/* ApiCallable.c generated by valac 0.34.9, the Vala compiler
 * generated from ApiCallable.vala, do not modify */

/*
 * Copyright 2016 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define DRT_TYPE_API_CALLABLE (drt_api_callable_get_type ())
#define DRT_API_CALLABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_API_CALLABLE, DrtApiCallable))
#define DRT_API_CALLABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_API_CALLABLE, DrtApiCallableClass))
#define DRT_IS_API_CALLABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_API_CALLABLE))
#define DRT_IS_API_CALLABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_API_CALLABLE))
#define DRT_API_CALLABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_API_CALLABLE, DrtApiCallableClass))

typedef struct _DrtApiCallable DrtApiCallable;
typedef struct _DrtApiCallableClass DrtApiCallableClass;
typedef struct _DrtApiCallablePrivate DrtApiCallablePrivate;

#define DRT_TYPE_API_FLAGS (drt_api_flags_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _DrtParamSpecApiCallable DrtParamSpecApiCallable;

struct _DrtApiCallable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DrtApiCallablePrivate * priv;
};

struct _DrtApiCallableClass {
	GTypeClass parent_class;
	void (*finalize) (DrtApiCallable *self);
	void (*run_with_args_tuple) (DrtApiCallable* self, GObject* conn, GVariant* data, GVariant** response, GError** error);
	void (*run_with_args_dict) (DrtApiCallable* self, GObject* conn, GVariant* data, GVariant** response, GError** error);
};

typedef enum  {
	DRT_API_FLAGS_PRIVATE = 1 << 0,
	DRT_API_FLAGS_READABLE = 1 << 1,
	DRT_API_FLAGS_WRITABLE = 1 << 2,
	DRT_API_FLAGS_SUBSCRIBE = 1 << 3
} DrtApiFlags;

struct _DrtApiCallablePrivate {
	gchar* _path;
	DrtApiFlags _flags;
	gchar* _description;
};

struct _DrtParamSpecApiCallable {
	GParamSpec parent_instance;
};


static gpointer drt_api_callable_parent_class = NULL;

gpointer drt_api_callable_ref (gpointer instance);
void drt_api_callable_unref (gpointer instance);
GParamSpec* drt_param_spec_api_callable (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void drt_value_set_api_callable (GValue* value, gpointer v_object);
void drt_value_take_api_callable (GValue* value, gpointer v_object);
gpointer drt_value_get_api_callable (const GValue* value);
GType drt_api_callable_get_type (void) G_GNUC_CONST;
GType drt_api_flags_get_type (void) G_GNUC_CONST;
#define DRT_API_CALLABLE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRT_TYPE_API_CALLABLE, DrtApiCallablePrivate))
enum  {
	DRT_API_CALLABLE_DUMMY_PROPERTY
};
void drt_api_callable_run_with_args_tuple (DrtApiCallable* self, GObject* conn, GVariant* data, GVariant** response, GError** error);
static void drt_api_callable_real_run_with_args_tuple (DrtApiCallable* self, GObject* conn, GVariant* data, GVariant** response, GError** error);
void drt_api_callable_run_with_args_dict (DrtApiCallable* self, GObject* conn, GVariant* data, GVariant** response, GError** error);
static void drt_api_callable_real_run_with_args_dict (DrtApiCallable* self, GObject* conn, GVariant* data, GVariant** response, GError** error);
DrtApiCallable* drt_api_callable_construct (GType object_type);
const gchar* drt_api_callable_get_path (DrtApiCallable* self);
void drt_api_callable_set_path (DrtApiCallable* self, const gchar* value);
DrtApiFlags drt_api_callable_get_flags (DrtApiCallable* self);
void drt_api_callable_set_flags (DrtApiCallable* self, DrtApiFlags value);
const gchar* drt_api_callable_get_description (DrtApiCallable* self);
void drt_api_callable_set_description (DrtApiCallable* self, const gchar* value);
static void drt_api_callable_finalize (DrtApiCallable* obj);


static void drt_api_callable_real_run_with_args_tuple (DrtApiCallable* self, GObject* conn, GVariant* data, GVariant** response, GError** error) {
	g_critical ("Type `%s' does not implement abstract method `drt_api_callable_run_with_args_tuple'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void drt_api_callable_run_with_args_tuple (DrtApiCallable* self, GObject* conn, GVariant* data, GVariant** response, GError** error) {
	g_return_if_fail (self != NULL);
	DRT_API_CALLABLE_GET_CLASS (self)->run_with_args_tuple (self, conn, data, response, error);
}


static void drt_api_callable_real_run_with_args_dict (DrtApiCallable* self, GObject* conn, GVariant* data, GVariant** response, GError** error) {
	g_critical ("Type `%s' does not implement abstract method `drt_api_callable_run_with_args_dict'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void drt_api_callable_run_with_args_dict (DrtApiCallable* self, GObject* conn, GVariant* data, GVariant** response, GError** error) {
	g_return_if_fail (self != NULL);
	DRT_API_CALLABLE_GET_CLASS (self)->run_with_args_dict (self, conn, data, response, error);
}


DrtApiCallable* drt_api_callable_construct (GType object_type) {
	DrtApiCallable* self = NULL;
	self = (DrtApiCallable*) g_type_create_instance (object_type);
	return self;
}


const gchar* drt_api_callable_get_path (DrtApiCallable* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_path;
	result = _tmp0_;
	return result;
}


void drt_api_callable_set_path (DrtApiCallable* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_path);
	self->priv->_path = _tmp1_;
}


DrtApiFlags drt_api_callable_get_flags (DrtApiCallable* self) {
	DrtApiFlags result;
	DrtApiFlags _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_flags;
	result = _tmp0_;
	return result;
}


void drt_api_callable_set_flags (DrtApiCallable* self, DrtApiFlags value) {
	DrtApiFlags _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_flags = _tmp0_;
}


const gchar* drt_api_callable_get_description (DrtApiCallable* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_description;
	result = _tmp0_;
	return result;
}


void drt_api_callable_set_description (DrtApiCallable* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_description);
	self->priv->_description = _tmp1_;
}


static void drt_value_api_callable_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void drt_value_api_callable_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		drt_api_callable_unref (value->data[0].v_pointer);
	}
}


static void drt_value_api_callable_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = drt_api_callable_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer drt_value_api_callable_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* drt_value_api_callable_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DrtApiCallable* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = drt_api_callable_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* drt_value_api_callable_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DrtApiCallable** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = drt_api_callable_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* drt_param_spec_api_callable (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DrtParamSpecApiCallable* spec;
	g_return_val_if_fail (g_type_is_a (object_type, DRT_TYPE_API_CALLABLE), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer drt_value_get_api_callable (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_API_CALLABLE), NULL);
	return value->data[0].v_pointer;
}


void drt_value_set_api_callable (GValue* value, gpointer v_object) {
	DrtApiCallable* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_API_CALLABLE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DRT_TYPE_API_CALLABLE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		drt_api_callable_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		drt_api_callable_unref (old);
	}
}


void drt_value_take_api_callable (GValue* value, gpointer v_object) {
	DrtApiCallable* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_API_CALLABLE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DRT_TYPE_API_CALLABLE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		drt_api_callable_unref (old);
	}
}


static void drt_api_callable_class_init (DrtApiCallableClass * klass) {
	drt_api_callable_parent_class = g_type_class_peek_parent (klass);
	((DrtApiCallableClass *) klass)->finalize = drt_api_callable_finalize;
	g_type_class_add_private (klass, sizeof (DrtApiCallablePrivate));
	((DrtApiCallableClass *) klass)->run_with_args_tuple = (void (*)(DrtApiCallable*, GObject*, GVariant*, GVariant**, GError**)) drt_api_callable_real_run_with_args_tuple;
	((DrtApiCallableClass *) klass)->run_with_args_dict = (void (*)(DrtApiCallable*, GObject*, GVariant*, GVariant**, GError**)) drt_api_callable_real_run_with_args_dict;
}


static void drt_api_callable_instance_init (DrtApiCallable * self) {
	self->priv = DRT_API_CALLABLE_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void drt_api_callable_finalize (DrtApiCallable* obj) {
	DrtApiCallable * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_API_CALLABLE, DrtApiCallable);
	g_signal_handlers_destroy (self);
	_g_free0 (self->priv->_path);
	_g_free0 (self->priv->_description);
}


GType drt_api_callable_get_type (void) {
	static volatile gsize drt_api_callable_type_id__volatile = 0;
	if (g_once_init_enter (&drt_api_callable_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { drt_value_api_callable_init, drt_value_api_callable_free_value, drt_value_api_callable_copy_value, drt_value_api_callable_peek_pointer, "p", drt_value_api_callable_collect_value, "p", drt_value_api_callable_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DrtApiCallableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_api_callable_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtApiCallable), 0, (GInstanceInitFunc) drt_api_callable_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType drt_api_callable_type_id;
		drt_api_callable_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DrtApiCallable", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&drt_api_callable_type_id__volatile, drt_api_callable_type_id);
	}
	return drt_api_callable_type_id__volatile;
}


gpointer drt_api_callable_ref (gpointer instance) {
	DrtApiCallable* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void drt_api_callable_unref (gpointer instance) {
	DrtApiCallable* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DRT_API_CALLABLE_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



