/* BaseChannel.c generated by valac 0.34.9, the Vala compiler
 * generated from BaseChannel.vala, do not modify */

/*
 * Copyright 2016 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define DRT_TYPE_BASE_CHANNEL (drt_base_channel_get_type ())
#define DRT_BASE_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_BASE_CHANNEL, DrtBaseChannel))
#define DRT_BASE_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_BASE_CHANNEL, DrtBaseChannelClass))
#define DRT_IS_BASE_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_BASE_CHANNEL))
#define DRT_IS_BASE_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_BASE_CHANNEL))
#define DRT_BASE_CHANNEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_BASE_CHANNEL, DrtBaseChannelClass))

typedef struct _DrtBaseChannel DrtBaseChannel;
typedef struct _DrtBaseChannelClass DrtBaseChannelClass;
typedef struct _DrtBaseChannelPrivate DrtBaseChannelPrivate;

#define DRT_TYPE_DUPLEX_CHANNEL (drt_duplex_channel_get_type ())
#define DRT_DUPLEX_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_DUPLEX_CHANNEL, DrtDuplexChannel))
#define DRT_DUPLEX_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_DUPLEX_CHANNEL, DrtDuplexChannelClass))
#define DRT_IS_DUPLEX_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_DUPLEX_CHANNEL))
#define DRT_IS_DUPLEX_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_DUPLEX_CHANNEL))
#define DRT_DUPLEX_CHANNEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_DUPLEX_CHANNEL, DrtDuplexChannelClass))

typedef struct _DrtDuplexChannel DrtDuplexChannel;
typedef struct _DrtDuplexChannelClass DrtDuplexChannelClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _DrtBaseChannel {
	GObject parent_instance;
	DrtBaseChannelPrivate * priv;
};

struct _DrtBaseChannelClass {
	GObjectClass parent_class;
};

struct _DrtBaseChannelPrivate {
	guint _id;
	DrtDuplexChannel* _channel;
	gboolean _pending;
	gboolean _closed;
};


static gpointer drt_base_channel_parent_class = NULL;

GType drt_base_channel_get_type (void) G_GNUC_CONST;
GType drt_duplex_channel_get_type (void) G_GNUC_CONST;
#define DRT_BASE_CHANNEL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRT_TYPE_BASE_CHANNEL, DrtBaseChannelPrivate))
enum  {
	DRT_BASE_CHANNEL_DUMMY_PROPERTY,
	DRT_BASE_CHANNEL_ID,
	DRT_BASE_CHANNEL_CHANNEL,
	DRT_BASE_CHANNEL_PENDING,
	DRT_BASE_CHANNEL_CLOSED,
	DRT_BASE_CHANNEL_NAME
};
DrtBaseChannel* drt_base_channel_construct (GType object_type);
guint drt_base_channel_get_id (DrtBaseChannel* self);
static void drt_base_channel_set_id (DrtBaseChannel* self, guint value);
DrtDuplexChannel* drt_base_channel_get_channel (DrtBaseChannel* self);
static void drt_base_channel_set_channel (DrtBaseChannel* self, DrtDuplexChannel* value);
gboolean drt_base_channel_get_pending (DrtBaseChannel* self);
void drt_base_channel_set_pending (DrtBaseChannel* self, gboolean value);
gboolean drt_base_channel_get_closed (DrtBaseChannel* self);
void drt_base_channel_set_closed (DrtBaseChannel* self, gboolean value);
const gchar* drt_base_channel_get_name (DrtBaseChannel* self);
const gchar* drt_duplex_channel_get_name (DrtDuplexChannel* self);
static void drt_base_channel_finalize (GObject* obj);
static void _vala_drt_base_channel_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_drt_base_channel_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


DrtBaseChannel* drt_base_channel_construct (GType object_type) {
	DrtBaseChannel * self = NULL;
	self = (DrtBaseChannel*) g_object_new (object_type, NULL);
	return self;
}


guint drt_base_channel_get_id (DrtBaseChannel* self) {
	guint result;
	guint _tmp0_ = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_id;
	result = _tmp0_;
	return result;
}


static void drt_base_channel_set_id (DrtBaseChannel* self, guint value) {
	guint _tmp0_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_id = _tmp0_;
	g_object_notify ((GObject *) self, "id");
}


DrtDuplexChannel* drt_base_channel_get_channel (DrtBaseChannel* self) {
	DrtDuplexChannel* result;
	DrtDuplexChannel* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_channel;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void drt_base_channel_set_channel (DrtBaseChannel* self, DrtDuplexChannel* value) {
	DrtDuplexChannel* _tmp0_ = NULL;
	DrtDuplexChannel* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_channel);
	self->priv->_channel = _tmp1_;
	g_object_notify ((GObject *) self, "channel");
}


gboolean drt_base_channel_get_pending (DrtBaseChannel* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_pending;
	result = _tmp0_;
	return result;
}


void drt_base_channel_set_pending (DrtBaseChannel* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_pending = _tmp0_;
	g_object_notify ((GObject *) self, "pending");
}


gboolean drt_base_channel_get_closed (DrtBaseChannel* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_closed;
	result = _tmp0_;
	return result;
}


void drt_base_channel_set_closed (DrtBaseChannel* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_closed = _tmp0_;
	g_object_notify ((GObject *) self, "closed");
}


const gchar* drt_base_channel_get_name (DrtBaseChannel* self) {
	const gchar* result;
	DrtDuplexChannel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_channel;
	_tmp1_ = drt_duplex_channel_get_name (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


static void drt_base_channel_class_init (DrtBaseChannelClass * klass) {
	drt_base_channel_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DrtBaseChannelPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_drt_base_channel_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_drt_base_channel_set_property;
	G_OBJECT_CLASS (klass)->finalize = drt_base_channel_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_BASE_CHANNEL_ID, g_param_spec_uint ("id", "id", "id", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_BASE_CHANNEL_CHANNEL, g_param_spec_object ("channel", "channel", "channel", DRT_TYPE_DUPLEX_CHANNEL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_BASE_CHANNEL_PENDING, g_param_spec_boolean ("pending", "pending", "pending", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_BASE_CHANNEL_CLOSED, g_param_spec_boolean ("closed", "closed", "closed", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_BASE_CHANNEL_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void drt_base_channel_instance_init (DrtBaseChannel * self) {
	self->priv = DRT_BASE_CHANNEL_GET_PRIVATE (self);
	self->priv->_pending = FALSE;
	self->priv->_closed = FALSE;
}


static void drt_base_channel_finalize (GObject* obj) {
	DrtBaseChannel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_BASE_CHANNEL, DrtBaseChannel);
	_g_object_unref0 (self->priv->_channel);
	G_OBJECT_CLASS (drt_base_channel_parent_class)->finalize (obj);
}


GType drt_base_channel_get_type (void) {
	static volatile gsize drt_base_channel_type_id__volatile = 0;
	if (g_once_init_enter (&drt_base_channel_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DrtBaseChannelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_base_channel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtBaseChannel), 0, (GInstanceInitFunc) drt_base_channel_instance_init, NULL };
		GType drt_base_channel_type_id;
		drt_base_channel_type_id = g_type_register_static (G_TYPE_OBJECT, "DrtBaseChannel", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&drt_base_channel_type_id__volatile, drt_base_channel_type_id);
	}
	return drt_base_channel_type_id__volatile;
}


static void _vala_drt_base_channel_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DrtBaseChannel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRT_TYPE_BASE_CHANNEL, DrtBaseChannel);
	switch (property_id) {
		case DRT_BASE_CHANNEL_ID:
		g_value_set_uint (value, drt_base_channel_get_id (self));
		break;
		case DRT_BASE_CHANNEL_CHANNEL:
		g_value_set_object (value, drt_base_channel_get_channel (self));
		break;
		case DRT_BASE_CHANNEL_PENDING:
		g_value_set_boolean (value, drt_base_channel_get_pending (self));
		break;
		case DRT_BASE_CHANNEL_CLOSED:
		g_value_set_boolean (value, drt_base_channel_get_closed (self));
		break;
		case DRT_BASE_CHANNEL_NAME:
		g_value_set_string (value, drt_base_channel_get_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_drt_base_channel_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DrtBaseChannel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRT_TYPE_BASE_CHANNEL, DrtBaseChannel);
	switch (property_id) {
		case DRT_BASE_CHANNEL_ID:
		drt_base_channel_set_id (self, g_value_get_uint (value));
		break;
		case DRT_BASE_CHANNEL_CHANNEL:
		drt_base_channel_set_channel (self, g_value_get_object (value));
		break;
		case DRT_BASE_CHANNEL_PENDING:
		drt_base_channel_set_pending (self, g_value_get_boolean (value));
		break;
		case DRT_BASE_CHANNEL_CLOSED:
		drt_base_channel_set_closed (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



