/* BluetoothConnection.c generated by valac 0.34.9, the Vala compiler
 * generated from BluetoothConnection.vala, do not modify */

/*
 * Copyright 2016 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gfiledescriptorbased.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gio/gunixoutputstream.h>
#include <gio/gunixinputstream.h>


#define DRT_TYPE_BLUETOOTH_CONNECTION (drt_bluetooth_connection_get_type ())
#define DRT_BLUETOOTH_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_BLUETOOTH_CONNECTION, DrtBluetoothConnection))
#define DRT_BLUETOOTH_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_BLUETOOTH_CONNECTION, DrtBluetoothConnectionClass))
#define DRT_IS_BLUETOOTH_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_BLUETOOTH_CONNECTION))
#define DRT_IS_BLUETOOTH_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_BLUETOOTH_CONNECTION))
#define DRT_BLUETOOTH_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_BLUETOOTH_CONNECTION, DrtBluetoothConnectionClass))

typedef struct _DrtBluetoothConnection DrtBluetoothConnection;
typedef struct _DrtBluetoothConnectionClass DrtBluetoothConnectionClass;
typedef struct _DrtBluetoothConnectionPrivate DrtBluetoothConnectionPrivate;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _DrtBluetoothConnection {
	GObject parent_instance;
	DrtBluetoothConnectionPrivate * priv;
};

struct _DrtBluetoothConnectionClass {
	GObjectClass parent_class;
};

struct _DrtBluetoothConnectionPrivate {
	gchar* _device;
	gint _fd;
	GOutputStream* _output;
	GInputStream* _input;
	GSocket* socket;
};


static gpointer drt_bluetooth_connection_parent_class = NULL;
static GFileDescriptorBasedIface* drt_bluetooth_connection_g_file_descriptor_based_parent_iface = NULL;

GType drt_bluetooth_connection_get_type (void) G_GNUC_CONST;
#define DRT_BLUETOOTH_CONNECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRT_TYPE_BLUETOOTH_CONNECTION, DrtBluetoothConnectionPrivate))
enum  {
	DRT_BLUETOOTH_CONNECTION_DUMMY_PROPERTY,
	DRT_BLUETOOTH_CONNECTION_DEVICE,
	DRT_BLUETOOTH_CONNECTION_FD,
	DRT_BLUETOOTH_CONNECTION_OUTPUT,
	DRT_BLUETOOTH_CONNECTION_INPUT
};
void drt_bluetooth_connection_close (DrtBluetoothConnection* self, GError** error);
DrtBluetoothConnection* drt_bluetooth_connection_new (GSocket* socket, const gchar* device);
DrtBluetoothConnection* drt_bluetooth_connection_construct (GType object_type, GSocket* socket, const gchar* device);
static void drt_bluetooth_connection_set_device (DrtBluetoothConnection* self, const gchar* value);
static void drt_bluetooth_connection_set_fd (DrtBluetoothConnection* self, gint value);
gint drt_bluetooth_connection_get_fd (DrtBluetoothConnection* self);
static void drt_bluetooth_connection_set_output (DrtBluetoothConnection* self, GOutputStream* value);
static void drt_bluetooth_connection_set_input (DrtBluetoothConnection* self, GInputStream* value);
DrtBluetoothConnection* drt_bluetooth_connection_new_from_fd (gint fd, const gchar* device, GError** error);
DrtBluetoothConnection* drt_bluetooth_connection_construct_from_fd (GType object_type, gint fd, const gchar* device, GError** error);
static gint drt_bluetooth_connection_real_get_fd (GFileDescriptorBased* base);
const gchar* drt_bluetooth_connection_get_device (DrtBluetoothConnection* self);
GOutputStream* drt_bluetooth_connection_get_output (DrtBluetoothConnection* self);
GInputStream* drt_bluetooth_connection_get_input (DrtBluetoothConnection* self);
static void drt_bluetooth_connection_finalize (GObject* obj);
static void _vala_drt_bluetooth_connection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_drt_bluetooth_connection_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


DrtBluetoothConnection* drt_bluetooth_connection_construct (GType object_type, GSocket* socket, const gchar* device) {
	DrtBluetoothConnection * self = NULL;
	const gchar* _tmp0_ = NULL;
	GSocket* _tmp1_ = NULL;
	GSocket* _tmp2_ = NULL;
	GSocket* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	GUnixOutputStream* _tmp7_ = NULL;
	GUnixOutputStream* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	GUnixInputStream* _tmp10_ = NULL;
	GUnixInputStream* _tmp11_ = NULL;
	g_return_val_if_fail (socket != NULL, NULL);
	g_return_val_if_fail (device != NULL, NULL);
	self = (DrtBluetoothConnection*) g_object_new (object_type, NULL);
	_tmp0_ = device;
	drt_bluetooth_connection_set_device (self, _tmp0_);
	_tmp1_ = socket;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	_g_object_unref0 (self->priv->socket);
	self->priv->socket = _tmp2_;
	_tmp3_ = socket;
	_tmp4_ = g_socket_get_fd (_tmp3_);
	_tmp5_ = _tmp4_;
	drt_bluetooth_connection_set_fd (self, _tmp5_);
	_tmp6_ = self->priv->_fd;
	_tmp7_ = (GUnixOutputStream*) g_unix_output_stream_new (_tmp6_, TRUE);
	_tmp8_ = _tmp7_;
	drt_bluetooth_connection_set_output (self, (GOutputStream*) _tmp8_);
	_g_object_unref0 (_tmp8_);
	_tmp9_ = self->priv->_fd;
	_tmp10_ = (GUnixInputStream*) g_unix_input_stream_new (_tmp9_, TRUE);
	_tmp11_ = _tmp10_;
	drt_bluetooth_connection_set_input (self, (GInputStream*) _tmp11_);
	_g_object_unref0 (_tmp11_);
	return self;
}


DrtBluetoothConnection* drt_bluetooth_connection_new (GSocket* socket, const gchar* device) {
	return drt_bluetooth_connection_construct (DRT_TYPE_BLUETOOTH_CONNECTION, socket, device);
}


DrtBluetoothConnection* drt_bluetooth_connection_construct_from_fd (GType object_type, gint fd, const gchar* device, GError** error) {
	DrtBluetoothConnection * self = NULL;
	GSocket* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	GSocket* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (device != NULL, NULL);
	_tmp1_ = fd;
	_tmp2_ = g_socket_new_from_fd (_tmp1_, &_inner_error_);
	_tmp0_ = _tmp2_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (self);
		return NULL;
	}
	_tmp3_ = device;
	self = (DrtBluetoothConnection*) drt_bluetooth_connection_construct (object_type, _tmp0_, _tmp3_);
	_g_object_unref0 (_tmp0_);
	return self;
}


DrtBluetoothConnection* drt_bluetooth_connection_new_from_fd (gint fd, const gchar* device, GError** error) {
	return drt_bluetooth_connection_construct_from_fd (DRT_TYPE_BLUETOOTH_CONNECTION, fd, device, error);
}


static gint drt_bluetooth_connection_real_get_fd (GFileDescriptorBased* base) {
	DrtBluetoothConnection * self;
	gint result = 0;
	gint _tmp0_ = 0;
	self = (DrtBluetoothConnection*) base;
	_tmp0_ = self->priv->_fd;
	result = _tmp0_;
	return result;
}


static gpointer _g_error_copy0 (gpointer self) {
	return self ? g_error_copy (self) : NULL;
}


void drt_bluetooth_connection_close (DrtBluetoothConnection* self, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		GSocket* _tmp0_ = NULL;
		gboolean _tmp1_ = FALSE;
		_tmp0_ = self->priv->socket;
		_tmp1_ = g_socket_is_closed (_tmp0_);
		if (!_tmp1_) {
			GSocket* _tmp2_ = NULL;
			_tmp2_ = self->priv->socket;
			g_socket_close (_tmp2_, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch5_g_error;
			}
		}
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_ = NULL;
		GError* _tmp4_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _g_error_copy0 ((GError*) _tmp3_);
		_inner_error_ = _tmp4_;
		_g_error_free0 (e);
		goto __finally5;
	}
	__finally5:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


const gchar* drt_bluetooth_connection_get_device (DrtBluetoothConnection* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_device;
	result = _tmp0_;
	return result;
}


static void drt_bluetooth_connection_set_device (DrtBluetoothConnection* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_device);
	self->priv->_device = _tmp1_;
	g_object_notify ((GObject *) self, "device");
}


gint drt_bluetooth_connection_get_fd (DrtBluetoothConnection* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_fd;
	result = _tmp0_;
	return result;
}


static void drt_bluetooth_connection_set_fd (DrtBluetoothConnection* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_fd = _tmp0_;
	g_object_notify ((GObject *) self, "fd");
}


GOutputStream* drt_bluetooth_connection_get_output (DrtBluetoothConnection* self) {
	GOutputStream* result;
	GOutputStream* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_output;
	result = _tmp0_;
	return result;
}


static void drt_bluetooth_connection_set_output (DrtBluetoothConnection* self, GOutputStream* value) {
	GOutputStream* _tmp0_ = NULL;
	GOutputStream* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_output);
	self->priv->_output = _tmp1_;
	g_object_notify ((GObject *) self, "output");
}


GInputStream* drt_bluetooth_connection_get_input (DrtBluetoothConnection* self) {
	GInputStream* result;
	GInputStream* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_input;
	result = _tmp0_;
	return result;
}


static void drt_bluetooth_connection_set_input (DrtBluetoothConnection* self, GInputStream* value) {
	GInputStream* _tmp0_ = NULL;
	GInputStream* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_input);
	self->priv->_input = _tmp1_;
	g_object_notify ((GObject *) self, "input");
}


static void drt_bluetooth_connection_class_init (DrtBluetoothConnectionClass * klass) {
	drt_bluetooth_connection_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DrtBluetoothConnectionPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_drt_bluetooth_connection_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_drt_bluetooth_connection_set_property;
	G_OBJECT_CLASS (klass)->finalize = drt_bluetooth_connection_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_BLUETOOTH_CONNECTION_DEVICE, g_param_spec_string ("device", "device", "device", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_BLUETOOTH_CONNECTION_FD, g_param_spec_int ("fd", "fd", "fd", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_BLUETOOTH_CONNECTION_OUTPUT, g_param_spec_object ("output", "output", "output", g_output_stream_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_BLUETOOTH_CONNECTION_INPUT, g_param_spec_object ("input", "input", "input", g_input_stream_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void drt_bluetooth_connection_g_file_descriptor_based_interface_init (GFileDescriptorBasedIface * iface) {
	drt_bluetooth_connection_g_file_descriptor_based_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_fd = (gint (*)(GFileDescriptorBased*)) drt_bluetooth_connection_real_get_fd;
}


static void drt_bluetooth_connection_instance_init (DrtBluetoothConnection * self) {
	self->priv = DRT_BLUETOOTH_CONNECTION_GET_PRIVATE (self);
}


static void drt_bluetooth_connection_finalize (GObject* obj) {
	DrtBluetoothConnection * self;
	GError * _inner_error_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_BLUETOOTH_CONNECTION, DrtBluetoothConnection);
	{
		drt_bluetooth_connection_close (self, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch4_g_error;
		}
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_g_error_free0 (e);
	}
	__finally4:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	_g_free0 (self->priv->_device);
	_g_object_unref0 (self->priv->_output);
	_g_object_unref0 (self->priv->_input);
	_g_object_unref0 (self->priv->socket);
	G_OBJECT_CLASS (drt_bluetooth_connection_parent_class)->finalize (obj);
}


GType drt_bluetooth_connection_get_type (void) {
	static volatile gsize drt_bluetooth_connection_type_id__volatile = 0;
	if (g_once_init_enter (&drt_bluetooth_connection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DrtBluetoothConnectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_bluetooth_connection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtBluetoothConnection), 0, (GInstanceInitFunc) drt_bluetooth_connection_instance_init, NULL };
		static const GInterfaceInfo g_file_descriptor_based_info = { (GInterfaceInitFunc) drt_bluetooth_connection_g_file_descriptor_based_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType drt_bluetooth_connection_type_id;
		drt_bluetooth_connection_type_id = g_type_register_static (G_TYPE_OBJECT, "DrtBluetoothConnection", &g_define_type_info, 0);
		g_type_add_interface_static (drt_bluetooth_connection_type_id, G_TYPE_FILE_DESCRIPTOR_BASED, &g_file_descriptor_based_info);
		g_once_init_leave (&drt_bluetooth_connection_type_id__volatile, drt_bluetooth_connection_type_id);
	}
	return drt_bluetooth_connection_type_id__volatile;
}


static void _vala_drt_bluetooth_connection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DrtBluetoothConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRT_TYPE_BLUETOOTH_CONNECTION, DrtBluetoothConnection);
	switch (property_id) {
		case DRT_BLUETOOTH_CONNECTION_DEVICE:
		g_value_set_string (value, drt_bluetooth_connection_get_device (self));
		break;
		case DRT_BLUETOOTH_CONNECTION_FD:
		g_value_set_int (value, drt_bluetooth_connection_get_fd (self));
		break;
		case DRT_BLUETOOTH_CONNECTION_OUTPUT:
		g_value_set_object (value, drt_bluetooth_connection_get_output (self));
		break;
		case DRT_BLUETOOTH_CONNECTION_INPUT:
		g_value_set_object (value, drt_bluetooth_connection_get_input (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_drt_bluetooth_connection_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DrtBluetoothConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRT_TYPE_BLUETOOTH_CONNECTION, DrtBluetoothConnection);
	switch (property_id) {
		case DRT_BLUETOOTH_CONNECTION_DEVICE:
		drt_bluetooth_connection_set_device (self, g_value_get_string (value));
		break;
		case DRT_BLUETOOTH_CONNECTION_FD:
		drt_bluetooth_connection_set_fd (self, g_value_get_int (value));
		break;
		case DRT_BLUETOOTH_CONNECTION_OUTPUT:
		drt_bluetooth_connection_set_output (self, g_value_get_object (value));
		break;
		case DRT_BLUETOOTH_CONNECTION_INPUT:
		drt_bluetooth_connection_set_input (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



