/* EventLoop.c generated by valac 0.34.9, the Vala compiler
 * generated from EventLoop.vala, do not modify */

/*
 * Copyright 2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>

typedef struct _DrtEventLoopResumeLaterData DrtEventLoopResumeLaterData;
#define _g_source_unref0(var) ((var == NULL) ? NULL : (var = (g_source_unref (var), NULL)))
#define _g_main_context_unref0(var) ((var == NULL) ? NULL : (var = (g_main_context_unref (var), NULL)))

struct _DrtEventLoopResumeLaterData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
};



static void drt_event_loop_resume_later_data_free (gpointer _data);
void drt_event_loop_resume_later (GAsyncReadyCallback _callback_, gpointer _user_data_);
void drt_event_loop_resume_later_finish (GAsyncResult* _res_);
static gboolean drt_event_loop_resume_later_co (DrtEventLoopResumeLaterData* _data_);
guint drt_event_loop_add_idle (GSourceFunc function, void* function_target, GDestroyNotify function_target_destroy_notify, gint priority);
static gboolean _drt_event_loop_resume_later_co_gsource_func (gpointer self);
guint drt_event_loop_add_timeout_ms (guint interval_ms, GSourceFunc function, void* function_target, GDestroyNotify function_target_destroy_notify, gint priority);
guint drt_event_loop_add_timeout_sec (guint interval_s, GSourceFunc function, void* function_target, GDestroyNotify function_target_destroy_notify, gint priority);


static void drt_event_loop_resume_later_data_free (gpointer _data) {
	DrtEventLoopResumeLaterData* _data_;
	_data_ = _data;
	g_slice_free (DrtEventLoopResumeLaterData, _data_);
}


void drt_event_loop_resume_later (GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DrtEventLoopResumeLaterData* _data_;
	_data_ = g_slice_new0 (DrtEventLoopResumeLaterData);
	_data_->_async_result = g_simple_async_result_new (NULL, _callback_, _user_data_, drt_event_loop_resume_later);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, drt_event_loop_resume_later_data_free);
	drt_event_loop_resume_later_co (_data_);
}


void drt_event_loop_resume_later_finish (GAsyncResult* _res_) {
	DrtEventLoopResumeLaterData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


/**
 * Pause async method and resume it later.
 */
static gboolean _drt_event_loop_resume_later_co_gsource_func (gpointer self) {
	gboolean result;
	result = drt_event_loop_resume_later_co (self);
	return result;
}


static gboolean drt_event_loop_resume_later_co (DrtEventLoopResumeLaterData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	drt_event_loop_add_idle (_drt_event_loop_resume_later_co_gsource_func, _data_, NULL, G_PRIORITY_DEFAULT_IDLE);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


/**
 * Attach an idle callback to the thread-default {@link GLib.MainContext}.
 * 
 * Similar to {@link GLib.Idle.add} but uses the thread-default {@link GLib.MainContext} instead of the global
 * {@link GLib.MainContext}.
 * 
 * @param function    The idle callback function.
 * @param priority    The priority of the callback.
 * @return Id of the corresponding event source.
 */
guint drt_event_loop_add_idle (GSourceFunc function, void* function_target, GDestroyNotify function_target_destroy_notify, gint priority) {
	guint result = 0U;
	GMainContext* context = NULL;
	GMainContext* _tmp0_ = NULL;
	GSource* source = NULL;
	GSource* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	GSourceFunc _tmp3_ = NULL;
	void* _tmp3__target = NULL;
	GDestroyNotify _tmp3__target_destroy_notify = NULL;
	guint _tmp4_ = 0U;
	_tmp0_ = g_main_context_ref_thread_default ();
	context = _tmp0_;
	_tmp1_ = g_idle_source_new ();
	source = _tmp1_;
	_tmp2_ = priority;
	g_source_set_priority (source, _tmp2_);
	_tmp3_ = function;
	_tmp3__target = function_target;
	_tmp3__target_destroy_notify = function_target_destroy_notify;
	function = NULL;
	function_target = NULL;
	function_target_destroy_notify = NULL;
	g_source_set_callback (source, _tmp3_, _tmp3__target, _tmp3__target_destroy_notify);
	_tmp4_ = g_source_attach (source, context);
	result = _tmp4_;
	_g_source_unref0 (source);
	_g_main_context_unref0 (context);
	(function_target_destroy_notify == NULL) ? NULL : (function_target_destroy_notify (function_target), NULL);
	function = NULL;
	function_target = NULL;
	function_target_destroy_notify = NULL;
	return result;
}


/**
 * Attach a timeout callback to the thread-default {@link GLib.MainContext}.
 * 
 * Similar to {@link GLib.Timeout.add} but uses the thread-default {@link GLib.MainContext} instead of the global
 * {@link GLib.MainContext}.
 * 
 * @param interval_ms    The number of miliseconds to wait before the callback is called.
 * @param function       The callback function.
 * @param priority       The priority of the callback.
 * @return Id of the corresponding event source.
 */
guint drt_event_loop_add_timeout_ms (guint interval_ms, GSourceFunc function, void* function_target, GDestroyNotify function_target_destroy_notify, gint priority) {
	guint result = 0U;
	GMainContext* context = NULL;
	GMainContext* _tmp0_ = NULL;
	GSource* source = NULL;
	guint _tmp1_ = 0U;
	GSource* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	GSourceFunc _tmp4_ = NULL;
	void* _tmp4__target = NULL;
	GDestroyNotify _tmp4__target_destroy_notify = NULL;
	guint _tmp5_ = 0U;
	_tmp0_ = g_main_context_ref_thread_default ();
	context = _tmp0_;
	_tmp1_ = interval_ms;
	_tmp2_ = g_timeout_source_new (_tmp1_);
	source = _tmp2_;
	_tmp3_ = priority;
	g_source_set_priority (source, _tmp3_);
	_tmp4_ = function;
	_tmp4__target = function_target;
	_tmp4__target_destroy_notify = function_target_destroy_notify;
	function = NULL;
	function_target = NULL;
	function_target_destroy_notify = NULL;
	g_source_set_callback (source, _tmp4_, _tmp4__target, _tmp4__target_destroy_notify);
	_tmp5_ = g_source_attach (source, context);
	result = _tmp5_;
	_g_source_unref0 (source);
	_g_main_context_unref0 (context);
	(function_target_destroy_notify == NULL) ? NULL : (function_target_destroy_notify (function_target), NULL);
	function = NULL;
	function_target = NULL;
	function_target_destroy_notify = NULL;
	return result;
}


/**
 * Attach a timeout callback to the thread-default {@link GLib.MainContext}.
 * 
 * Similar to {@link GLib.Timeout.add_seconds} but uses the thread-default {@link GLib.MainContext} instead
 * of the global {@link GLib.MainContext}.
 * 
 * @param interval_s    The number of seconds to wait before the callback is called.
 * @param function      The callback function.
 * @param priority      The priority of the callback.
 * @return Id of the corresponding event source.
 */
guint drt_event_loop_add_timeout_sec (guint interval_s, GSourceFunc function, void* function_target, GDestroyNotify function_target_destroy_notify, gint priority) {
	guint result = 0U;
	guint _tmp0_ = 0U;
	GSourceFunc _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	GDestroyNotify _tmp1__target_destroy_notify = NULL;
	gint _tmp2_ = 0;
	guint _tmp3_ = 0U;
	_tmp0_ = interval_s;
	_tmp1_ = function;
	_tmp1__target = function_target;
	_tmp1__target_destroy_notify = function_target_destroy_notify;
	function = NULL;
	function_target = NULL;
	function_target_destroy_notify = NULL;
	_tmp2_ = priority;
	_tmp3_ = drt_event_loop_add_timeout_ms (_tmp0_ * 1000, _tmp1_, _tmp1__target, _tmp1__target_destroy_notify, _tmp2_);
	result = _tmp3_;
	(function_target_destroy_notify == NULL) ? NULL : (function_target_destroy_notify (function_target), NULL);
	function = NULL;
	function_target = NULL;
	function_target_destroy_notify = NULL;
	return result;
}



