/* MessageListener.c generated by valac 0.34.9, the Vala compiler
 * generated from MessageListener.vala, do not modify */

/*
 * Copyright 2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define DRT_TYPE_HANDLER_ADAPTOR (drt_handler_adaptor_get_type ())
#define DRT_HANDLER_ADAPTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_HANDLER_ADAPTOR, DrtHandlerAdaptor))
#define DRT_HANDLER_ADAPTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_HANDLER_ADAPTOR, DrtHandlerAdaptorClass))
#define DRT_IS_HANDLER_ADAPTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_HANDLER_ADAPTOR))
#define DRT_IS_HANDLER_ADAPTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_HANDLER_ADAPTOR))
#define DRT_HANDLER_ADAPTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_HANDLER_ADAPTOR, DrtHandlerAdaptorClass))

typedef struct _DrtHandlerAdaptor DrtHandlerAdaptor;
typedef struct _DrtHandlerAdaptorClass DrtHandlerAdaptorClass;
typedef struct _DrtHandlerAdaptorPrivate DrtHandlerAdaptorPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _DrtParamSpecHandlerAdaptor DrtParamSpecHandlerAdaptor;

typedef GVariant* (*DrtMessageHandler) (GObject* source, GVariant* params, void* user_data, GError** error);
typedef enum  {
	DRT_MESSAGE_ERROR_UNKNOWN,
	DRT_MESSAGE_ERROR_REMOTE_ERROR,
	DRT_MESSAGE_ERROR_UNSUPPORTED,
	DRT_MESSAGE_ERROR_IOERROR,
	DRT_MESSAGE_ERROR_INVALID_RESPONSE,
	DRT_MESSAGE_ERROR_INVALID_REQUEST,
	DRT_MESSAGE_ERROR_INVALID_ARGUMENTS,
	DRT_MESSAGE_ERROR_NOT_READY
} DrtMessageError;
#define DRT_MESSAGE_ERROR drt_message_error_quark ()
struct _DrtHandlerAdaptor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DrtHandlerAdaptorPrivate * priv;
};

struct _DrtHandlerAdaptorClass {
	GTypeClass parent_class;
	void (*finalize) (DrtHandlerAdaptor *self);
};

struct _DrtHandlerAdaptorPrivate {
	DrtMessageHandler handler;
	gpointer handler_target;
	GDestroyNotify handler_target_destroy_notify;
	gchar* type_string;
};

struct _DrtParamSpecHandlerAdaptor {
	GParamSpec parent_instance;
};


static gpointer drt_handler_adaptor_parent_class = NULL;

GQuark drt_message_error_quark (void);
#define DRT_TYPE_STRING_ANY "#ANY#"
GVariant* drt_message_listener_echo_handler (GObject* source, GVariant* request, GError** error);
void drt_message_listener_check_type_string (GVariant* data, const gchar* type_string, GError** error);
gpointer drt_handler_adaptor_ref (gpointer instance);
void drt_handler_adaptor_unref (gpointer instance);
GParamSpec* drt_param_spec_handler_adaptor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void drt_value_set_handler_adaptor (GValue* value, gpointer v_object);
void drt_value_take_handler_adaptor (GValue* value, gpointer v_object);
gpointer drt_value_get_handler_adaptor (const GValue* value);
GType drt_handler_adaptor_get_type (void) G_GNUC_CONST;
#define DRT_HANDLER_ADAPTOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRT_TYPE_HANDLER_ADAPTOR, DrtHandlerAdaptorPrivate))
enum  {
	DRT_HANDLER_ADAPTOR_DUMMY_PROPERTY
};
DrtHandlerAdaptor* drt_handler_adaptor_new (DrtMessageHandler handler, void* handler_target, GDestroyNotify handler_target_destroy_notify, const gchar* type_string);
DrtHandlerAdaptor* drt_handler_adaptor_construct (GType object_type, DrtMessageHandler handler, void* handler_target, GDestroyNotify handler_target_destroy_notify, const gchar* type_string);
void drt_handler_adaptor_handle (DrtHandlerAdaptor* self, GObject* source, GVariant* params, GVariant** response, GError** error);
static void drt_handler_adaptor_finalize (DrtHandlerAdaptor* obj);


GQuark drt_message_error_quark (void) {
	return g_quark_from_static_string ("drt_message_error-quark");
}


static gpointer _g_variant_ref0 (gpointer self) {
	return self ? g_variant_ref (self) : NULL;
}


GVariant* drt_message_listener_echo_handler (GObject* source, GVariant* request, GError** error) {
	GVariant* result = NULL;
	GVariant* _tmp0_ = NULL;
	GVariant* _tmp1_ = NULL;
	g_return_val_if_fail (source != NULL, NULL);
	_tmp0_ = request;
	_tmp1_ = _g_variant_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}


void drt_message_listener_check_type_string (GVariant* data, const gchar* type_string, GError** error) {
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp3_ = FALSE;
	GVariant* _tmp4_ = NULL;
	GVariant* _tmp8_ = NULL;
	GError * _inner_error_ = NULL;
	_tmp1_ = type_string;
	if (_tmp1_ != NULL) {
		const gchar* _tmp2_ = NULL;
		_tmp2_ = type_string;
		_tmp0_ = g_strcmp0 (_tmp2_, DRT_TYPE_STRING_ANY) == 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	_tmp4_ = data;
	if (_tmp4_ == NULL) {
		const gchar* _tmp5_ = NULL;
		_tmp5_ = type_string;
		_tmp3_ = _tmp5_ != NULL;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		const gchar* _tmp6_ = NULL;
		GError* _tmp7_ = NULL;
		_tmp6_ = type_string;
		_tmp7_ = g_error_new (DRT_MESSAGE_ERROR, DRT_MESSAGE_ERROR_INVALID_ARGUMENTS, "Invalid data type null, expected '%s'.", _tmp6_);
		_inner_error_ = _tmp7_;
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp8_ = data;
	if (_tmp8_ != NULL) {
		const gchar* data_type_string = NULL;
		GVariant* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
		GVariant* _tmp14_ = NULL;
		const gchar* _tmp15_ = NULL;
		gboolean _tmp16_ = FALSE;
		_tmp9_ = data;
		_tmp10_ = g_variant_get_type_string (_tmp9_);
		data_type_string = _tmp10_;
		_tmp11_ = type_string;
		if (_tmp11_ == NULL) {
			const gchar* _tmp12_ = NULL;
			GError* _tmp13_ = NULL;
			_tmp12_ = data_type_string;
			_tmp13_ = g_error_new (DRT_MESSAGE_ERROR, DRT_MESSAGE_ERROR_INVALID_ARGUMENTS, "Invalid data type '%s', expected null.", _tmp12_);
			_inner_error_ = _tmp13_;
			g_propagate_error (error, _inner_error_);
			return;
		}
		_tmp14_ = data;
		_tmp15_ = type_string;
		_tmp16_ = g_variant_check_format_string (_tmp14_, _tmp15_, FALSE);
		if (!_tmp16_) {
			const gchar* _tmp17_ = NULL;
			const gchar* _tmp18_ = NULL;
			GError* _tmp19_ = NULL;
			_tmp17_ = data_type_string;
			_tmp18_ = type_string;
			_tmp19_ = g_error_new (DRT_MESSAGE_ERROR, DRT_MESSAGE_ERROR_INVALID_ARGUMENTS, "Invalid data type '%s', expected '%s'.", _tmp17_, _tmp18_);
			_inner_error_ = _tmp19_;
			g_propagate_error (error, _inner_error_);
			return;
		}
	}
}


DrtHandlerAdaptor* drt_handler_adaptor_construct (GType object_type, DrtMessageHandler handler, void* handler_target, GDestroyNotify handler_target_destroy_notify, const gchar* type_string) {
	DrtHandlerAdaptor* self = NULL;
	DrtMessageHandler _tmp0_ = NULL;
	void* _tmp0__target = NULL;
	GDestroyNotify _tmp0__target_destroy_notify = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	self = (DrtHandlerAdaptor*) g_type_create_instance (object_type);
	_tmp0_ = handler;
	_tmp0__target = handler_target;
	_tmp0__target_destroy_notify = handler_target_destroy_notify;
	handler = NULL;
	handler_target = NULL;
	handler_target_destroy_notify = NULL;
	(self->priv->handler_target_destroy_notify == NULL) ? NULL : (self->priv->handler_target_destroy_notify (self->priv->handler_target), NULL);
	self->priv->handler = NULL;
	self->priv->handler_target = NULL;
	self->priv->handler_target_destroy_notify = NULL;
	self->priv->handler = _tmp0_;
	self->priv->handler_target = _tmp0__target;
	self->priv->handler_target_destroy_notify = _tmp0__target_destroy_notify;
	_tmp1_ = type_string;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 (self->priv->type_string);
	self->priv->type_string = _tmp2_;
	(handler_target_destroy_notify == NULL) ? NULL : (handler_target_destroy_notify (handler_target), NULL);
	handler = NULL;
	handler_target = NULL;
	handler_target_destroy_notify = NULL;
	return self;
}


DrtHandlerAdaptor* drt_handler_adaptor_new (DrtMessageHandler handler, void* handler_target, GDestroyNotify handler_target_destroy_notify, const gchar* type_string) {
	return drt_handler_adaptor_construct (DRT_TYPE_HANDLER_ADAPTOR, handler, handler_target, handler_target_destroy_notify, type_string);
}


void drt_handler_adaptor_handle (DrtHandlerAdaptor* self, GObject* source, GVariant* params, GVariant** response, GError** error) {
	GVariant* _vala_response = NULL;
	GVariant* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GVariant* _tmp2_ = NULL;
	DrtMessageHandler _tmp3_ = NULL;
	void* _tmp3__target = NULL;
	GObject* _tmp4_ = NULL;
	GVariant* _tmp5_ = NULL;
	GVariant* _tmp6_ = NULL;
	GVariant* _tmp7_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	_tmp0_ = params;
	_tmp1_ = self->priv->type_string;
	drt_message_listener_check_type_string (_tmp0_, _tmp1_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp3_ = self->priv->handler;
	_tmp3__target = self->priv->handler_target;
	_tmp4_ = source;
	_tmp5_ = params;
	_tmp6_ = _tmp3_ (_tmp4_, _tmp5_, _tmp3__target, &_inner_error_);
	_tmp2_ = _tmp6_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp7_ = _tmp2_;
	_tmp2_ = NULL;
	_g_variant_unref0 (_vala_response);
	_vala_response = _tmp7_;
	_g_variant_unref0 (_tmp2_);
	if (response) {
		*response = _vala_response;
	} else {
		_g_variant_unref0 (_vala_response);
	}
}


static void drt_value_handler_adaptor_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void drt_value_handler_adaptor_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		drt_handler_adaptor_unref (value->data[0].v_pointer);
	}
}


static void drt_value_handler_adaptor_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = drt_handler_adaptor_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer drt_value_handler_adaptor_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* drt_value_handler_adaptor_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DrtHandlerAdaptor* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = drt_handler_adaptor_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* drt_value_handler_adaptor_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DrtHandlerAdaptor** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = drt_handler_adaptor_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* drt_param_spec_handler_adaptor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DrtParamSpecHandlerAdaptor* spec;
	g_return_val_if_fail (g_type_is_a (object_type, DRT_TYPE_HANDLER_ADAPTOR), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer drt_value_get_handler_adaptor (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_HANDLER_ADAPTOR), NULL);
	return value->data[0].v_pointer;
}


void drt_value_set_handler_adaptor (GValue* value, gpointer v_object) {
	DrtHandlerAdaptor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_HANDLER_ADAPTOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DRT_TYPE_HANDLER_ADAPTOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		drt_handler_adaptor_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		drt_handler_adaptor_unref (old);
	}
}


void drt_value_take_handler_adaptor (GValue* value, gpointer v_object) {
	DrtHandlerAdaptor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_HANDLER_ADAPTOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DRT_TYPE_HANDLER_ADAPTOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		drt_handler_adaptor_unref (old);
	}
}


static void drt_handler_adaptor_class_init (DrtHandlerAdaptorClass * klass) {
	drt_handler_adaptor_parent_class = g_type_class_peek_parent (klass);
	((DrtHandlerAdaptorClass *) klass)->finalize = drt_handler_adaptor_finalize;
	g_type_class_add_private (klass, sizeof (DrtHandlerAdaptorPrivate));
}


static void drt_handler_adaptor_instance_init (DrtHandlerAdaptor * self) {
	self->priv = DRT_HANDLER_ADAPTOR_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void drt_handler_adaptor_finalize (DrtHandlerAdaptor* obj) {
	DrtHandlerAdaptor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_HANDLER_ADAPTOR, DrtHandlerAdaptor);
	g_signal_handlers_destroy (self);
	(self->priv->handler_target_destroy_notify == NULL) ? NULL : (self->priv->handler_target_destroy_notify (self->priv->handler_target), NULL);
	self->priv->handler = NULL;
	self->priv->handler_target = NULL;
	self->priv->handler_target_destroy_notify = NULL;
	_g_free0 (self->priv->type_string);
}


GType drt_handler_adaptor_get_type (void) {
	static volatile gsize drt_handler_adaptor_type_id__volatile = 0;
	if (g_once_init_enter (&drt_handler_adaptor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { drt_value_handler_adaptor_init, drt_value_handler_adaptor_free_value, drt_value_handler_adaptor_copy_value, drt_value_handler_adaptor_peek_pointer, "p", drt_value_handler_adaptor_collect_value, "p", drt_value_handler_adaptor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DrtHandlerAdaptorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_handler_adaptor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtHandlerAdaptor), 0, (GInstanceInitFunc) drt_handler_adaptor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType drt_handler_adaptor_type_id;
		drt_handler_adaptor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DrtHandlerAdaptor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&drt_handler_adaptor_type_id__volatile, drt_handler_adaptor_type_id);
	}
	return drt_handler_adaptor_type_id__volatile;
}


gpointer drt_handler_adaptor_ref (gpointer instance) {
	DrtHandlerAdaptor* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void drt_handler_adaptor_unref (gpointer instance) {
	DrtHandlerAdaptor* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DRT_HANDLER_ADAPTOR_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



