/* MessageRouter.c generated by valac 0.34.9, the Vala compiler
 * generated from MessageRouter.vala, do not modify */

/*
 * Copyright 2016 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define DRT_TYPE_MESSAGE_ROUTER (drt_message_router_get_type ())
#define DRT_MESSAGE_ROUTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_MESSAGE_ROUTER, DrtMessageRouter))
#define DRT_MESSAGE_ROUTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_MESSAGE_ROUTER, DrtMessageRouterClass))
#define DRT_IS_MESSAGE_ROUTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_MESSAGE_ROUTER))
#define DRT_IS_MESSAGE_ROUTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_MESSAGE_ROUTER))
#define DRT_MESSAGE_ROUTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_MESSAGE_ROUTER, DrtMessageRouterClass))

typedef struct _DrtMessageRouter DrtMessageRouter;
typedef struct _DrtMessageRouterClass DrtMessageRouterClass;
typedef struct _DrtMessageRouterPrivate DrtMessageRouterPrivate;

#define DRT_TYPE_HANDLER_ADAPTOR (drt_handler_adaptor_get_type ())
#define DRT_HANDLER_ADAPTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_HANDLER_ADAPTOR, DrtHandlerAdaptor))
#define DRT_HANDLER_ADAPTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_HANDLER_ADAPTOR, DrtHandlerAdaptorClass))
#define DRT_IS_HANDLER_ADAPTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_HANDLER_ADAPTOR))
#define DRT_IS_HANDLER_ADAPTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_HANDLER_ADAPTOR))
#define DRT_HANDLER_ADAPTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_HANDLER_ADAPTOR, DrtHandlerAdaptorClass))

typedef struct _DrtHandlerAdaptor DrtHandlerAdaptor;
typedef struct _DrtHandlerAdaptorClass DrtHandlerAdaptorClass;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _drt_handler_adaptor_unref0(var) ((var == NULL) ? NULL : (var = (drt_handler_adaptor_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _DrtMessageRouter {
	GObject parent_instance;
	DrtMessageRouterPrivate * priv;
	GHashTable* handlers;
};

struct _DrtMessageRouterClass {
	GObjectClass parent_class;
	GVariant* (*handle_message) (DrtMessageRouter* self, GObject* source, const gchar* name, GVariant* data, GError** error);
};

typedef GVariant* (*DrtMessageHandler) (GObject* source, GVariant* params, void* user_data, GError** error);
typedef enum  {
	DRT_MESSAGE_ERROR_UNKNOWN,
	DRT_MESSAGE_ERROR_REMOTE_ERROR,
	DRT_MESSAGE_ERROR_UNSUPPORTED,
	DRT_MESSAGE_ERROR_IOERROR,
	DRT_MESSAGE_ERROR_INVALID_RESPONSE,
	DRT_MESSAGE_ERROR_INVALID_REQUEST,
	DRT_MESSAGE_ERROR_INVALID_ARGUMENTS,
	DRT_MESSAGE_ERROR_NOT_READY
} DrtMessageError;
#define DRT_MESSAGE_ERROR drt_message_error_quark ()

static gpointer drt_message_router_parent_class = NULL;

GType drt_message_router_get_type (void) G_GNUC_CONST;
gpointer drt_handler_adaptor_ref (gpointer instance);
void drt_handler_adaptor_unref (gpointer instance);
GParamSpec* drt_param_spec_handler_adaptor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void drt_value_set_handler_adaptor (GValue* value, gpointer v_object);
void drt_value_take_handler_adaptor (GValue* value, gpointer v_object);
gpointer drt_value_get_handler_adaptor (const GValue* value);
GType drt_handler_adaptor_get_type (void) G_GNUC_CONST;
enum  {
	DRT_MESSAGE_ROUTER_DUMMY_PROPERTY
};
DrtMessageRouter* drt_message_router_new (GHashTable* handlers);
DrtMessageRouter* drt_message_router_construct (GType object_type, GHashTable* handlers);
static void _g_free0_ (gpointer var);
static void _drt_handler_adaptor_unref0_ (gpointer var);
void drt_message_router_add_handler (DrtMessageRouter* self, const gchar* message_name, const gchar* type_string, DrtMessageHandler handler, void* handler_target, GDestroyNotify handler_target_destroy_notify);
#define DRT_TYPE_STRING_ANY "#ANY#"
GVariant* drt_message_listener_echo_handler (GObject* source, GVariant* request, GError** error);
static GVariant* _drt_message_listener_echo_handler_drt_message_handler (GObject* source, GVariant* params, gpointer self, GError** error);
GVariant* drt_message_router_handle_message (DrtMessageRouter* self, GObject* source, const gchar* name, GVariant* data, GError** error);
static GVariant* drt_message_router_real_handle_message (DrtMessageRouter* self, GObject* source, const gchar* name, GVariant* data, GError** error);
GQuark drt_message_error_quark (void);
void drt_handler_adaptor_handle (DrtHandlerAdaptor* self, GObject* source, GVariant* params, GVariant** response, GError** error);
DrtHandlerAdaptor* drt_handler_adaptor_new (DrtMessageHandler handler, void* handler_target, GDestroyNotify handler_target_destroy_notify, const gchar* type_string);
DrtHandlerAdaptor* drt_handler_adaptor_construct (GType object_type, DrtMessageHandler handler, void* handler_target, GDestroyNotify handler_target_destroy_notify, const gchar* type_string);
gboolean drt_message_router_remove_handler (DrtMessageRouter* self, const gchar* message_name);
static void drt_message_router_finalize (GObject* obj);


static gpointer _g_hash_table_ref0 (gpointer self) {
	return self ? g_hash_table_ref (self) : NULL;
}


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _drt_handler_adaptor_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (drt_handler_adaptor_unref (var), NULL));
}


static GVariant* _drt_message_listener_echo_handler_drt_message_handler (GObject* source, GVariant* params, gpointer self, GError** error) {
	GVariant* result;
	result = drt_message_listener_echo_handler (source, params, error);
	return result;
}


DrtMessageRouter* drt_message_router_construct (GType object_type, GHashTable* handlers) {
	DrtMessageRouter * self = NULL;
	GHashTable* _tmp0_ = NULL;
	GHashTable* _tmp1_ = NULL;
	GHashTable* _tmp7_ = NULL;
	self = (DrtMessageRouter*) g_object_new (object_type, NULL);
	_tmp1_ = handlers;
	if (_tmp1_ != NULL) {
		GHashTable* _tmp2_ = NULL;
		GHashTable* _tmp3_ = NULL;
		_tmp2_ = handlers;
		_tmp3_ = _g_hash_table_ref0 (_tmp2_);
		_g_hash_table_unref0 (_tmp0_);
		_tmp0_ = _tmp3_;
	} else {
		GHashFunc _tmp4_ = NULL;
		GEqualFunc _tmp5_ = NULL;
		GHashTable* _tmp6_ = NULL;
		_tmp4_ = g_str_hash;
		_tmp5_ = g_str_equal;
		_tmp6_ = g_hash_table_new_full (_tmp4_, _tmp5_, _g_free0_, _drt_handler_adaptor_unref0_);
		_g_hash_table_unref0 (_tmp0_);
		_tmp0_ = _tmp6_;
	}
	_tmp7_ = _g_hash_table_ref0 (_tmp0_);
	_g_hash_table_unref0 (self->handlers);
	self->handlers = _tmp7_;
	drt_message_router_add_handler (self, "echo", DRT_TYPE_STRING_ANY, _drt_message_listener_echo_handler_drt_message_handler, NULL, NULL);
	_g_hash_table_unref0 (_tmp0_);
	return self;
}


DrtMessageRouter* drt_message_router_new (GHashTable* handlers) {
	return drt_message_router_construct (DRT_TYPE_MESSAGE_ROUTER, handlers);
}


/**
 * Handle incoming request message
 * 
 * @param name    request name
 * @param data    request parameters
 * @return response data
 * @throws GLib.Error on failure
 */
static gpointer _drt_handler_adaptor_ref0 (gpointer self) {
	return self ? drt_handler_adaptor_ref (self) : NULL;
}


static GVariant* drt_message_router_real_handle_message (DrtMessageRouter* self, GObject* source, const gchar* name, GVariant* data, GError** error) {
	GVariant* result = NULL;
	GHashTable* _tmp0_ = NULL;
	GVariant* response = NULL;
	DrtHandlerAdaptor* adaptor = NULL;
	GHashTable* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gconstpointer _tmp4_ = NULL;
	DrtHandlerAdaptor* _tmp5_ = NULL;
	DrtHandlerAdaptor* _tmp6_ = NULL;
	DrtHandlerAdaptor* _tmp9_ = NULL;
	GObject* _tmp10_ = NULL;
	GVariant* _tmp11_ = NULL;
	GVariant* _tmp12_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (source != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = self->handlers;
	if (_tmp0_ == NULL) {
		GError* _tmp1_ = NULL;
		_tmp1_ = g_error_new_literal (DRT_MESSAGE_ERROR, DRT_MESSAGE_ERROR_UNSUPPORTED, "This message channel doesn't support requests.");
		_inner_error_ = _tmp1_;
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	response = NULL;
	_tmp2_ = self->handlers;
	_tmp3_ = name;
	_tmp4_ = g_hash_table_lookup (_tmp2_, _tmp3_);
	_tmp5_ = _drt_handler_adaptor_ref0 ((DrtHandlerAdaptor*) _tmp4_);
	adaptor = _tmp5_;
	_tmp6_ = adaptor;
	if (_tmp6_ == NULL) {
		const gchar* _tmp7_ = NULL;
		GError* _tmp8_ = NULL;
		_tmp7_ = name;
		_tmp8_ = g_error_new (DRT_MESSAGE_ERROR, DRT_MESSAGE_ERROR_UNSUPPORTED, "No handler for message '%s'", _tmp7_);
		_inner_error_ = _tmp8_;
		g_propagate_error (error, _inner_error_);
		_drt_handler_adaptor_unref0 (adaptor);
		_g_variant_unref0 (response);
		return NULL;
	}
	_tmp9_ = adaptor;
	_tmp10_ = source;
	_tmp11_ = data;
	drt_handler_adaptor_handle (_tmp9_, _tmp10_, _tmp11_, &_tmp12_, &_inner_error_);
	_g_variant_unref0 (response);
	response = _tmp12_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_drt_handler_adaptor_unref0 (adaptor);
		_g_variant_unref0 (response);
		return NULL;
	}
	result = response;
	_drt_handler_adaptor_unref0 (adaptor);
	return result;
}


GVariant* drt_message_router_handle_message (DrtMessageRouter* self, GObject* source, const gchar* name, GVariant* data, GError** error) {
	g_return_val_if_fail (self != NULL, NULL);
	return DRT_MESSAGE_ROUTER_GET_CLASS (self)->handle_message (self, source, name, data, error);
}


void drt_message_router_add_handler (DrtMessageRouter* self, const gchar* message_name, const gchar* type_string, DrtMessageHandler handler, void* handler_target, GDestroyNotify handler_target_destroy_notify) {
	GHashTable* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	DrtMessageHandler _tmp3_ = NULL;
	void* _tmp3__target = NULL;
	GDestroyNotify _tmp3__target_destroy_notify = NULL;
	const gchar* _tmp4_ = NULL;
	DrtHandlerAdaptor* _tmp5_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (message_name != NULL);
	_tmp0_ = self->handlers;
	_tmp1_ = message_name;
	_tmp2_ = g_strdup (_tmp1_);
	_tmp3_ = handler;
	_tmp3__target = handler_target;
	_tmp3__target_destroy_notify = handler_target_destroy_notify;
	handler = NULL;
	handler_target = NULL;
	handler_target_destroy_notify = NULL;
	_tmp4_ = type_string;
	_tmp5_ = drt_handler_adaptor_new (_tmp3_, _tmp3__target, _tmp3__target_destroy_notify, _tmp4_);
	g_hash_table_insert (_tmp0_, _tmp2_, _tmp5_);
	(handler_target_destroy_notify == NULL) ? NULL : (handler_target_destroy_notify (handler_target), NULL);
	handler = NULL;
	handler_target = NULL;
	handler_target_destroy_notify = NULL;
}


gboolean drt_message_router_remove_handler (DrtMessageRouter* self, const gchar* message_name) {
	gboolean result = FALSE;
	GHashTable* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (message_name != NULL, FALSE);
	_tmp0_ = self->handlers;
	_tmp1_ = message_name;
	_tmp2_ = g_hash_table_remove (_tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}


static void drt_message_router_class_init (DrtMessageRouterClass * klass) {
	drt_message_router_parent_class = g_type_class_peek_parent (klass);
	((DrtMessageRouterClass *) klass)->handle_message = (GVariant* (*)(DrtMessageRouter*, GObject*, const gchar*, GVariant*, GError**)) drt_message_router_real_handle_message;
	G_OBJECT_CLASS (klass)->finalize = drt_message_router_finalize;
}


static void drt_message_router_instance_init (DrtMessageRouter * self) {
}


static void drt_message_router_finalize (GObject* obj) {
	DrtMessageRouter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_MESSAGE_ROUTER, DrtMessageRouter);
	_g_hash_table_unref0 (self->handlers);
	G_OBJECT_CLASS (drt_message_router_parent_class)->finalize (obj);
}


GType drt_message_router_get_type (void) {
	static volatile gsize drt_message_router_type_id__volatile = 0;
	if (g_once_init_enter (&drt_message_router_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DrtMessageRouterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_message_router_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtMessageRouter), 0, (GInstanceInitFunc) drt_message_router_instance_init, NULL };
		GType drt_message_router_type_id;
		drt_message_router_type_id = g_type_register_static (G_TYPE_OBJECT, "DrtMessageRouter", &g_define_type_info, 0);
		g_once_init_leave (&drt_message_router_type_id__volatile, drt_message_router_type_id);
	}
	return drt_message_router_type_id__volatile;
}



