/* OrmManager.c generated by valac 0.34.9, the Vala compiler
 * generated from OrmManager.vala, do not modify */

/*
 * Copyright 2015-2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <dioriteglib4.h>
#include <stdlib.h>
#include <string.h>


#define DRTDB_TYPE_ORM_MANAGER (drtdb_orm_manager_get_type ())
#define DRTDB_ORM_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRTDB_TYPE_ORM_MANAGER, DrtdbOrmManager))
#define DRTDB_ORM_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRTDB_TYPE_ORM_MANAGER, DrtdbOrmManagerClass))
#define DRTDB_IS_ORM_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRTDB_TYPE_ORM_MANAGER))
#define DRTDB_IS_ORM_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRTDB_TYPE_ORM_MANAGER))
#define DRTDB_ORM_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRTDB_TYPE_ORM_MANAGER, DrtdbOrmManagerClass))

typedef struct _DrtdbOrmManager DrtdbOrmManager;
typedef struct _DrtdbOrmManagerClass DrtdbOrmManagerClass;
typedef struct _DrtdbOrmManagerPrivate DrtdbOrmManagerPrivate;

#define DRTDB_TYPE_OBJECT_SPEC (drtdb_object_spec_get_type ())
#define DRTDB_OBJECT_SPEC(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRTDB_TYPE_OBJECT_SPEC, DrtdbObjectSpec))
#define DRTDB_OBJECT_SPEC_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRTDB_TYPE_OBJECT_SPEC, DrtdbObjectSpecClass))
#define DRTDB_IS_OBJECT_SPEC(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRTDB_TYPE_OBJECT_SPEC))
#define DRTDB_IS_OBJECT_SPEC_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRTDB_TYPE_OBJECT_SPEC))
#define DRTDB_OBJECT_SPEC_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRTDB_TYPE_OBJECT_SPEC, DrtdbObjectSpecClass))

typedef struct _DrtdbObjectSpec DrtdbObjectSpec;
typedef struct _DrtdbObjectSpecClass DrtdbObjectSpecClass;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

#define DRTDB_TYPE_RESULT (drtdb_result_get_type ())
#define DRTDB_RESULT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRTDB_TYPE_RESULT, DrtdbResult))
#define DRTDB_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRTDB_TYPE_RESULT, DrtdbResultClass))
#define DRTDB_IS_RESULT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRTDB_TYPE_RESULT))
#define DRTDB_IS_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRTDB_TYPE_RESULT))
#define DRTDB_RESULT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRTDB_TYPE_RESULT, DrtdbResultClass))

typedef struct _DrtdbResult DrtdbResult;
typedef struct _DrtdbResultClass DrtdbResultClass;
#define _drtdb_object_spec_unref0(var) ((var == NULL) ? NULL : (var = (drtdb_object_spec_unref (var), NULL)))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))

struct _DrtdbOrmManager {
	GObject parent_instance;
	DrtdbOrmManagerPrivate * priv;
};

struct _DrtdbOrmManagerClass {
	GObjectClass parent_class;
};

struct _DrtdbOrmManagerPrivate {
	GHashTable* object_specs;
	GRecMutex __lock_object_specs;
};

typedef enum  {
	DRTDB_DATABASE_ERROR_UNKNOWN,
	DRTDB_DATABASE_ERROR_IOERROR,
	DRTDB_DATABASE_ERROR_DATABASE_NOT_OPENED,
	DRTDB_DATABASE_ERROR_GENERAL,
	DRTDB_DATABASE_ERROR_RANGE,
	DRTDB_DATABASE_ERROR_DATA_TYPE,
	DRTDB_DATABASE_ERROR_NAME,
	DRTDB_DATABASE_ERROR_MISMATCH,
	DRTDB_DATABASE_ERROR_MISUSE,
	DRTDB_DATABASE_ERROR_DOES_NOT_EXIST,
	DRTDB_DATABASE_ERROR_TOO_MANY_RESULTS
} DrtdbDatabaseError;
#define DRTDB_DATABASE_ERROR drtdb_database_error_quark ()

static gpointer drtdb_orm_manager_parent_class = NULL;

GType drtdb_orm_manager_get_type (void) G_GNUC_CONST;
gpointer drtdb_object_spec_ref (gpointer instance);
void drtdb_object_spec_unref (gpointer instance);
GParamSpec* drtdb_param_spec_object_spec (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void drtdb_value_set_object_spec (GValue* value, gpointer v_object);
void drtdb_value_take_object_spec (GValue* value, gpointer v_object);
gpointer drtdb_value_get_object_spec (const GValue* value);
GType drtdb_object_spec_get_type (void) G_GNUC_CONST;
#define DRTDB_ORM_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRTDB_TYPE_ORM_MANAGER, DrtdbOrmManagerPrivate))
enum  {
	DRTDB_ORM_MANAGER_DUMMY_PROPERTY
};
DrtdbOrmManager* drtdb_orm_manager_new (void);
DrtdbOrmManager* drtdb_orm_manager_construct (GType object_type);
static guint _drt_types_type_hash_ghash_func (gconstpointer key);
static gboolean _drt_types_type_equal_gequal_func (gconstpointer a, gconstpointer b);
static void _drtdb_object_spec_unref0_ (gpointer var);
void drtdb_orm_manager_add_object_spec (DrtdbOrmManager* self, DrtdbObjectSpec* spec);
GType drtdb_object_spec_get_object_type (DrtdbObjectSpec* self);
DrtdbObjectSpec* drtdb_orm_manager_get_object_spec (DrtdbOrmManager* self, GType type);
GType drtdb_result_get_type (void) G_GNUC_CONST;
GQuark drtdb_database_error_quark (void);
gpointer drtdb_orm_manager_create_object (DrtdbOrmManager* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, DrtdbResult* _result_, GError** error);
GParamSpec** drtdb_object_spec_get_properties (DrtdbObjectSpec* self, int* result_length1);
gint drtdb_result_get_column_index (DrtdbResult* self, const gchar* name);
static void g_parameter_destroy (GParameter* self);
static void _vala_GParameter_array_free (GParameter* array, gint array_length);
GValue* drtdb_result_fetch_value_of_type (DrtdbResult* self, gint index, GType type, GError** error);
static GValue* _g_value_dup (GValue* self);
static void _vala_GValue_free (GValue* self);
static void _vala_array_add1 (GParameter** array, int* length, int* size, const GParameter* value);
void drtdb_orm_manager_fill_object (DrtdbOrmManager* self, GObject* object, DrtdbResult* _result_, GError** error);
static void drtdb_orm_manager_finalize (GObject* obj);


/**
 * Create new OrmManager object.
 */
static guint _drt_types_type_hash_ghash_func (gconstpointer key) {
	guint result;
	result = drt_types_type_hash ((GType) ((gintptr) key));
	return result;
}


static gboolean _drt_types_type_equal_gequal_func (gconstpointer a, gconstpointer b) {
	gboolean result;
	result = drt_types_type_equal ((GType) ((gintptr) a), (GType) ((gintptr) b));
	return result;
}


static void _drtdb_object_spec_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (drtdb_object_spec_unref (var), NULL));
}


DrtdbOrmManager* drtdb_orm_manager_construct (GType object_type) {
	DrtdbOrmManager * self = NULL;
	GHashTable* _tmp0_ = NULL;
	self = (DrtdbOrmManager*) g_object_new (object_type, NULL);
	_tmp0_ = g_hash_table_new_full (_drt_types_type_hash_ghash_func, _drt_types_type_equal_gequal_func, NULL, _drtdb_object_spec_unref0_);
	_g_hash_table_unref0 (self->priv->object_specs);
	self->priv->object_specs = _tmp0_;
	return self;
}


DrtdbOrmManager* drtdb_orm_manager_new (void) {
	return drtdb_orm_manager_construct (DRTDB_TYPE_ORM_MANAGER);
}


/**
 * Add ORM object specification
 * 
 * @param spec    ORM object specification
 */
static gpointer _drtdb_object_spec_ref0 (gpointer self) {
	return self ? drtdb_object_spec_ref (self) : NULL;
}


void drtdb_orm_manager_add_object_spec (DrtdbOrmManager* self, DrtdbObjectSpec* spec) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (spec != NULL);
	{
		GHashTable* _tmp0_ = NULL;
		_tmp0_ = self->priv->object_specs;
		g_rec_mutex_lock (&self->priv->__lock_object_specs);
		{
			GHashTable* _tmp1_ = NULL;
			DrtdbObjectSpec* _tmp2_ = NULL;
			GType _tmp3_ = 0UL;
			GType _tmp4_ = 0UL;
			DrtdbObjectSpec* _tmp5_ = NULL;
			DrtdbObjectSpec* _tmp6_ = NULL;
			_tmp1_ = self->priv->object_specs;
			_tmp2_ = spec;
			_tmp3_ = drtdb_object_spec_get_object_type (_tmp2_);
			_tmp4_ = _tmp3_;
			_tmp5_ = spec;
			_tmp6_ = _drtdb_object_spec_ref0 (_tmp5_);
			g_hash_table_insert (_tmp1_, (gpointer) ((gintptr) _tmp4_), _tmp6_);
		}
		__finally3:
		{
			GHashTable* _tmp7_ = NULL;
			_tmp7_ = self->priv->object_specs;
			g_rec_mutex_unlock (&self->priv->__lock_object_specs);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


/**
 * Retrieve ORM object specification for given type
 * 
 * @param type    {@link GLib.Object} type
 * @return ORM object spec or `null` if it is not found
 */
DrtdbObjectSpec* drtdb_orm_manager_get_object_spec (DrtdbOrmManager* self, GType type) {
	DrtdbObjectSpec* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		GHashTable* _tmp0_ = NULL;
		_tmp0_ = self->priv->object_specs;
		g_rec_mutex_lock (&self->priv->__lock_object_specs);
		{
			GHashTable* _tmp1_ = NULL;
			GType _tmp2_ = 0UL;
			gconstpointer _tmp3_ = NULL;
			DrtdbObjectSpec* _tmp4_ = NULL;
			_tmp1_ = self->priv->object_specs;
			_tmp2_ = type;
			_tmp3_ = g_hash_table_lookup (_tmp1_, (gpointer) ((gintptr) _tmp2_));
			_tmp4_ = _drtdb_object_spec_ref0 ((DrtdbObjectSpec*) _tmp3_);
			result = _tmp4_;
			{
				GHashTable* _tmp5_ = NULL;
				_tmp5_ = self->priv->object_specs;
				g_rec_mutex_unlock (&self->priv->__lock_object_specs);
			}
			return result;
		}
		__finally4:
		{
			GHashTable* _tmp6_ = NULL;
			_tmp6_ = self->priv->object_specs;
			g_rec_mutex_unlock (&self->priv->__lock_object_specs);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


/**
 * Create ORM object from database record
 * 
 * @param result    The corresponding database record.
 * @return object containing database data according to corresponding {@link ObjectSpec}
 * @throws DatabaseError if data type `T` is not supported or {@link ObjectSpec} is not found
 * @see OrmManager.add_object_spec
 */
static void g_parameter_destroy (GParameter* self) {
	G_IS_VALUE (&(*self).value) ? (g_value_unset (&(*self).value), NULL) : NULL;
}


static void _vala_GParameter_array_free (GParameter* array, gint array_length) {
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			g_parameter_destroy (&array[i]);
		}
	}
	g_free (array);
}


static GValue* _g_value_dup (GValue* self) {
	return g_boxed_copy (G_TYPE_VALUE, self);
}


static gpointer __g_value_dup0 (gpointer self) {
	return self ? _g_value_dup (self) : NULL;
}


static void _vala_GValue_free (GValue* self) {
	g_value_unset (self);
	g_free (self);
}


static void _vala_array_add1 (GParameter** array, int* length, int* size, const GParameter* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GParameter, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


gpointer drtdb_orm_manager_create_object (DrtdbOrmManager* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, DrtdbResult* _result_, GError** error) {
	gpointer result = NULL;
	GType type = 0UL;
	GType _tmp0_ = 0UL;
	gboolean _tmp1_ = FALSE;
	DrtdbObjectSpec* object_spec = NULL;
	GType _tmp5_ = 0UL;
	DrtdbObjectSpec* _tmp6_ = NULL;
	DrtdbObjectSpec* _tmp7_ = NULL;
	GParameter* parameters = NULL;
	GParameter* _tmp11_ = NULL;
	gint parameters_length1 = 0;
	gint _parameters_size_ = 0;
	DrtdbObjectSpec* _tmp12_ = NULL;
	GParamSpec** _tmp13_ = NULL;
	gint _tmp13__length1 = 0;
	GParamSpec** _tmp14_ = NULL;
	gint _tmp14__length1 = 0;
	GType _tmp40_ = 0UL;
	GParameter* _tmp41_ = NULL;
	gint _tmp41__length1 = 0;
	GObject* _tmp42_ = NULL;
	GObject* _tmp43_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (_result_ != NULL, NULL);
	type = t_type;
	_tmp0_ = type;
	_tmp1_ = G_TYPE_IS_OBJECT (_tmp0_);
	if (!_tmp1_) {
		GType _tmp2_ = 0UL;
		const gchar* _tmp3_ = NULL;
		GError* _tmp4_ = NULL;
		_tmp2_ = type;
		_tmp3_ = g_type_name (_tmp2_);
		_tmp4_ = g_error_new (DRTDB_DATABASE_ERROR, DRTDB_DATABASE_ERROR_DATA_TYPE, "Data type %s is not supported.", _tmp3_);
		_inner_error_ = _tmp4_;
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp5_ = type;
	_tmp6_ = drtdb_orm_manager_get_object_spec (self, _tmp5_);
	object_spec = _tmp6_;
	_tmp7_ = object_spec;
	if (_tmp7_ == NULL) {
		GType _tmp8_ = 0UL;
		const gchar* _tmp9_ = NULL;
		GError* _tmp10_ = NULL;
		_tmp8_ = type;
		_tmp9_ = g_type_name (_tmp8_);
		_tmp10_ = g_error_new (DRTDB_DATABASE_ERROR, DRTDB_DATABASE_ERROR_DATA_TYPE, "ObjectSpec for %s has not been found.", _tmp9_);
		_inner_error_ = _tmp10_;
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			_drtdb_object_spec_unref0 (object_spec);
			return NULL;
		} else {
			_drtdb_object_spec_unref0 (object_spec);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp11_ = g_new0 (GParameter, 0);
	parameters = _tmp11_;
	parameters_length1 = 0;
	_parameters_size_ = parameters_length1;
	_tmp12_ = object_spec;
	_tmp13_ = drtdb_object_spec_get_properties (_tmp12_, &_tmp13__length1);
	_tmp14_ = _tmp13_;
	_tmp14__length1 = _tmp13__length1;
	{
		GParamSpec** property_collection = NULL;
		gint property_collection_length1 = 0;
		gint _property_collection_size_ = 0;
		gint property_it = 0;
		property_collection = _tmp14_;
		property_collection_length1 = _tmp14__length1;
		for (property_it = 0; property_it < _tmp14__length1; property_it = property_it + 1) {
			GParamSpec* property = NULL;
			property = property_collection[property_it];
			{
				gint index = 0;
				DrtdbResult* _tmp15_ = NULL;
				GParamSpec* _tmp16_ = NULL;
				const gchar* _tmp17_ = NULL;
				gint _tmp18_ = 0;
				gint _tmp19_ = 0;
				GValue* value = NULL;
				DrtdbResult* _tmp23_ = NULL;
				gint _tmp24_ = 0;
				GParamSpec* _tmp25_ = NULL;
				GType _tmp26_ = 0UL;
				GValue* _tmp27_ = NULL;
				GValue* _tmp28_ = NULL;
				GParameter* _tmp34_ = NULL;
				gint _tmp34__length1 = 0;
				GParamSpec* _tmp35_ = NULL;
				const gchar* _tmp36_ = NULL;
				GValue* _tmp37_ = NULL;
				GValue _tmp38_ = {0};
				GParameter _tmp39_ = {0};
				_tmp15_ = _result_;
				_tmp16_ = property;
				_tmp17_ = _tmp16_->name;
				_tmp18_ = drtdb_result_get_column_index (_tmp15_, _tmp17_);
				index = _tmp18_;
				_tmp19_ = index;
				if (_tmp19_ < 0) {
					GParamSpec* _tmp20_ = NULL;
					const gchar* _tmp21_ = NULL;
					GError* _tmp22_ = NULL;
					_tmp20_ = property;
					_tmp21_ = _tmp20_->name;
					_tmp22_ = g_error_new (DRTDB_DATABASE_ERROR, DRTDB_DATABASE_ERROR_NAME, "There is no column named '%s'.", _tmp21_);
					_inner_error_ = _tmp22_;
					if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
						g_propagate_error (error, _inner_error_);
						parameters = (_vala_GParameter_array_free (parameters, parameters_length1), NULL);
						_drtdb_object_spec_unref0 (object_spec);
						return NULL;
					} else {
						parameters = (_vala_GParameter_array_free (parameters, parameters_length1), NULL);
						_drtdb_object_spec_unref0 (object_spec);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
				}
				_tmp23_ = _result_;
				_tmp24_ = index;
				_tmp25_ = property;
				_tmp26_ = _tmp25_->value_type;
				_tmp27_ = drtdb_result_fetch_value_of_type (_tmp23_, _tmp24_, _tmp26_, &_inner_error_);
				value = _tmp27_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
						g_propagate_error (error, _inner_error_);
						parameters = (_vala_GParameter_array_free (parameters, parameters_length1), NULL);
						_drtdb_object_spec_unref0 (object_spec);
						return NULL;
					} else {
						parameters = (_vala_GParameter_array_free (parameters, parameters_length1), NULL);
						_drtdb_object_spec_unref0 (object_spec);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
				}
				_tmp28_ = value;
				if (_tmp28_ == NULL) {
					GParamSpec* _tmp29_ = NULL;
					GType _tmp30_ = 0UL;
					GValue _tmp31_ = {0};
					GValue _tmp32_ = {0};
					GValue* _tmp33_ = NULL;
					_tmp29_ = property;
					_tmp30_ = _tmp29_->value_type;
					g_value_init (&_tmp31_, _tmp30_);
					_tmp32_ = _tmp31_;
					_tmp33_ = __g_value_dup0 (&_tmp32_);
					__vala_GValue_free0 (value);
					value = _tmp33_;
					G_IS_VALUE (&_tmp32_) ? (g_value_unset (&_tmp32_), NULL) : NULL;
				}
				_tmp34_ = parameters;
				_tmp34__length1 = parameters_length1;
				_tmp35_ = property;
				_tmp36_ = _tmp35_->name;
				_tmp37_ = value;
				if (G_IS_VALUE (_tmp37_)) {
					g_value_init (&_tmp38_, G_VALUE_TYPE (_tmp37_));
					g_value_copy (_tmp37_, &_tmp38_);
				} else {
					_tmp38_ = *_tmp37_;
				}
				memset (&_tmp39_, 0, sizeof (GParameter));
				_tmp39_.name = _tmp36_;
				G_IS_VALUE (&_tmp39_.value) ? (g_value_unset (&_tmp39_.value), NULL) : NULL;
				_tmp39_.value = _tmp38_;
				_vala_array_add1 (&parameters, &parameters_length1, &_parameters_size_, &_tmp39_);
				__vala_GValue_free0 (value);
			}
		}
	}
	_tmp40_ = type;
	_tmp41_ = parameters;
	_tmp41__length1 = parameters_length1;
	_tmp42_ = g_object_newv (_tmp40_, _tmp41__length1, _tmp41_);
	_tmp43_ = G_IS_INITIALLY_UNOWNED (_tmp42_) ? g_object_ref_sink (_tmp42_) : _tmp42_;
	result = (gpointer) _tmp43_;
	parameters = (_vala_GParameter_array_free (parameters, parameters_length1), NULL);
	_drtdb_object_spec_unref0 (object_spec);
	return result;
}


/**
 * Fill ORM object from database data
 * 
 * @param object    the object to fill with database data
 * @param result    The corresponding database record.
 * @throws DatabaseError if corresponding {@link ObjectSpec} is not found
 */
void drtdb_orm_manager_fill_object (DrtdbOrmManager* self, GObject* object, DrtdbResult* _result_, GError** error) {
	GType type = 0UL;
	GObject* _tmp0_ = NULL;
	GType _tmp1_ = 0UL;
	DrtdbObjectSpec* object_spec = NULL;
	GType _tmp2_ = 0UL;
	DrtdbObjectSpec* _tmp3_ = NULL;
	DrtdbObjectSpec* _tmp4_ = NULL;
	DrtdbObjectSpec* _tmp8_ = NULL;
	GParamSpec** _tmp9_ = NULL;
	gint _tmp9__length1 = 0;
	GParamSpec** _tmp10_ = NULL;
	gint _tmp10__length1 = 0;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (object != NULL);
	g_return_if_fail (_result_ != NULL);
	_tmp0_ = object;
	_tmp1_ = G_TYPE_FROM_INSTANCE (_tmp0_);
	type = _tmp1_;
	_tmp2_ = type;
	_tmp3_ = drtdb_orm_manager_get_object_spec (self, _tmp2_);
	object_spec = _tmp3_;
	_tmp4_ = object_spec;
	if (_tmp4_ == NULL) {
		GType _tmp5_ = 0UL;
		const gchar* _tmp6_ = NULL;
		GError* _tmp7_ = NULL;
		_tmp5_ = type;
		_tmp6_ = g_type_name (_tmp5_);
		_tmp7_ = g_error_new (DRTDB_DATABASE_ERROR, DRTDB_DATABASE_ERROR_DATA_TYPE, "ObjectSpec for %s has not been found.", _tmp6_);
		_inner_error_ = _tmp7_;
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			_drtdb_object_spec_unref0 (object_spec);
			return;
		} else {
			_drtdb_object_spec_unref0 (object_spec);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp8_ = object_spec;
	_tmp9_ = drtdb_object_spec_get_properties (_tmp8_, &_tmp9__length1);
	_tmp10_ = _tmp9_;
	_tmp10__length1 = _tmp9__length1;
	{
		GParamSpec** property_collection = NULL;
		gint property_collection_length1 = 0;
		gint _property_collection_size_ = 0;
		gint property_it = 0;
		property_collection = _tmp10_;
		property_collection_length1 = _tmp10__length1;
		for (property_it = 0; property_it < _tmp10__length1; property_it = property_it + 1) {
			GParamSpec* property = NULL;
			property = property_collection[property_it];
			{
				gint index = 0;
				DrtdbResult* _tmp11_ = NULL;
				GParamSpec* _tmp12_ = NULL;
				const gchar* _tmp13_ = NULL;
				gint _tmp14_ = 0;
				gint _tmp15_ = 0;
				GValue* value = NULL;
				DrtdbResult* _tmp19_ = NULL;
				gint _tmp20_ = 0;
				GParamSpec* _tmp21_ = NULL;
				GType _tmp22_ = 0UL;
				GValue* _tmp23_ = NULL;
				GValue* _tmp24_ = NULL;
				gboolean _tmp30_ = FALSE;
				GParamSpec* _tmp31_ = NULL;
				GParamFlags _tmp32_ = 0;
				_tmp11_ = _result_;
				_tmp12_ = property;
				_tmp13_ = _tmp12_->name;
				_tmp14_ = drtdb_result_get_column_index (_tmp11_, _tmp13_);
				index = _tmp14_;
				_tmp15_ = index;
				if (_tmp15_ < 0) {
					GParamSpec* _tmp16_ = NULL;
					const gchar* _tmp17_ = NULL;
					GError* _tmp18_ = NULL;
					_tmp16_ = property;
					_tmp17_ = _tmp16_->name;
					_tmp18_ = g_error_new (DRTDB_DATABASE_ERROR, DRTDB_DATABASE_ERROR_NAME, "There is no column named '%s'.", _tmp17_);
					_inner_error_ = _tmp18_;
					if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
						g_propagate_error (error, _inner_error_);
						_drtdb_object_spec_unref0 (object_spec);
						return;
					} else {
						_drtdb_object_spec_unref0 (object_spec);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
				}
				_tmp19_ = _result_;
				_tmp20_ = index;
				_tmp21_ = property;
				_tmp22_ = _tmp21_->value_type;
				_tmp23_ = drtdb_result_fetch_value_of_type (_tmp19_, _tmp20_, _tmp22_, &_inner_error_);
				value = _tmp23_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
						g_propagate_error (error, _inner_error_);
						_drtdb_object_spec_unref0 (object_spec);
						return;
					} else {
						_drtdb_object_spec_unref0 (object_spec);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
				}
				_tmp24_ = value;
				if (_tmp24_ == NULL) {
					GParamSpec* _tmp25_ = NULL;
					GType _tmp26_ = 0UL;
					GValue _tmp27_ = {0};
					GValue _tmp28_ = {0};
					GValue* _tmp29_ = NULL;
					_tmp25_ = property;
					_tmp26_ = _tmp25_->value_type;
					g_value_init (&_tmp27_, _tmp26_);
					_tmp28_ = _tmp27_;
					_tmp29_ = __g_value_dup0 (&_tmp28_);
					__vala_GValue_free0 (value);
					value = _tmp29_;
					G_IS_VALUE (&_tmp28_) ? (g_value_unset (&_tmp28_), NULL) : NULL;
				}
				_tmp31_ = property;
				_tmp32_ = _tmp31_->flags;
				if ((_tmp32_ & G_PARAM_WRITABLE) != 0) {
					GParamSpec* _tmp33_ = NULL;
					GParamFlags _tmp34_ = 0;
					_tmp33_ = property;
					_tmp34_ = _tmp33_->flags;
					_tmp30_ = (_tmp34_ & G_PARAM_CONSTRUCT_ONLY) == 0;
				} else {
					_tmp30_ = FALSE;
				}
				if (_tmp30_) {
					GObject* _tmp35_ = NULL;
					GParamSpec* _tmp36_ = NULL;
					const gchar* _tmp37_ = NULL;
					GValue* _tmp38_ = NULL;
					GValue _tmp39_ = {0};
					_tmp35_ = object;
					_tmp36_ = property;
					_tmp37_ = _tmp36_->name;
					_tmp38_ = value;
					_tmp39_ = *_tmp38_;
					g_object_set_property (_tmp35_, _tmp37_, &_tmp39_);
				} else {
					GParamSpec* _tmp40_ = NULL;
					GParamFlags _tmp41_ = 0;
					_tmp40_ = property;
					_tmp41_ = _tmp40_->flags;
					if ((_tmp41_ & G_PARAM_READABLE) != 0) {
						GValue current_value = {0};
						GParamSpec* _tmp42_ = NULL;
						GType _tmp43_ = 0UL;
						GValue _tmp44_ = {0};
						GObject* _tmp45_ = NULL;
						GParamSpec* _tmp46_ = NULL;
						const gchar* _tmp47_ = NULL;
						GValue _tmp48_ = {0};
						GValue* _tmp49_ = NULL;
						gboolean _tmp50_ = FALSE;
						_tmp42_ = property;
						_tmp43_ = _tmp42_->value_type;
						g_value_init (&_tmp44_, _tmp43_);
						current_value = _tmp44_;
						_tmp45_ = object;
						_tmp46_ = property;
						_tmp47_ = _tmp46_->name;
						g_object_get_property (_tmp45_, _tmp47_, &current_value);
						_tmp48_ = current_value;
						_tmp49_ = value;
						_tmp50_ = drt_value_equal (&_tmp48_, _tmp49_);
						if (!_tmp50_) {
							GParamSpec* _tmp51_ = NULL;
							const gchar* _tmp52_ = NULL;
							GError* _tmp53_ = NULL;
							_tmp51_ = property;
							_tmp52_ = _tmp51_->name;
							_tmp53_ = g_error_new (DRTDB_DATABASE_ERROR, DRTDB_DATABASE_ERROR_MISMATCH, "Read-only value of property '%s' doesn't match database data.", _tmp52_);
							_inner_error_ = _tmp53_;
							if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
								g_propagate_error (error, _inner_error_);
								G_IS_VALUE (&current_value) ? (g_value_unset (&current_value), NULL) : NULL;
								__vala_GValue_free0 (value);
								_drtdb_object_spec_unref0 (object_spec);
								return;
							} else {
								G_IS_VALUE (&current_value) ? (g_value_unset (&current_value), NULL) : NULL;
								__vala_GValue_free0 (value);
								_drtdb_object_spec_unref0 (object_spec);
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
								g_clear_error (&_inner_error_);
								return;
							}
						}
						G_IS_VALUE (&current_value) ? (g_value_unset (&current_value), NULL) : NULL;
					}
				}
				__vala_GValue_free0 (value);
			}
		}
	}
	_drtdb_object_spec_unref0 (object_spec);
}


static void drtdb_orm_manager_class_init (DrtdbOrmManagerClass * klass) {
	drtdb_orm_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DrtdbOrmManagerPrivate));
	G_OBJECT_CLASS (klass)->finalize = drtdb_orm_manager_finalize;
}


static void drtdb_orm_manager_instance_init (DrtdbOrmManager * self) {
	self->priv = DRTDB_ORM_MANAGER_GET_PRIVATE (self);
	g_rec_mutex_init (&self->priv->__lock_object_specs);
}


static void drtdb_orm_manager_finalize (GObject* obj) {
	DrtdbOrmManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRTDB_TYPE_ORM_MANAGER, DrtdbOrmManager);
	g_rec_mutex_clear (&self->priv->__lock_object_specs);
	_g_hash_table_unref0 (self->priv->object_specs);
	G_OBJECT_CLASS (drtdb_orm_manager_parent_class)->finalize (obj);
}


/**
 * Object Relationship Mapping
 */
GType drtdb_orm_manager_get_type (void) {
	static volatile gsize drtdb_orm_manager_type_id__volatile = 0;
	if (g_once_init_enter (&drtdb_orm_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DrtdbOrmManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drtdb_orm_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtdbOrmManager), 0, (GInstanceInitFunc) drtdb_orm_manager_instance_init, NULL };
		GType drtdb_orm_manager_type_id;
		drtdb_orm_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "DrtdbOrmManager", &g_define_type_info, 0);
		g_once_init_leave (&drtdb_orm_manager_type_id__volatile, drtdb_orm_manager_type_id);
	}
	return drtdb_orm_manager_type_id__volatile;
}



