/* PopoverButton.c generated by valac 0.34.9, the Vala compiler
 * generated from PopoverButton.vala, do not modify */

/*
 * Copyright 2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>


#define DRT_TYPE_POPOVER_BUTTON (drt_popover_button_get_type ())
#define DRT_POPOVER_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_POPOVER_BUTTON, DrtPopoverButton))
#define DRT_POPOVER_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_POPOVER_BUTTON, DrtPopoverButtonClass))
#define DRT_IS_POPOVER_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_POPOVER_BUTTON))
#define DRT_IS_POPOVER_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_POPOVER_BUTTON))
#define DRT_POPOVER_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_POPOVER_BUTTON, DrtPopoverButtonClass))

typedef struct _DrtPopoverButton DrtPopoverButton;
typedef struct _DrtPopoverButtonClass DrtPopoverButtonClass;
typedef struct _DrtPopoverButtonPrivate DrtPopoverButtonPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _DrtPopoverButton {
	GtkButton parent_instance;
	DrtPopoverButtonPrivate * priv;
};

struct _DrtPopoverButtonClass {
	GtkButtonClass parent_class;
};

struct _DrtPopoverButtonPrivate {
	GtkPopover* _popover;
};


static gpointer drt_popover_button_parent_class = NULL;

GType drt_popover_button_get_type (void) G_GNUC_CONST;
#define DRT_POPOVER_BUTTON_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRT_TYPE_POPOVER_BUTTON, DrtPopoverButtonPrivate))
enum  {
	DRT_POPOVER_BUTTON_DUMMY_PROPERTY,
	DRT_POPOVER_BUTTON_POPOVER
};
DrtPopoverButton* drt_popover_button_new (const gchar* label);
DrtPopoverButton* drt_popover_button_construct (GType object_type, const gchar* label);
static void drt_popover_button_real_clicked (GtkButton* base);
GtkPopover* drt_popover_button_get_popover (DrtPopoverButton* self);
static void drt_popover_button_set_popover (DrtPopoverButton* self, GtkPopover* value);
static GObject * drt_popover_button_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void drt_popover_button_finalize (GObject* obj);
static void _vala_drt_popover_button_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_drt_popover_button_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
 * Create new PopoverButton.
 * 
 * @param label    The label of the button.
 */
DrtPopoverButton* drt_popover_button_construct (GType object_type, const gchar* label) {
	DrtPopoverButton * self = NULL;
	const gchar* _tmp0_ = NULL;
	self = (DrtPopoverButton*) g_object_new (object_type, NULL);
	_tmp0_ = label;
	if (_tmp0_ != NULL) {
		const gchar* _tmp1_ = NULL;
		_tmp1_ = label;
		gtk_button_set_label ((GtkButton*) self, _tmp1_);
	}
	return self;
}


DrtPopoverButton* drt_popover_button_new (const gchar* label) {
	return drt_popover_button_construct (DRT_TYPE_POPOVER_BUTTON, label);
}


static void drt_popover_button_real_clicked (GtkButton* base) {
	DrtPopoverButton * self;
	GtkPopover* _tmp0_ = NULL;
	self = (DrtPopoverButton*) base;
	_tmp0_ = self->priv->_popover;
	gtk_widget_show ((GtkWidget*) _tmp0_);
}


GtkPopover* drt_popover_button_get_popover (DrtPopoverButton* self) {
	GtkPopover* result;
	GtkPopover* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_popover;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void drt_popover_button_set_popover (DrtPopoverButton* self, GtkPopover* value) {
	GtkPopover* _tmp0_ = NULL;
	GtkPopover* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_popover);
	self->priv->_popover = _tmp1_;
	g_object_notify ((GObject *) self, "popover");
}


static GObject * drt_popover_button_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	DrtPopoverButton * self;
	GtkPopover* _tmp0_ = NULL;
	GtkPopover* _tmp1_ = NULL;
	GtkPopover* _tmp2_ = NULL;
	parent_class = G_OBJECT_CLASS (drt_popover_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_POPOVER_BUTTON, DrtPopoverButton);
	_tmp0_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) self);
	g_object_ref_sink (_tmp0_);
	_tmp1_ = _tmp0_;
	drt_popover_button_set_popover (self, _tmp1_);
	_g_object_unref0 (_tmp1_);
	_tmp2_ = self->priv->_popover;
	gtk_popover_set_position (_tmp2_, GTK_POS_BOTTOM);
	return obj;
}


static void drt_popover_button_class_init (DrtPopoverButtonClass * klass) {
	drt_popover_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DrtPopoverButtonPrivate));
	((GtkButtonClass *) klass)->clicked = (void (*)(GtkButton*)) drt_popover_button_real_clicked;
	G_OBJECT_CLASS (klass)->get_property = _vala_drt_popover_button_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_drt_popover_button_set_property;
	G_OBJECT_CLASS (klass)->constructor = drt_popover_button_constructor;
	G_OBJECT_CLASS (klass)->finalize = drt_popover_button_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_POPOVER_BUTTON_POPOVER, g_param_spec_object ("popover", "popover", "popover", gtk_popover_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void drt_popover_button_instance_init (DrtPopoverButton * self) {
	self->priv = DRT_POPOVER_BUTTON_GET_PRIVATE (self);
}


static void drt_popover_button_finalize (GObject* obj) {
	DrtPopoverButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_POPOVER_BUTTON, DrtPopoverButton);
	_g_object_unref0 (self->priv->_popover);
	G_OBJECT_CLASS (drt_popover_button_parent_class)->finalize (obj);
}


/**
 * Button which shows popover on click.
 */
GType drt_popover_button_get_type (void) {
	static volatile gsize drt_popover_button_type_id__volatile = 0;
	if (g_once_init_enter (&drt_popover_button_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DrtPopoverButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_popover_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtPopoverButton), 0, (GInstanceInitFunc) drt_popover_button_instance_init, NULL };
		GType drt_popover_button_type_id;
		drt_popover_button_type_id = g_type_register_static (gtk_button_get_type (), "DrtPopoverButton", &g_define_type_info, 0);
		g_once_init_leave (&drt_popover_button_type_id__volatile, drt_popover_button_type_id);
	}
	return drt_popover_button_type_id__volatile;
}


static void _vala_drt_popover_button_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DrtPopoverButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRT_TYPE_POPOVER_BUTTON, DrtPopoverButton);
	switch (property_id) {
		case DRT_POPOVER_BUTTON_POPOVER:
		g_value_set_object (value, drt_popover_button_get_popover (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_drt_popover_button_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DrtPopoverButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRT_TYPE_POPOVER_BUTTON, DrtPopoverButton);
	switch (property_id) {
		case DRT_POPOVER_BUTTON_POPOVER:
		drt_popover_button_set_popover (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



