/* RichTextBuffer.c generated by valac 0.34.9, the Vala compiler
 * generated from RichTextBuffer.vala, do not modify */

/*
 * Copyright 2012-2015 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <dioriteglib4.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <pango/pango.h>


#define DRT_TYPE_RICH_TEXT_BUFFER (drt_rich_text_buffer_get_type ())
#define DRT_RICH_TEXT_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_RICH_TEXT_BUFFER, DrtRichTextBuffer))
#define DRT_RICH_TEXT_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_RICH_TEXT_BUFFER, DrtRichTextBufferClass))
#define DRT_IS_RICH_TEXT_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_RICH_TEXT_BUFFER))
#define DRT_IS_RICH_TEXT_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_RICH_TEXT_BUFFER))
#define DRT_RICH_TEXT_BUFFER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_RICH_TEXT_BUFFER, DrtRichTextBufferClass))

typedef struct _DrtRichTextBuffer DrtRichTextBuffer;
typedef struct _DrtRichTextBufferClass DrtRichTextBufferClass;
typedef struct _DrtRichTextBufferPrivate DrtRichTextBufferPrivate;
typedef struct _DrtRichTextBufferTag DrtRichTextBufferTag;
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define __g_queue_free__drt_rich_text_buffer_tag_free0_0(var) ((var == NULL) ? NULL : (var = (_g_queue_free__drt_rich_text_buffer_tag_free0_ (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_markup_parse_context_unref0(var) ((var == NULL) ? NULL : (var = (g_markup_parse_context_unref (var), NULL)))

#define DRT_TYPE_RICH_TEXT_LINK (drt_rich_text_link_get_type ())
#define DRT_RICH_TEXT_LINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_RICH_TEXT_LINK, DrtRichTextLink))
#define DRT_RICH_TEXT_LINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_RICH_TEXT_LINK, DrtRichTextLinkClass))
#define DRT_IS_RICH_TEXT_LINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_RICH_TEXT_LINK))
#define DRT_IS_RICH_TEXT_LINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_RICH_TEXT_LINK))
#define DRT_RICH_TEXT_LINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_RICH_TEXT_LINK, DrtRichTextLinkClass))

typedef struct _DrtRichTextLink DrtRichTextLink;
typedef struct _DrtRichTextLinkClass DrtRichTextLinkClass;
#define _drt_rich_text_buffer_tag_free0(var) ((var == NULL) ? NULL : (var = (drt_rich_text_buffer_tag_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _DrtRichTextLinkPrivate DrtRichTextLinkPrivate;

typedef gchar* (*DrtImageLocator) (const gchar* uri, void* user_data);
struct _DrtRichTextBuffer {
	GtkTextBuffer parent_instance;
	DrtRichTextBufferPrivate * priv;
};

struct _DrtRichTextBufferClass {
	GtkTextBufferClass parent_class;
	void (*image_requested) (DrtRichTextBuffer* self, const gchar* uri, gint width, gint height);
};

struct _DrtRichTextBufferPrivate {
	GdkRGBA* _link_color;
	DrtImageLocator _image_locator;
	gpointer _image_locator_target;
	GDestroyNotify _image_locator_target_destroy_notify;
	GRegex* strip_spaces;
	gboolean insert_new_line;
	gboolean strip_left;
	gboolean in_paragraph;
	gboolean ignore_text;
	GQueue* tag_stack;
	GtkTextTag* tag_bold;
	GtkTextTag* tag_italic;
	GtkTextTag* tag_h1;
	GtkTextTag* tag_h2;
	GtkTextTag* tag_h3;
	GtkTextTag* tag_para;
	GtkTextTag* tag_dl;
	GtkTextTag* tag_dt;
	GtkTextTag* tag_dd;
	GtkTextTag* tag_ul;
	GtkTextTag* tag_li;
};

struct _DrtRichTextBufferTag {
	gchar* name;
	GtkTextMark* mark;
	GtkTextTag* tag;
};

struct _DrtRichTextLink {
	GtkTextTag parent_instance;
	DrtRichTextLinkPrivate * priv;
};

struct _DrtRichTextLinkClass {
	GtkTextTagClass parent_class;
};

struct _DrtRichTextLinkPrivate {
	gchar* _uri;
};


static gpointer drt_rich_text_buffer_parent_class = NULL;
static gpointer drt_rich_text_link_parent_class = NULL;

GType drt_rich_text_buffer_get_type (void) G_GNUC_CONST;
static void drt_rich_text_buffer_tag_free (DrtRichTextBufferTag* self);
#define DRT_RICH_TEXT_BUFFER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRT_TYPE_RICH_TEXT_BUFFER, DrtRichTextBufferPrivate))
enum  {
	DRT_RICH_TEXT_BUFFER_DUMMY_PROPERTY
};
static void _drt_rich_text_buffer_tag_free0_ (gpointer var);
static void _g_queue_free__drt_rich_text_buffer_tag_free0_ (GQueue* self);
#define DRT_RICH_TEXT_BUFFER_TEXT_TAG_HEADING1 "h1"
#define DRT_RICH_TEXT_BUFFER_TEXT_TAG_HEADING2 "h2"
#define DRT_RICH_TEXT_BUFFER_TEXT_TAG_HEADING3 "h3"
#define DRT_RICH_TEXT_BUFFER_TEXT_TAG_PARAGRAPH "p"
#define DRT_RICH_TEXT_BUFFER_TEXT_TAG_BOLD "b"
#define DRT_RICH_TEXT_BUFFER_TEXT_TAG_ITALIC "i"
#define DRT_RICH_TEXT_BUFFER_TEXT_TAG_DEFINITION_LIST "dl"
#define DRT_RICH_TEXT_BUFFER_TEXT_TAG_DEFINED_TERM "dt"
#define DRT_RICH_TEXT_BUFFER_TEXT_TAG_DEFINITION "dd"
#define DRT_RICH_TEXT_BUFFER_TEXT_TAG_UNORDERED_LIST "ul"
#define DRT_RICH_TEXT_BUFFER_TEXT_TAG_LIST_ITEM "li"
#define DRT_RICH_TEXT_BUFFER_IMAGE_PATH "path"
#define DRT_RICH_TEXT_BUFFER_INPUT_TAG_HEADING1 "h1"
#define DRT_RICH_TEXT_BUFFER_INPUT_TAG_HEADING2 "h2"
#define DRT_RICH_TEXT_BUFFER_INPUT_TAG_HEADING3 "h3"
#define DRT_RICH_TEXT_BUFFER_INPUT_TAG_PARA "p"
#define DRT_RICH_TEXT_BUFFER_INPUT_TAG_LINE_BREAK "br"
#define DRT_RICH_TEXT_BUFFER_INPUT_TAG_BOLD "b"
#define DRT_RICH_TEXT_BUFFER_INPUT_TAG_STRONG "strong"
#define DRT_RICH_TEXT_BUFFER_INPUT_TAG_ITALIC "i"
#define DRT_RICH_TEXT_BUFFER_INPUT_TAG_EM "em"
#define DRT_RICH_TEXT_BUFFER_INPUT_TAG_LINK "a"
#define DRT_RICH_TEXT_BUFFER_LINK_TARGET "href"
#define DRT_RICH_TEXT_BUFFER_INPUT_TAG_DL "dl"
#define DRT_RICH_TEXT_BUFFER_INPUT_TAG_DT "dt"
#define DRT_RICH_TEXT_BUFFER_INPUT_TAG_DD "dd"
#define DRT_RICH_TEXT_BUFFER_INPUT_TAG_IMAGE "img"
#define DRT_RICH_TEXT_BUFFER_INPUT_TAG_UL "ul"
#define DRT_RICH_TEXT_BUFFER_INPUT_TAG_LI "li"
static void drt_rich_text_buffer_start_tag (DrtRichTextBuffer* self, GMarkupParseContext* context, const gchar* name, gchar** attr_names, int attr_names_length1, gchar** attr_values, int attr_values_length1, GError** error);
static void _drt_rich_text_buffer_start_tag_gmarkup_parser_start_element_func (GMarkupParseContext* context, const gchar* element_name, gchar** attribute_names, gchar** attribute_values, gpointer self, GError** error);
static void drt_rich_text_buffer_end_tag (DrtRichTextBuffer* self, GMarkupParseContext* context, const gchar* name, GError** error);
static void _drt_rich_text_buffer_end_tag_gmarkup_parser_end_element_func (GMarkupParseContext* context, const gchar* element_name, gpointer self, GError** error);
static void drt_rich_text_buffer_element_text (DrtRichTextBuffer* self, GMarkupParseContext* context, const gchar* text, gsize text_len, GError** error);
static void _drt_rich_text_buffer_element_text_gmarkup_parser_text_func (GMarkupParseContext* context, const gchar* text, gsize text_len, gpointer self, GError** error);
DrtRichTextBuffer* drt_rich_text_buffer_new_with_table (GtkTextTagTable* tag_table);
DrtRichTextBuffer* drt_rich_text_buffer_construct_with_table (GType object_type, GtkTextTagTable* tag_table);
DrtRichTextBuffer* drt_rich_text_buffer_new (void);
DrtRichTextBuffer* drt_rich_text_buffer_construct (GType object_type);
gchar* drt_rich_text_buffer_default_image_locator (DrtRichTextBuffer* self, const gchar* uri);
void drt_rich_text_buffer_load_from_file (DrtRichTextBuffer* self, GFile* doc_file, GError** error);
void drt_rich_text_buffer_clear (DrtRichTextBuffer* self);
void drt_rich_text_buffer_append_from_file (DrtRichTextBuffer* self, GFile* doc_file, GError** error);
void drt_rich_text_buffer_append (DrtRichTextBuffer* self, const gchar* doc_text, GError** error);
void drt_rich_text_buffer_load (DrtRichTextBuffer* self, const gchar* doc_text, GError** error);
static void __lambda8_ (void);
static void ___lambda8__gdestroy_notify (void* data);
static gchar* drt_rich_text_buffer_norm_whitespace (DrtRichTextBuffer* self, const gchar* text);
void drt_rich_text_buffer_append_tag_to_stack (DrtRichTextBuffer* self, const gchar* name, GtkTextTag* text_tag);
GType drt_rich_text_link_get_type (void) G_GNUC_CONST;
static DrtRichTextLink* drt_rich_text_buffer_create_link_tag (DrtRichTextBuffer* self, const gchar* uri);
static DrtRichTextBufferTag* drt_rich_text_buffer_tag_new (const gchar* name, GtkTextMark* mark, GtkTextTag* tag);
void drt_rich_text_buffer_close_tag_from_stack (DrtRichTextBuffer* self, const gchar* name, GError** error);
DrtRichTextLink* drt_rich_text_link_new (const gchar* uri);
DrtRichTextLink* drt_rich_text_link_construct (GType object_type, const gchar* uri);
GdkRGBA* drt_rich_text_buffer_get_link_color (DrtRichTextBuffer* self);
static void drt_rich_text_buffer_find_link_and_set_color (DrtRichTextBuffer* self, GtkTextTag* tag);
static GdkPixbuf* drt_rich_text_buffer_get_missing_image_pixbuf (DrtRichTextBuffer* self);
void drt_rich_text_buffer_insert_image_at_cursor (DrtRichTextBuffer* self, const gchar* path, gint width, gint height);
static gboolean* _bool_dup (gboolean* self);
void drt_rich_text_buffer_insert_pixbuf_at_cursor (DrtRichTextBuffer* self, GdkPixbuf* pixbuf);
void drt_rich_text_buffer_set_link_color (DrtRichTextBuffer* self, GdkRGBA* value);
static GdkRGBA* _gdk_rgba_dup (GdkRGBA* self);
static void _drt_rich_text_buffer_find_link_and_set_color_gtk_text_tag_table_foreach (GtkTextTag* tag, gpointer self);
DrtImageLocator drt_rich_text_buffer_get_image_locator (DrtRichTextBuffer* self, gpointer* result_target);
void drt_rich_text_buffer_set_image_locator (DrtRichTextBuffer* self, DrtImageLocator value, gpointer value_target, GDestroyNotify value_target_destroy_notify);
static void drt_rich_text_buffer_real_image_requested (DrtRichTextBuffer* self, const gchar* uri, gint width, gint height);
static void g_cclosure_user_marshal_VOID__STRING_INT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_BOXED_INT_BOXED_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static GObject * drt_rich_text_buffer_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static gchar* _drt_rich_text_buffer_default_image_locator_drt_image_locator (const gchar* uri, gpointer self);
static void drt_rich_text_buffer_tag_instance_init (DrtRichTextBufferTag * self);
static void drt_rich_text_buffer_finalize (GObject* obj);
static void _vala_drt_rich_text_buffer_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_drt_rich_text_buffer_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
#define DRT_RICH_TEXT_LINK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRT_TYPE_RICH_TEXT_LINK, DrtRichTextLinkPrivate))
enum  {
	DRT_RICH_TEXT_LINK_DUMMY_PROPERTY,
	DRT_RICH_TEXT_LINK_URI
};
const gchar* drt_rich_text_link_get_uri (DrtRichTextLink* self);
void drt_rich_text_link_set_uri (DrtRichTextLink* self, const gchar* value);
static void drt_rich_text_link_finalize (GObject* obj);
static void _vala_drt_rich_text_link_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_drt_rich_text_link_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static gint _vala_array_length (gpointer array);

static const GMarkupParser DRT_RICH_TEXT_BUFFER_parser = {_drt_rich_text_buffer_start_tag_gmarkup_parser_start_element_func, _drt_rich_text_buffer_end_tag_gmarkup_parser_end_element_func, _drt_rich_text_buffer_element_text_gmarkup_parser_text_func, NULL, NULL};

static void _drt_rich_text_buffer_tag_free0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (drt_rich_text_buffer_tag_free (var), NULL));
}


static void _g_queue_free__drt_rich_text_buffer_tag_free0_ (GQueue* self) {
	g_queue_foreach (self, (GFunc) _drt_rich_text_buffer_tag_free0_, NULL);
	g_queue_free (self);
}


static void _drt_rich_text_buffer_start_tag_gmarkup_parser_start_element_func (GMarkupParseContext* context, const gchar* element_name, gchar** attribute_names, gchar** attribute_values, gpointer self, GError** error) {
	drt_rich_text_buffer_start_tag ((DrtRichTextBuffer*) self, context, element_name, attribute_names, _vala_array_length (attribute_names), attribute_values, _vala_array_length (attribute_values), error);
}


static void _drt_rich_text_buffer_end_tag_gmarkup_parser_end_element_func (GMarkupParseContext* context, const gchar* element_name, gpointer self, GError** error) {
	drt_rich_text_buffer_end_tag ((DrtRichTextBuffer*) self, context, element_name, error);
}


static void _drt_rich_text_buffer_element_text_gmarkup_parser_text_func (GMarkupParseContext* context, const gchar* text, gsize text_len, gpointer self, GError** error) {
	drt_rich_text_buffer_element_text ((DrtRichTextBuffer*) self, context, text, text_len, error);
}


/**
 * Creates new Simple Document Buffer.
 * 
 * @param tag_table    Custom text table.!
 */
DrtRichTextBuffer* drt_rich_text_buffer_construct_with_table (GType object_type, GtkTextTagTable* tag_table) {
	DrtRichTextBuffer * self = NULL;
	GtkTextTagTable* _tmp0_ = NULL;
	g_return_val_if_fail (tag_table != NULL, NULL);
	_tmp0_ = tag_table;
	self = (DrtRichTextBuffer*) g_object_new (object_type, "tag-table", _tmp0_, NULL);
	return self;
}


DrtRichTextBuffer* drt_rich_text_buffer_new_with_table (GtkTextTagTable* tag_table) {
	return drt_rich_text_buffer_construct_with_table (DRT_TYPE_RICH_TEXT_BUFFER, tag_table);
}


/**
 * Creates new Simple Document Buffer.
 */
DrtRichTextBuffer* drt_rich_text_buffer_construct (GType object_type) {
	DrtRichTextBuffer * self = NULL;
	self = (DrtRichTextBuffer*) g_object_new (object_type, NULL);
	return self;
}


DrtRichTextBuffer* drt_rich_text_buffer_new (void) {
	return drt_rich_text_buffer_construct (DRT_TYPE_RICH_TEXT_BUFFER);
}


gchar* drt_rich_text_buffer_default_image_locator (DrtRichTextBuffer* self, const gchar* uri) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (uri != NULL, NULL);
	_tmp0_ = uri;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


/**
 * Loads document from file.
 * 
 * @param doc_file    document file to load
 * @throws MarkupError on failure
 */
void drt_rich_text_buffer_load_from_file (DrtRichTextBuffer* self, GFile* doc_file, GError** error) {
	GFile* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (doc_file != NULL);
	drt_rich_text_buffer_clear (self);
	_tmp0_ = doc_file;
	drt_rich_text_buffer_append_from_file (self, _tmp0_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_MARKUP_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


/**
 * Appends content of a document from file.
 * 
 * @param doc_file    document file to load
 * @throws MarkupError on failure
 */
void drt_rich_text_buffer_append_from_file (DrtRichTextBuffer* self, GFile* doc_file, GError** error) {
	gchar* doc_text = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (doc_file != NULL);
	{
		gchar* _tmp0_ = NULL;
		GFile* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		_tmp1_ = doc_file;
		_tmp2_ = drt_system_read_file (_tmp1_, &_inner_error_);
		_tmp0_ = _tmp2_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch5_g_error;
		}
		_tmp3_ = _tmp0_;
		_tmp0_ = NULL;
		_g_free0 (doc_text);
		doc_text = _tmp3_;
		_g_free0 (_tmp0_);
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		GFile* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		GError* _tmp7_ = NULL;
		GError* _tmp8_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp4_ = doc_file;
		_tmp5_ = g_file_get_path (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_error_new (G_MARKUP_ERROR, G_MARKUP_ERROR_INVALID_CONTENT, "Unable to read file %s.", _tmp6_);
		_tmp8_ = _tmp7_;
		_g_free0 (_tmp6_);
		_inner_error_ = _tmp8_;
		_g_error_free0 (e);
		goto __finally5;
	}
	__finally5:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_MARKUP_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (doc_text);
			return;
		} else {
			_g_free0 (doc_text);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	drt_rich_text_buffer_append (self, doc_text, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_MARKUP_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (doc_text);
			return;
		} else {
			_g_free0 (doc_text);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_g_free0 (doc_text);
}


/**
 * Loads a document.
 * 
 * @param doc_text    Content of a document to load.
 * @throws MarkupError on failure
 */
void drt_rich_text_buffer_load (DrtRichTextBuffer* self, const gchar* doc_text, GError** error) {
	const gchar* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (doc_text != NULL);
	drt_rich_text_buffer_clear (self);
	_tmp0_ = doc_text;
	drt_rich_text_buffer_append (self, _tmp0_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_MARKUP_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


/**
 * Appends content of a document.
 * 
 * @param doc_text    Content of a document to load.
 * @throws MarkupError on failure
 */
static void __lambda8_ (void) {
}


static void ___lambda8__gdestroy_notify (void* data) {
	__lambda8_ ();
}


void drt_rich_text_buffer_append (DrtRichTextBuffer* self, const gchar* doc_text, GError** error) {
	GMarkupParseContext* context = NULL;
	GMarkupParseContext* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (doc_text != NULL);
	_tmp0_ = g_markup_parse_context_new (&DRT_RICH_TEXT_BUFFER_parser, 0, self, ___lambda8__gdestroy_notify);
	context = _tmp0_;
	_tmp1_ = doc_text;
	g_markup_parse_context_parse (context, _tmp1_, (gssize) -1, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_MARKUP_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_markup_parse_context_unref0 (context);
			return;
		} else {
			_g_markup_parse_context_unref0 (context);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_g_markup_parse_context_unref0 (context);
}


static gchar* drt_rich_text_buffer_norm_whitespace (DrtRichTextBuffer* self, const gchar* text) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (text != NULL, NULL);
	{
		gchar* _tmp0_ = NULL;
		GRegex* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		_tmp1_ = self->priv->strip_spaces;
		_tmp2_ = text;
		_tmp3_ = g_regex_replace (_tmp1_, _tmp2_, (gssize) -1, 0, " ", 0, &_inner_error_);
		_tmp0_ = _tmp3_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch6_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp4_ = _tmp0_;
		_tmp0_ = NULL;
		result = _tmp4_;
		_g_free0 (_tmp0_);
		return result;
	}
	goto __finally6;
	__catch6_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		g_warning ("RichTextBuffer.vala:316: Unable to strip spaces, Regex failed: %s", _tmp6_);
		_tmp7_ = text;
		_tmp8_ = g_strdup (_tmp7_);
		result = _tmp8_;
		_g_error_free0 (e);
		return result;
	}
	__finally6:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return NULL;
}


/**
 * Clears buffer and resets parser.
 */
void drt_rich_text_buffer_clear (DrtRichTextBuffer* self) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GQueue* _tmp2_ = NULL;
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	GtkTextIter _tmp3_ = {0};
	GtkTextIter _tmp4_ = {0};
	g_return_if_fail (self != NULL);
	self->priv->insert_new_line = FALSE;
	_tmp0_ = self->priv->insert_new_line;
	self->priv->strip_left = _tmp0_;
	_tmp1_ = self->priv->strip_left;
	self->priv->in_paragraph = _tmp1_;
	_tmp2_ = self->priv->tag_stack;
	g_queue_clear (_tmp2_);
	gtk_text_buffer_get_bounds ((GtkTextBuffer*) self, &_tmp3_, &_tmp4_);
	start = _tmp3_;
	end = _tmp4_;
	gtk_text_buffer_delete ((GtkTextBuffer*) self, &start, &end);
}


static void drt_rich_text_buffer_start_tag (DrtRichTextBuffer* self, GMarkupParseContext* context, const gchar* name, gchar** attr_names, int attr_names_length1, gchar** attr_values, int attr_values_length1, GError** error) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GQuark _tmp3_ = 0U;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	g_return_if_fail (name != NULL);
	_tmp0_ = name;
	_tmp1_ = _tmp0_;
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
	if ((((((_tmp3_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_HEADING1)) || (_tmp3_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_HEADING2))) || (_tmp3_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_HEADING3))) || (_tmp3_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_PARA))) || (_tmp3_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_DL))) || (_tmp3_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_UL))) {
		switch (0) {
			default:
			{
				gboolean _tmp4_ = FALSE;
				_tmp4_ = self->priv->in_paragraph;
				if (!_tmp4_) {
					gboolean _tmp5_ = FALSE;
					const gchar* _tmp6_ = NULL;
					const gchar* _tmp7_ = NULL;
					GQuark _tmp9_ = 0U;
					_tmp5_ = self->priv->insert_new_line;
					if (_tmp5_) {
						self->priv->insert_new_line = FALSE;
						gtk_text_buffer_insert_at_cursor ((GtkTextBuffer*) self, "\n", -1);
					}
					self->priv->in_paragraph = TRUE;
					self->priv->strip_left = TRUE;
					_tmp6_ = name;
					_tmp7_ = _tmp6_;
					_tmp9_ = (NULL == _tmp7_) ? 0 : g_quark_from_string (_tmp7_);
					if (_tmp9_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_HEADING1)) {
						switch (0) {
							default:
							{
								const gchar* _tmp10_ = NULL;
								GtkTextTag* _tmp11_ = NULL;
								_tmp10_ = name;
								_tmp11_ = self->priv->tag_h1;
								drt_rich_text_buffer_append_tag_to_stack (self, _tmp10_, _tmp11_);
								break;
							}
						}
					} else if (_tmp9_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_HEADING2)) {
						switch (0) {
							default:
							{
								const gchar* _tmp12_ = NULL;
								GtkTextTag* _tmp13_ = NULL;
								_tmp12_ = name;
								_tmp13_ = self->priv->tag_h2;
								drt_rich_text_buffer_append_tag_to_stack (self, _tmp12_, _tmp13_);
								break;
							}
						}
					} else if (_tmp9_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_HEADING3)) {
						switch (0) {
							default:
							{
								const gchar* _tmp14_ = NULL;
								GtkTextTag* _tmp15_ = NULL;
								_tmp14_ = name;
								_tmp15_ = self->priv->tag_h3;
								drt_rich_text_buffer_append_tag_to_stack (self, _tmp14_, _tmp15_);
								break;
							}
						}
					} else if (_tmp9_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_DL)) {
						switch (0) {
							default:
							{
								const gchar* _tmp16_ = NULL;
								GtkTextTag* _tmp17_ = NULL;
								self->priv->ignore_text = TRUE;
								_tmp16_ = name;
								_tmp17_ = self->priv->tag_dl;
								drt_rich_text_buffer_append_tag_to_stack (self, _tmp16_, _tmp17_);
								break;
							}
						}
					} else if (_tmp9_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_UL)) {
						switch (0) {
							default:
							{
								const gchar* _tmp18_ = NULL;
								GtkTextTag* _tmp19_ = NULL;
								self->priv->ignore_text = TRUE;
								_tmp18_ = name;
								_tmp19_ = self->priv->tag_ul;
								drt_rich_text_buffer_append_tag_to_stack (self, _tmp18_, _tmp19_);
								break;
							}
						}
					} else {
						switch (0) {
							default:
							{
								const gchar* _tmp20_ = NULL;
								GtkTextTag* _tmp21_ = NULL;
								_tmp20_ = name;
								_tmp21_ = self->priv->tag_para;
								drt_rich_text_buffer_append_tag_to_stack (self, _tmp20_, _tmp21_);
								break;
							}
						}
					}
				} else {
					const gchar* _tmp22_ = NULL;
					_tmp22_ = name;
					g_debug ("RichTextBuffer.vala:379: Ignored start tag: %s", _tmp22_);
				}
				break;
			}
		}
	} else if (_tmp3_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_LINE_BREAK)) {
		switch (0) {
			default:
			{
				gtk_text_buffer_insert_at_cursor ((GtkTextBuffer*) self, "\n", -1);
				self->priv->strip_left = TRUE;
				break;
			}
		}
	} else if ((_tmp3_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_BOLD)) || (_tmp3_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_STRONG))) {
		switch (0) {
			default:
			{
				gboolean _tmp23_ = FALSE;
				_tmp23_ = self->priv->in_paragraph;
				if (_tmp23_) {
					const gchar* _tmp24_ = NULL;
					GtkTextTag* _tmp25_ = NULL;
					_tmp24_ = name;
					_tmp25_ = self->priv->tag_bold;
					drt_rich_text_buffer_append_tag_to_stack (self, _tmp24_, _tmp25_);
				} else {
					const gchar* _tmp26_ = NULL;
					_tmp26_ = name;
					g_debug ("RichTextBuffer.vala:394: Ignored start tag: %s", _tmp26_);
				}
				break;
			}
		}
	} else if ((_tmp3_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_ITALIC)) || (_tmp3_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_EM))) {
		switch (0) {
			default:
			{
				gboolean _tmp27_ = FALSE;
				_tmp27_ = self->priv->in_paragraph;
				if (_tmp27_) {
					const gchar* _tmp28_ = NULL;
					GtkTextTag* _tmp29_ = NULL;
					_tmp28_ = name;
					_tmp29_ = self->priv->tag_italic;
					drt_rich_text_buffer_append_tag_to_stack (self, _tmp28_, _tmp29_);
				} else {
					const gchar* _tmp30_ = NULL;
					_tmp30_ = name;
					g_debug ("RichTextBuffer.vala:405: Ignored start tag: %s", _tmp30_);
				}
				break;
			}
		}
	} else if (_tmp3_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_LINK)) {
		switch (0) {
			default:
			{
				gboolean _tmp31_ = FALSE;
				_tmp31_ = self->priv->in_paragraph;
				if (_tmp31_) {
					gint i = 0;
					gint _tmp39_ = 0;
					gchar** _tmp40_ = NULL;
					gint _tmp40__length1 = 0;
					gchar* uri = NULL;
					gchar** _tmp42_ = NULL;
					gint _tmp42__length1 = 0;
					gint _tmp43_ = 0;
					const gchar* _tmp44_ = NULL;
					gchar* _tmp45_ = NULL;
					const gchar* _tmp46_ = NULL;
					const gchar* _tmp47_ = NULL;
					DrtRichTextLink* _tmp48_ = NULL;
					{
						gboolean _tmp32_ = FALSE;
						i = 0;
						_tmp32_ = TRUE;
						while (TRUE) {
							gint _tmp34_ = 0;
							gchar** _tmp35_ = NULL;
							gint _tmp35__length1 = 0;
							gchar** _tmp36_ = NULL;
							gint _tmp36__length1 = 0;
							gint _tmp37_ = 0;
							const gchar* _tmp38_ = NULL;
							if (!_tmp32_) {
								gint _tmp33_ = 0;
								_tmp33_ = i;
								i = _tmp33_ + 1;
							}
							_tmp32_ = FALSE;
							_tmp34_ = i;
							_tmp35_ = attr_names;
							_tmp35__length1 = attr_names_length1;
							if (!(_tmp34_ < _tmp35__length1)) {
								break;
							}
							_tmp36_ = attr_names;
							_tmp36__length1 = attr_names_length1;
							_tmp37_ = i;
							_tmp38_ = _tmp36_[_tmp37_];
							if (g_strcmp0 (_tmp38_, DRT_RICH_TEXT_BUFFER_LINK_TARGET) == 0) {
								break;
							}
						}
					}
					_tmp39_ = i;
					_tmp40_ = attr_values;
					_tmp40__length1 = attr_values_length1;
					if (_tmp39_ >= _tmp40__length1) {
						GError* _tmp41_ = NULL;
						_tmp41_ = g_error_new (G_MARKUP_ERROR, G_MARKUP_ERROR_MISSING_ATTRIBUTE, "Missing attribute '%s' for element '%s'.", DRT_RICH_TEXT_BUFFER_LINK_TARGET, DRT_RICH_TEXT_BUFFER_INPUT_TAG_LINK);
						_inner_error_ = _tmp41_;
						if (_inner_error_->domain == G_MARKUP_ERROR) {
							g_propagate_error (error, _inner_error_);
							return;
						} else {
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return;
						}
					}
					_tmp42_ = attr_values;
					_tmp42__length1 = attr_values_length1;
					_tmp43_ = i;
					_tmp44_ = _tmp42_[_tmp43_];
					_tmp45_ = g_strdup (_tmp44_);
					uri = _tmp45_;
					_tmp46_ = name;
					_tmp47_ = uri;
					_tmp48_ = drt_rich_text_buffer_create_link_tag (self, _tmp47_);
					drt_rich_text_buffer_append_tag_to_stack (self, _tmp46_, (GtkTextTag*) _tmp48_);
					_g_free0 (uri);
				} else {
					const gchar* _tmp49_ = NULL;
					_tmp49_ = name;
					g_debug ("RichTextBuffer.vala:426: Ignored start tag: %s", _tmp49_);
				}
				break;
			}
		}
	} else if (_tmp3_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_DT)) {
		switch (0) {
			default:
			{
				gboolean _tmp50_ = FALSE;
				_tmp50_ = self->priv->in_paragraph;
				if (_tmp50_) {
					const gchar* _tmp51_ = NULL;
					GtkTextTag* _tmp52_ = NULL;
					_tmp51_ = name;
					_tmp52_ = self->priv->tag_dt;
					drt_rich_text_buffer_append_tag_to_stack (self, _tmp51_, _tmp52_);
					self->priv->ignore_text = FALSE;
				} else {
					const gchar* _tmp53_ = NULL;
					_tmp53_ = name;
					g_debug ("RichTextBuffer.vala:437: Ignored start tag: %s", _tmp53_);
				}
				break;
			}
		}
	} else if (_tmp3_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_DD)) {
		switch (0) {
			default:
			{
				gboolean _tmp54_ = FALSE;
				_tmp54_ = self->priv->in_paragraph;
				if (_tmp54_) {
					const gchar* _tmp55_ = NULL;
					GtkTextTag* _tmp56_ = NULL;
					_tmp55_ = name;
					_tmp56_ = self->priv->tag_dd;
					drt_rich_text_buffer_append_tag_to_stack (self, _tmp55_, _tmp56_);
					self->priv->ignore_text = FALSE;
				} else {
					const gchar* _tmp57_ = NULL;
					_tmp57_ = name;
					g_debug ("RichTextBuffer.vala:448: Ignored start tag: %s", _tmp57_);
				}
				break;
			}
		}
	} else if (_tmp3_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_LI)) {
		switch (0) {
			default:
			{
				gboolean _tmp58_ = FALSE;
				_tmp58_ = self->priv->in_paragraph;
				if (_tmp58_) {
					const gchar* _tmp59_ = NULL;
					GtkTextTag* _tmp60_ = NULL;
					_tmp59_ = name;
					_tmp60_ = self->priv->tag_li;
					drt_rich_text_buffer_append_tag_to_stack (self, _tmp59_, _tmp60_);
					gtk_text_buffer_insert_at_cursor ((GtkTextBuffer*) self, "• ", -1);
					self->priv->ignore_text = FALSE;
				} else {
					const gchar* _tmp61_ = NULL;
					_tmp61_ = name;
					g_debug ("RichTextBuffer.vala:460: Ignored start tag: %s", _tmp61_);
				}
				break;
			}
		}
	} else if (_tmp3_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_IMAGE)) {
		switch (0) {
			default:
			{
				gchar* src = NULL;
				gint width = 0;
				gint height = 0;
				const gchar* _tmp84_ = NULL;
				src = NULL;
				width = -1;
				height = -1;
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp62_ = FALSE;
						_tmp62_ = TRUE;
						while (TRUE) {
							gint _tmp64_ = 0;
							gchar** _tmp65_ = NULL;
							gint _tmp65__length1 = 0;
							gchar** _tmp66_ = NULL;
							gint _tmp66__length1 = 0;
							gint _tmp67_ = 0;
							const gchar* _tmp68_ = NULL;
							const gchar* _tmp69_ = NULL;
							GQuark _tmp71_ = 0U;
							static GQuark _tmp70_label0 = 0;
							static GQuark _tmp70_label1 = 0;
							static GQuark _tmp70_label2 = 0;
							if (!_tmp62_) {
								gint _tmp63_ = 0;
								_tmp63_ = j;
								j = _tmp63_ + 1;
							}
							_tmp62_ = FALSE;
							_tmp64_ = j;
							_tmp65_ = attr_names;
							_tmp65__length1 = attr_names_length1;
							if (!(_tmp64_ < _tmp65__length1)) {
								break;
							}
							_tmp66_ = attr_names;
							_tmp66__length1 = attr_names_length1;
							_tmp67_ = j;
							_tmp68_ = _tmp66_[_tmp67_];
							_tmp69_ = _tmp68_;
							_tmp71_ = (NULL == _tmp69_) ? 0 : g_quark_from_string (_tmp69_);
							if (_tmp71_ == ((0 != _tmp70_label0) ? _tmp70_label0 : (_tmp70_label0 = g_quark_from_static_string ("src")))) {
								switch (0) {
									default:
									{
										gchar** _tmp72_ = NULL;
										gint _tmp72__length1 = 0;
										gint _tmp73_ = 0;
										const gchar* _tmp74_ = NULL;
										gchar* _tmp75_ = NULL;
										_tmp72_ = attr_values;
										_tmp72__length1 = attr_values_length1;
										_tmp73_ = j;
										_tmp74_ = _tmp72_[_tmp73_];
										_tmp75_ = g_strdup (_tmp74_);
										_g_free0 (src);
										src = _tmp75_;
										break;
									}
								}
							} else if (_tmp71_ == ((0 != _tmp70_label1) ? _tmp70_label1 : (_tmp70_label1 = g_quark_from_static_string ("width")))) {
								switch (0) {
									default:
									{
										gchar** _tmp76_ = NULL;
										gint _tmp76__length1 = 0;
										gint _tmp77_ = 0;
										const gchar* _tmp78_ = NULL;
										gint _tmp79_ = 0;
										_tmp76_ = attr_values;
										_tmp76__length1 = attr_values_length1;
										_tmp77_ = j;
										_tmp78_ = _tmp76_[_tmp77_];
										_tmp79_ = atoi (_tmp78_);
										width = _tmp79_;
										break;
									}
								}
							} else if (_tmp71_ == ((0 != _tmp70_label2) ? _tmp70_label2 : (_tmp70_label2 = g_quark_from_static_string ("height")))) {
								switch (0) {
									default:
									{
										gchar** _tmp80_ = NULL;
										gint _tmp80__length1 = 0;
										gint _tmp81_ = 0;
										const gchar* _tmp82_ = NULL;
										gint _tmp83_ = 0;
										_tmp80_ = attr_values;
										_tmp80__length1 = attr_values_length1;
										_tmp81_ = j;
										_tmp82_ = _tmp80_[_tmp81_];
										_tmp83_ = atoi (_tmp82_);
										height = _tmp83_;
										break;
									}
								}
							}
						}
					}
				}
				_tmp84_ = src;
				if (_tmp84_ != NULL) {
					const gchar* _tmp85_ = NULL;
					gint _tmp86_ = 0;
					gint _tmp87_ = 0;
					_tmp85_ = src;
					_tmp86_ = width;
					_tmp87_ = height;
					g_signal_emit_by_name (self, "image-requested", _tmp85_, _tmp86_, _tmp87_);
				}
				_g_free0 (src);
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				gboolean _tmp88_ = FALSE;
				_tmp88_ = self->priv->in_paragraph;
				if (_tmp88_) {
					const gchar* _tmp89_ = NULL;
					gchar** _tmp90_ = NULL;
					gint _tmp90__length1 = 0;
					gchar** _tmp91_ = NULL;
					gint _tmp91__length1 = 0;
					_tmp89_ = name;
					_tmp90_ = attr_names;
					_tmp90__length1 = attr_names_length1;
					_tmp91_ = attr_values;
					_tmp91__length1 = attr_values_length1;
					g_signal_emit_by_name (self, "unknown-tag-opened", _tmp89_, _tmp90_, _tmp90__length1, _tmp91_, _tmp91__length1);
				} else {
					const gchar* _tmp92_ = NULL;
					_tmp92_ = name;
					g_debug ("RichTextBuffer.vala:494: Ignored start tag: %s", _tmp92_);
				}
				break;
			}
		}
	}
}


/**
 * Appends tag to a stack at current position.
 * 
 * @param name        tag name
 * @param text_tag    tag format
 */
void drt_rich_text_buffer_append_tag_to_stack (DrtRichTextBuffer* self, const gchar* name, GtkTextTag* text_tag) {
	GtkTextIter iter = {0};
	GtkTextIter _tmp0_ = {0};
	DrtRichTextBufferTag* tag = NULL;
	const gchar* _tmp1_ = NULL;
	GtkTextIter _tmp2_ = {0};
	GtkTextMark* _tmp3_ = NULL;
	GtkTextTag* _tmp4_ = NULL;
	DrtRichTextBufferTag* _tmp5_ = NULL;
	GQueue* _tmp6_ = NULL;
	DrtRichTextBufferTag* _tmp7_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (text_tag != NULL);
	gtk_text_buffer_get_end_iter ((GtkTextBuffer*) self, &_tmp0_);
	iter = _tmp0_;
	_tmp1_ = name;
	_tmp2_ = iter;
	_tmp3_ = gtk_text_buffer_create_mark ((GtkTextBuffer*) self, NULL, &_tmp2_, TRUE);
	_tmp4_ = text_tag;
	_tmp5_ = drt_rich_text_buffer_tag_new (_tmp1_, _tmp3_, _tmp4_);
	tag = _tmp5_;
	_tmp6_ = self->priv->tag_stack;
	_tmp7_ = tag;
	tag = NULL;
	g_queue_push_tail (_tmp6_, _tmp7_);
	_drt_rich_text_buffer_tag_free0 (tag);
}


static void drt_rich_text_buffer_end_tag (DrtRichTextBuffer* self, GMarkupParseContext* context, const gchar* name, GError** error) {
	gboolean _tmp0_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	g_return_if_fail (name != NULL);
	_tmp0_ = self->priv->in_paragraph;
	if (_tmp0_) {
		const gchar* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		GQuark _tmp4_ = 0U;
		_tmp1_ = name;
		_tmp2_ = _tmp1_;
		_tmp4_ = (NULL == _tmp2_) ? 0 : g_quark_from_string (_tmp2_);
		if ((((_tmp4_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_HEADING1)) || (_tmp4_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_HEADING2))) || (_tmp4_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_HEADING3))) || (_tmp4_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_PARA))) {
			switch (0) {
				default:
				{
					const gchar* _tmp5_ = NULL;
					gtk_text_buffer_insert_at_cursor ((GtkTextBuffer*) self, "\n", -1);
					self->priv->insert_new_line = TRUE;
					self->priv->in_paragraph = FALSE;
					_tmp5_ = name;
					drt_rich_text_buffer_close_tag_from_stack (self, _tmp5_, &_inner_error_);
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == G_MARKUP_ERROR) {
							g_propagate_error (error, _inner_error_);
							return;
						} else {
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return;
						}
					}
					self->priv->ignore_text = FALSE;
					break;
				}
			}
		} else if ((_tmp4_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_DL)) || (_tmp4_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_UL))) {
			switch (0) {
				default:
				{
					const gchar* _tmp6_ = NULL;
					self->priv->insert_new_line = TRUE;
					self->priv->in_paragraph = FALSE;
					_tmp6_ = name;
					drt_rich_text_buffer_close_tag_from_stack (self, _tmp6_, &_inner_error_);
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == G_MARKUP_ERROR) {
							g_propagate_error (error, _inner_error_);
							return;
						} else {
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return;
						}
					}
					self->priv->ignore_text = FALSE;
					break;
				}
			}
		} else if (((((_tmp4_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_BOLD)) || (_tmp4_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_STRONG))) || (_tmp4_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_ITALIC))) || (_tmp4_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_EM))) || (_tmp4_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_LINK))) {
			switch (0) {
				default:
				{
					const gchar* _tmp7_ = NULL;
					_tmp7_ = name;
					drt_rich_text_buffer_close_tag_from_stack (self, _tmp7_, &_inner_error_);
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == G_MARKUP_ERROR) {
							g_propagate_error (error, _inner_error_);
							return;
						} else {
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return;
						}
					}
					break;
				}
			}
		} else if ((_tmp4_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_DT)) || (_tmp4_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_DD))) {
			switch (0) {
				default:
				{
					const gchar* _tmp8_ = NULL;
					_tmp8_ = name;
					drt_rich_text_buffer_close_tag_from_stack (self, _tmp8_, &_inner_error_);
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == G_MARKUP_ERROR) {
							g_propagate_error (error, _inner_error_);
							return;
						} else {
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return;
						}
					}
					gtk_text_buffer_insert_at_cursor ((GtkTextBuffer*) self, "\n", -1);
					self->priv->ignore_text = TRUE;
					break;
				}
			}
		} else if (_tmp4_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_LI)) {
			switch (0) {
				default:
				{
					const gchar* _tmp9_ = NULL;
					_tmp9_ = name;
					drt_rich_text_buffer_close_tag_from_stack (self, _tmp9_, &_inner_error_);
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == G_MARKUP_ERROR) {
							g_propagate_error (error, _inner_error_);
							return;
						} else {
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return;
						}
					}
					gtk_text_buffer_insert_at_cursor ((GtkTextBuffer*) self, "\n", -1);
					self->priv->ignore_text = TRUE;
					break;
				}
			}
		} else if ((_tmp4_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_IMAGE)) || (_tmp4_ == g_quark_from_string (DRT_RICH_TEXT_BUFFER_INPUT_TAG_LINE_BREAK))) {
			switch (0) {
				default:
				{
					break;
				}
			}
		} else {
			switch (0) {
				default:
				{
					const gchar* _tmp10_ = NULL;
					_tmp10_ = name;
					g_signal_emit_by_name (self, "unknown-tag-closed", _tmp10_);
					break;
				}
			}
		}
	} else {
		const gchar* _tmp11_ = NULL;
		_tmp11_ = name;
		g_debug ("RichTextBuffer.vala:566: Ignored end tag: %s", _tmp11_);
	}
}


/**
 * Closes tag from stack and applies its formating.
 * 
 * @param name    tag name
 * @throws MarkupError when name doesn't match nme of the last opened tag.
 */
static const gchar* string_to_string (const gchar* self) {
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}


void drt_rich_text_buffer_close_tag_from_stack (DrtRichTextBuffer* self, const gchar* name, GError** error) {
	DrtRichTextBufferTag* tag = NULL;
	GQueue* _tmp0_ = NULL;
	gpointer _tmp1_ = NULL;
	DrtRichTextBufferTag* _tmp2_ = NULL;
	DrtRichTextBufferTag* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	DrtRichTextBufferTag* _tmp18_ = NULL;
	GtkTextMark* _tmp19_ = NULL;
	GtkTextIter _tmp20_ = {0};
	GtkTextIter _tmp21_ = {0};
	DrtRichTextBufferTag* _tmp22_ = NULL;
	GtkTextTag* _tmp23_ = NULL;
	GtkTextIter _tmp24_ = {0};
	GtkTextIter _tmp25_ = {0};
	DrtRichTextBufferTag* _tmp26_ = NULL;
	GtkTextMark* _tmp27_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	_tmp0_ = self->priv->tag_stack;
	_tmp1_ = g_queue_pop_tail (_tmp0_);
	tag = (DrtRichTextBufferTag*) _tmp1_;
	_tmp2_ = tag;
	if (_tmp2_ == NULL) {
		GError* _tmp3_ = NULL;
		_tmp3_ = g_error_new_literal (G_MARKUP_ERROR, G_MARKUP_ERROR_PARSE, "Attempt to close $(name), but not tag is open.");
		_inner_error_ = _tmp3_;
		if (_inner_error_->domain == G_MARKUP_ERROR) {
			g_propagate_error (error, _inner_error_);
			_drt_rich_text_buffer_tag_free0 (tag);
			return;
		} else {
			_drt_rich_text_buffer_tag_free0 (tag);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp4_ = tag;
	_tmp5_ = _tmp4_->name;
	_tmp6_ = name;
	if (g_strcmp0 (_tmp5_, _tmp6_) != 0) {
		GQueue* _tmp7_ = NULL;
		DrtRichTextBufferTag* _tmp8_ = NULL;
		DrtRichTextBufferTag* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		GError* _tmp16_ = NULL;
		GError* _tmp17_ = NULL;
		_tmp7_ = self->priv->tag_stack;
		_tmp8_ = tag;
		tag = NULL;
		g_queue_push_tail (_tmp7_, _tmp8_);
		_tmp9_ = tag;
		_tmp10_ = _tmp9_->name;
		_tmp11_ = string_to_string (_tmp10_);
		_tmp12_ = name;
		_tmp13_ = string_to_string (_tmp12_);
		_tmp14_ = g_strconcat ("Expected tag ", _tmp11_, ", found ", _tmp13_, NULL);
		_tmp15_ = _tmp14_;
		_tmp16_ = g_error_new_literal (G_MARKUP_ERROR, G_MARKUP_ERROR_PARSE, _tmp15_);
		_tmp17_ = _tmp16_;
		_g_free0 (_tmp15_);
		_inner_error_ = _tmp17_;
		if (_inner_error_->domain == G_MARKUP_ERROR) {
			g_propagate_error (error, _inner_error_);
			_drt_rich_text_buffer_tag_free0 (tag);
			return;
		} else {
			_drt_rich_text_buffer_tag_free0 (tag);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp18_ = tag;
	_tmp19_ = _tmp18_->mark;
	gtk_text_buffer_get_iter_at_mark ((GtkTextBuffer*) self, &_tmp20_, _tmp19_);
	start = _tmp20_;
	gtk_text_buffer_get_end_iter ((GtkTextBuffer*) self, &_tmp21_);
	end = _tmp21_;
	_tmp22_ = tag;
	_tmp23_ = _tmp22_->tag;
	_tmp24_ = start;
	_tmp25_ = end;
	gtk_text_buffer_apply_tag ((GtkTextBuffer*) self, _tmp23_, &_tmp24_, &_tmp25_);
	_tmp26_ = tag;
	_tmp27_ = _tmp26_->mark;
	gtk_text_buffer_delete_mark ((GtkTextBuffer*) self, _tmp27_);
	_drt_rich_text_buffer_tag_free0 (tag);
}


static gchar* string_chug (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strchug (_tmp1_);
	result = _result_;
	return result;
}


static void drt_rich_text_buffer_element_text (DrtRichTextBuffer* self, GMarkupParseContext* context, const gchar* text, gsize text_len, GError** error) {
	const gchar* _tmp0_ = NULL;
	gchar* _result_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp11_ = NULL;
	gboolean _tmp12_ = FALSE;
	const gchar* _tmp13_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = text;
	if (g_strcmp0 (_tmp0_, "") == 0) {
		return;
	}
	_tmp1_ = text;
	_tmp2_ = drt_rich_text_buffer_norm_whitespace (self, _tmp1_);
	_result_ = _tmp2_;
	_tmp3_ = _result_;
	if (g_strcmp0 (_tmp3_, " ") == 0) {
		_g_free0 (_result_);
		return;
	}
	_tmp5_ = self->priv->ignore_text;
	if (_tmp5_) {
		_tmp4_ = TRUE;
	} else {
		gboolean _tmp6_ = FALSE;
		_tmp6_ = self->priv->in_paragraph;
		_tmp4_ = !_tmp6_;
	}
	if (_tmp4_) {
		const gchar* _tmp7_ = NULL;
		_tmp7_ = text;
		g_warning ("RichTextBuffer.vala:606: Ignored text: '%s'", _tmp7_);
		_g_free0 (_result_);
		return;
	}
	_tmp8_ = self->priv->strip_left;
	if (_tmp8_) {
		const gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		_tmp9_ = _result_;
		_tmp10_ = string_chug (_tmp9_);
		_g_free0 (_result_);
		_result_ = _tmp10_;
		self->priv->strip_left = FALSE;
	}
	_tmp11_ = _result_;
	_tmp12_ = g_str_has_suffix (_tmp11_, " ");
	if (_tmp12_) {
		self->priv->strip_left = TRUE;
	}
	_tmp13_ = _result_;
	gtk_text_buffer_insert_at_cursor ((GtkTextBuffer*) self, _tmp13_, -1);
	_g_free0 (_result_);
}


static DrtRichTextLink* drt_rich_text_buffer_create_link_tag (DrtRichTextBuffer* self, const gchar* uri) {
	DrtRichTextLink* result = NULL;
	DrtRichTextLink* tag = NULL;
	const gchar* _tmp0_ = NULL;
	DrtRichTextLink* _tmp1_ = NULL;
	GtkTextTagTable* _tmp2_ = NULL;
	GtkTextTagTable* _tmp3_ = NULL;
	DrtRichTextLink* _tmp4_ = NULL;
	GdkRGBA* _tmp5_ = NULL;
	GdkRGBA* _tmp6_ = NULL;
	DrtRichTextLink* weak_tag = NULL;
	DrtRichTextLink* _tmp10_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (uri != NULL, NULL);
	_tmp0_ = uri;
	_tmp1_ = drt_rich_text_link_new (_tmp0_);
	tag = _tmp1_;
	_tmp2_ = gtk_text_buffer_get_tag_table ((GtkTextBuffer*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = tag;
	gtk_text_tag_table_add (_tmp3_, (GtkTextTag*) _tmp4_);
	_tmp5_ = drt_rich_text_buffer_get_link_color (self);
	_tmp6_ = _tmp5_;
	if (_tmp6_ != NULL) {
		DrtRichTextLink* _tmp7_ = NULL;
		GdkRGBA* _tmp8_ = NULL;
		GdkRGBA* _tmp9_ = NULL;
		_tmp7_ = tag;
		_tmp8_ = drt_rich_text_buffer_get_link_color (self);
		_tmp9_ = _tmp8_;
		g_object_set ((GtkTextTag*) _tmp7_, "foreground-rgba", _tmp9_, NULL);
	}
	_tmp10_ = tag;
	weak_tag = _tmp10_;
	result = weak_tag;
	_g_object_unref0 (tag);
	return result;
}


static void drt_rich_text_buffer_find_link_and_set_color (DrtRichTextBuffer* self, GtkTextTag* tag) {
	GtkTextTag* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (tag != NULL);
	_tmp0_ = tag;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, DRT_TYPE_RICH_TEXT_LINK)) {
		GtkTextTag* _tmp1_ = NULL;
		GdkRGBA* _tmp2_ = NULL;
		GdkRGBA* _tmp3_ = NULL;
		_tmp1_ = tag;
		_tmp2_ = drt_rich_text_buffer_get_link_color (self);
		_tmp3_ = _tmp2_;
		g_object_set (_tmp1_, "foreground-rgba", _tmp3_, NULL);
	}
}


static GdkPixbuf* drt_rich_text_buffer_get_missing_image_pixbuf (DrtRichTextBuffer* self) {
	GdkPixbuf* result = NULL;
	GtkOffscreenWindow* widget = NULL;
	GtkOffscreenWindow* _tmp0_ = NULL;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = (GtkOffscreenWindow*) gtk_offscreen_window_new ();
	g_object_ref_sink (_tmp0_);
	widget = _tmp0_;
	_tmp1_ = gtk_widget_render_icon ((GtkWidget*) widget, GTK_STOCK_MISSING_IMAGE, GTK_ICON_SIZE_DIALOG, NULL);
	pixbuf = _tmp1_;
	gtk_widget_destroy ((GtkWidget*) widget);
	result = pixbuf;
	_g_object_unref0 (widget);
	return result;
}


/**
 * Inserts image at cursor
 * 
 * @param path      path to image file (missing image icon will be shown if path is null)
 * @param width     image width (-1 to use original width)
 * @param height    image height (-1 to use original height)
 */
static gboolean* _bool_dup (gboolean* self) {
	gboolean* dup;
	dup = g_new0 (gboolean, 1);
	memcpy (dup, self, sizeof (gboolean));
	return dup;
}


static gpointer __bool_dup0 (gpointer self) {
	return self ? _bool_dup (self) : NULL;
}


void drt_rich_text_buffer_insert_image_at_cursor (DrtRichTextBuffer* self, const gchar* path, gint width, gint height) {
	GdkPixbuf* pixbuf = NULL;
	gboolean real_size = FALSE;
	gint real_width = 0;
	gint real_height = 0;
	const gchar* _tmp0_ = NULL;
	GdkPixbuf* _tmp35_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	real_size = TRUE;
	real_width = -1;
	real_height = -1;
	_tmp0_ = path;
	if (_tmp0_ == NULL) {
		GdkPixbuf* _tmp1_ = NULL;
		_tmp1_ = drt_rich_text_buffer_get_missing_image_pixbuf (self);
		_g_object_unref0 (pixbuf);
		pixbuf = _tmp1_;
	} else {
		{
			GdkPixbuf* _tmp2_ = NULL;
			const gchar* _tmp3_ = NULL;
			gint _tmp4_ = 0;
			gint _tmp5_ = 0;
			GdkPixbuf* _tmp6_ = NULL;
			GdkPixbuf* _tmp7_ = NULL;
			GdkPixbuf* _tmp8_ = NULL;
			const gchar* _tmp9_ = NULL;
			gchar* _tmp10_ = NULL;
			gboolean _tmp11_ = FALSE;
			gboolean _tmp12_ = FALSE;
			gint _tmp13_ = 0;
			GdkPixbuf* _tmp28_ = NULL;
			gboolean _tmp29_ = FALSE;
			gboolean* _tmp30_ = NULL;
			_tmp3_ = path;
			_tmp4_ = width;
			_tmp5_ = height;
			_tmp6_ = gdk_pixbuf_new_from_file_at_size (_tmp3_, _tmp4_, _tmp5_, &_inner_error_);
			_tmp2_ = _tmp6_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch7_g_error;
			}
			_tmp7_ = _tmp2_;
			_tmp2_ = NULL;
			_g_object_unref0 (pixbuf);
			pixbuf = _tmp7_;
			_tmp8_ = pixbuf;
			_tmp9_ = path;
			_tmp10_ = g_strdup (_tmp9_);
			g_object_set_data_full ((GObject*) _tmp8_, DRT_RICH_TEXT_BUFFER_IMAGE_PATH, _tmp10_, g_free);
			_tmp13_ = height;
			if (_tmp13_ != -1) {
				_tmp12_ = TRUE;
			} else {
				gint _tmp14_ = 0;
				_tmp14_ = width;
				_tmp12_ = _tmp14_ != -1;
			}
			if (_tmp12_) {
				const gchar* _tmp15_ = NULL;
				gint _tmp16_ = 0;
				gint _tmp17_ = 0;
				GdkPixbufFormat* _tmp18_ = NULL;
				_tmp15_ = path;
				_tmp18_ = gdk_pixbuf_get_file_info (_tmp15_, &_tmp16_, &_tmp17_);
				real_width = _tmp16_;
				real_height = _tmp17_;
				_tmp11_ = _tmp18_ != NULL;
			} else {
				_tmp11_ = FALSE;
			}
			if (_tmp11_) {
				gboolean _tmp19_ = FALSE;
				gboolean _tmp20_ = FALSE;
				gint _tmp21_ = 0;
				_tmp21_ = height;
				if (_tmp21_ == -1) {
					_tmp20_ = TRUE;
				} else {
					gint _tmp22_ = 0;
					gint _tmp23_ = 0;
					_tmp22_ = height;
					_tmp23_ = real_height;
					_tmp20_ = _tmp22_ == _tmp23_;
				}
				if (_tmp20_) {
					gboolean _tmp24_ = FALSE;
					gint _tmp25_ = 0;
					_tmp25_ = width;
					if (_tmp25_ == -1) {
						_tmp24_ = TRUE;
					} else {
						gint _tmp26_ = 0;
						gint _tmp27_ = 0;
						_tmp26_ = width;
						_tmp27_ = real_width;
						_tmp24_ = _tmp26_ == _tmp27_;
					}
					_tmp19_ = _tmp24_;
				} else {
					_tmp19_ = FALSE;
				}
				real_size = _tmp19_;
			}
			_tmp28_ = pixbuf;
			_tmp29_ = real_size;
			_tmp30_ = __bool_dup0 (&_tmp29_);
			g_object_set_data_full ((GObject*) _tmp28_, "has_real_size", _tmp30_, g_free);
			_g_object_unref0 (_tmp2_);
		}
		goto __finally7;
		__catch7_g_error:
		{
			GError* e = NULL;
			GdkPixbuf* _tmp31_ = NULL;
			const gchar* _tmp32_ = NULL;
			GError* _tmp33_ = NULL;
			const gchar* _tmp34_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp31_ = drt_rich_text_buffer_get_missing_image_pixbuf (self);
			_g_object_unref0 (pixbuf);
			pixbuf = _tmp31_;
			_tmp32_ = path;
			_tmp33_ = e;
			_tmp34_ = _tmp33_->message;
			g_warning ("RichTextBuffer.vala:683: Unable to load image %s: %s", _tmp32_, _tmp34_);
			_g_error_free0 (e);
		}
		__finally7:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (pixbuf);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp35_ = pixbuf;
	drt_rich_text_buffer_insert_pixbuf_at_cursor (self, _tmp35_);
	_g_object_unref0 (pixbuf);
}


/**
 * Inserts pixbuf at cursor
 * 
 * @param pixbuf    pixbuf to insert
 */
void drt_rich_text_buffer_insert_pixbuf_at_cursor (DrtRichTextBuffer* self, GdkPixbuf* pixbuf) {
	GtkTextIter iter = {0};
	GtkTextMark* _tmp0_ = NULL;
	GtkTextIter _tmp1_ = {0};
	GtkTextIter _tmp2_ = {0};
	GdkPixbuf* _tmp3_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (pixbuf != NULL);
	_tmp0_ = gtk_text_buffer_get_insert ((GtkTextBuffer*) self);
	gtk_text_buffer_get_iter_at_mark ((GtkTextBuffer*) self, &_tmp1_, _tmp0_);
	iter = _tmp1_;
	_tmp2_ = iter;
	_tmp3_ = pixbuf;
	gtk_text_buffer_insert_pixbuf ((GtkTextBuffer*) self, &_tmp2_, _tmp3_);
}


GdkRGBA* drt_rich_text_buffer_get_link_color (DrtRichTextBuffer* self) {
	GdkRGBA* result;
	GdkRGBA* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_link_color;
	result = _tmp0_;
	return result;
}


static GdkRGBA* _gdk_rgba_dup (GdkRGBA* self) {
	GdkRGBA* dup;
	dup = g_new0 (GdkRGBA, 1);
	memcpy (dup, self, sizeof (GdkRGBA));
	return dup;
}


static gpointer __gdk_rgba_dup0 (gpointer self) {
	return self ? _gdk_rgba_dup (self) : NULL;
}


static void _drt_rich_text_buffer_find_link_and_set_color_gtk_text_tag_table_foreach (GtkTextTag* tag, gpointer self) {
	drt_rich_text_buffer_find_link_and_set_color ((DrtRichTextBuffer*) self, tag);
}


void drt_rich_text_buffer_set_link_color (DrtRichTextBuffer* self, GdkRGBA* value) {
	GdkRGBA* _tmp0_ = NULL;
	GdkRGBA* _tmp1_ = NULL;
	GdkRGBA* _tmp2_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = __gdk_rgba_dup0 (_tmp0_);
	_g_free0 (self->priv->_link_color);
	self->priv->_link_color = _tmp1_;
	_tmp2_ = self->priv->_link_color;
	if (_tmp2_ != NULL) {
		GtkTextTagTable* _tmp3_ = NULL;
		GtkTextTagTable* _tmp4_ = NULL;
		_tmp3_ = gtk_text_buffer_get_tag_table ((GtkTextBuffer*) self);
		_tmp4_ = _tmp3_;
		gtk_text_tag_table_foreach (_tmp4_, _drt_rich_text_buffer_find_link_and_set_color_gtk_text_tag_table_foreach, self);
	}
}


DrtImageLocator drt_rich_text_buffer_get_image_locator (DrtRichTextBuffer* self, gpointer* result_target) {
	DrtImageLocator result;
	DrtImageLocator _tmp0_ = NULL;
	void* _tmp0__target = NULL;
	DrtImageLocator _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_image_locator;
	_tmp0__target = self->priv->_image_locator_target;
	_tmp1_ = _tmp0_;
	_tmp1__target = _tmp0__target;
	*result_target = _tmp1__target;
	result = _tmp1_;
	return result;
}


void drt_rich_text_buffer_set_image_locator (DrtRichTextBuffer* self, DrtImageLocator value, gpointer value_target, GDestroyNotify value_target_destroy_notify) {
	DrtImageLocator _tmp0_ = NULL;
	void* _tmp0__target = NULL;
	GDestroyNotify _tmp0__target_destroy_notify = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp0__target = value_target;
	_tmp0__target_destroy_notify = value_target_destroy_notify;
	value = NULL;
	value_target = NULL;
	value_target_destroy_notify = NULL;
	(self->priv->_image_locator_target_destroy_notify == NULL) ? NULL : (self->priv->_image_locator_target_destroy_notify (self->priv->_image_locator_target), NULL);
	self->priv->_image_locator = NULL;
	self->priv->_image_locator_target = NULL;
	self->priv->_image_locator_target_destroy_notify = NULL;
	self->priv->_image_locator = _tmp0_;
	self->priv->_image_locator_target = _tmp0__target;
	self->priv->_image_locator_target_destroy_notify = _tmp0__target_destroy_notify;
	(value_target_destroy_notify == NULL) ? NULL : (value_target_destroy_notify (value_target), NULL);
	value = NULL;
	value_target = NULL;
	value_target_destroy_notify = NULL;
}


static void drt_rich_text_buffer_real_image_requested (DrtRichTextBuffer* self, const gchar* uri, gint width, gint height) {
	DrtImageLocator _tmp0_ = NULL;
	void* _tmp0__target = NULL;
	DrtImageLocator _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	g_return_if_fail (uri != NULL);
	_tmp0_ = drt_rich_text_buffer_get_image_locator (self, &_tmp0__target);
	_tmp1_ = _tmp0_;
	_tmp1__target = _tmp0__target;
	if (_tmp1_ != NULL) {
		DrtImageLocator _tmp2_ = NULL;
		void* _tmp2__target = NULL;
		DrtImageLocator _tmp3_ = NULL;
		void* _tmp3__target = NULL;
		const gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		_tmp2_ = drt_rich_text_buffer_get_image_locator (self, &_tmp2__target);
		_tmp3_ = _tmp2_;
		_tmp3__target = _tmp2__target;
		_tmp4_ = uri;
		_tmp5_ = _tmp3_ (_tmp4_, _tmp3__target);
		_tmp6_ = _tmp5_;
		_tmp7_ = width;
		_tmp8_ = height;
		drt_rich_text_buffer_insert_image_at_cursor (self, _tmp6_, _tmp7_, _tmp8_);
		_g_free0 (_tmp6_);
	}
}


static void g_cclosure_user_marshal_VOID__STRING_INT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_INT_INT) (gpointer data1, const char* arg_1, gint arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__STRING_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_INT_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), data2);
}


static void g_cclosure_user_marshal_VOID__STRING_BOXED_INT_BOXED_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_BOXED_INT_BOXED_INT) (gpointer data1, const char* arg_1, gpointer arg_2, gint arg_3, gpointer arg_4, gint arg_5, gpointer data2);
	register GMarshalFunc_VOID__STRING_BOXED_INT_BOXED_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 6);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_BOXED_INT_BOXED_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_boxed (param_values + 2), g_value_get_int (param_values + 3), g_value_get_boxed (param_values + 4), g_value_get_int (param_values + 5), data2);
}


static gchar* _drt_rich_text_buffer_default_image_locator_drt_image_locator (const gchar* uri, gpointer self) {
	gchar* result;
	result = drt_rich_text_buffer_default_image_locator ((DrtRichTextBuffer*) self, uri);
	return result;
}


static GObject * drt_rich_text_buffer_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	DrtRichTextBuffer * self;
	GtkTextTag* _tmp5_ = NULL;
	GtkTextTag* _tmp6_ = NULL;
	GtkTextTag* _tmp7_ = NULL;
	GtkTextTag* _tmp8_ = NULL;
	GtkTextTag* _tmp9_ = NULL;
	GtkTextTag* _tmp10_ = NULL;
	GtkTextTag* _tmp11_ = NULL;
	GtkTextTag* _tmp12_ = NULL;
	GtkTextTag* _tmp13_ = NULL;
	GtkTextTag* _tmp14_ = NULL;
	GtkTextTag* _tmp15_ = NULL;
	GError * _inner_error_ = NULL;
	parent_class = G_OBJECT_CLASS (drt_rich_text_buffer_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_RICH_TEXT_BUFFER, DrtRichTextBuffer);
	{
		GRegex* _tmp0_ = NULL;
		GRegex* _tmp1_ = NULL;
		GRegex* _tmp2_ = NULL;
		_tmp1_ = g_regex_new ("(\n|\\s)+", 0, 0, &_inner_error_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch8_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_regex_unref0 (self->priv->strip_spaces);
		self->priv->strip_spaces = _tmp2_;
		_g_regex_unref0 (_tmp0_);
	}
	goto __finally8;
	__catch8_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_error ("RichTextBuffer.vala:196: Failed to compile strip space regex: %s", _tmp4_);
		_g_error_free0 (e);
	}
	__finally8:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	_tmp5_ = gtk_text_buffer_create_tag ((GtkTextBuffer*) self, DRT_RICH_TEXT_BUFFER_TEXT_TAG_BOLD, "weight", PANGO_WEIGHT_BOLD, NULL);
	self->priv->tag_bold = _tmp5_;
	_tmp6_ = gtk_text_buffer_create_tag ((GtkTextBuffer*) self, DRT_RICH_TEXT_BUFFER_TEXT_TAG_ITALIC, "style", PANGO_STYLE_ITALIC, NULL);
	self->priv->tag_italic = _tmp6_;
	_tmp7_ = gtk_text_buffer_create_tag ((GtkTextBuffer*) self, DRT_RICH_TEXT_BUFFER_TEXT_TAG_HEADING1, "scale", PANGO_SCALE_XX_LARGE, "weight", PANGO_WEIGHT_HEAVY, NULL);
	self->priv->tag_h1 = _tmp7_;
	_tmp8_ = gtk_text_buffer_create_tag ((GtkTextBuffer*) self, DRT_RICH_TEXT_BUFFER_TEXT_TAG_HEADING2, "scale", PANGO_SCALE_X_LARGE, "weight", PANGO_WEIGHT_BOLD, NULL);
	self->priv->tag_h2 = _tmp8_;
	_tmp9_ = gtk_text_buffer_create_tag ((GtkTextBuffer*) self, DRT_RICH_TEXT_BUFFER_TEXT_TAG_HEADING3, "scale", PANGO_SCALE_LARGE, "weight", PANGO_WEIGHT_BOLD, NULL);
	self->priv->tag_h3 = _tmp9_;
	_tmp10_ = gtk_text_buffer_create_tag ((GtkTextBuffer*) self, DRT_RICH_TEXT_BUFFER_TEXT_TAG_PARAGRAPH, NULL);
	self->priv->tag_para = _tmp10_;
	_tmp11_ = gtk_text_buffer_create_tag ((GtkTextBuffer*) self, DRT_RICH_TEXT_BUFFER_TEXT_TAG_DEFINITION_LIST, NULL);
	self->priv->tag_dl = _tmp11_;
	_tmp12_ = gtk_text_buffer_create_tag ((GtkTextBuffer*) self, DRT_RICH_TEXT_BUFFER_TEXT_TAG_DEFINED_TERM, "weight", PANGO_WEIGHT_BOLD, NULL);
	self->priv->tag_dt = _tmp12_;
	_tmp13_ = gtk_text_buffer_create_tag ((GtkTextBuffer*) self, DRT_RICH_TEXT_BUFFER_TEXT_TAG_DEFINITION, "left-margin", 50, NULL);
	self->priv->tag_dd = _tmp13_;
	_tmp14_ = gtk_text_buffer_create_tag ((GtkTextBuffer*) self, DRT_RICH_TEXT_BUFFER_TEXT_TAG_UNORDERED_LIST, NULL);
	self->priv->tag_ul = _tmp14_;
	_tmp15_ = gtk_text_buffer_create_tag ((GtkTextBuffer*) self, DRT_RICH_TEXT_BUFFER_TEXT_TAG_LIST_ITEM, "left-margin", 13, "indent", -13, NULL);
	self->priv->tag_li = _tmp15_;
	drt_rich_text_buffer_set_image_locator (self, _drt_rich_text_buffer_default_image_locator_drt_image_locator, g_object_ref (self), g_object_unref);
	return obj;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static DrtRichTextBufferTag* drt_rich_text_buffer_tag_new (const gchar* name, GtkTextMark* mark, GtkTextTag* tag) {
	DrtRichTextBufferTag* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GtkTextMark* _tmp2_ = NULL;
	GtkTextMark* _tmp3_ = NULL;
	GtkTextTag* _tmp4_ = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (mark != NULL, NULL);
	g_return_val_if_fail (tag != NULL, NULL);
	self = g_slice_new0 (DrtRichTextBufferTag);
	drt_rich_text_buffer_tag_instance_init (self);
	_tmp0_ = name;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->name);
	self->name = _tmp1_;
	_tmp2_ = mark;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (self->mark);
	self->mark = _tmp3_;
	_tmp4_ = tag;
	self->tag = _tmp4_;
	return self;
}


static void drt_rich_text_buffer_tag_instance_init (DrtRichTextBufferTag * self) {
}


static void drt_rich_text_buffer_tag_free (DrtRichTextBufferTag* self) {
	_g_free0 (self->name);
	_g_object_unref0 (self->mark);
	g_slice_free (DrtRichTextBufferTag, self);
}


static void drt_rich_text_buffer_class_init (DrtRichTextBufferClass * klass) {
	drt_rich_text_buffer_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DrtRichTextBufferPrivate));
	((DrtRichTextBufferClass *) klass)->image_requested = drt_rich_text_buffer_real_image_requested;
	G_OBJECT_CLASS (klass)->get_property = _vala_drt_rich_text_buffer_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_drt_rich_text_buffer_set_property;
	G_OBJECT_CLASS (klass)->constructor = drt_rich_text_buffer_constructor;
	G_OBJECT_CLASS (klass)->finalize = drt_rich_text_buffer_finalize;
	/**
	 * Emitted when image is about to be inserted.
	 * 
	 * The default handler inserts image with path retrieved by image_locator.
	 * 
	 * @param uri       image uri
	 * @param width     image width
	 * @param height    image height
	 */
	g_signal_new ("image_requested", DRT_TYPE_RICH_TEXT_BUFFER, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DrtRichTextBufferClass, image_requested), NULL, NULL, g_cclosure_user_marshal_VOID__STRING_INT_INT, G_TYPE_NONE, 3, G_TYPE_STRING, G_TYPE_INT, G_TYPE_INT);
	/**
	 * Emitted when an unknown in-line tag is opened. You can use provided
	 * information to create custom Gtk.TextTag and add it to tag stack via
	 * append_tag_to_stack().
	 * 
	 * @param name           tag name
	 * @param attr_names     names of attributes
	 * @param attr_values    values of attributes
	 */
	g_signal_new ("unknown_tag_opened", DRT_TYPE_RICH_TEXT_BUFFER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_BOXED_INT_BOXED_INT, G_TYPE_NONE, 5, G_TYPE_STRING, G_TYPE_STRV, G_TYPE_INT, G_TYPE_STRV, G_TYPE_INT);
	/**
	 * Emitted when an unknown in-line tag is closed. You can use provided
	 * information to close custom Gtk.TextTag via close_tag_from_stack().
	 * 
	 * @param name    tag name
	 */
	g_signal_new ("unknown_tag_closed", DRT_TYPE_RICH_TEXT_BUFFER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
}


static void drt_rich_text_buffer_instance_init (DrtRichTextBuffer * self) {
	GQueue* _tmp0_ = NULL;
	self->priv = DRT_RICH_TEXT_BUFFER_GET_PRIVATE (self);
	self->priv->_link_color = NULL;
	self->priv->insert_new_line = FALSE;
	self->priv->strip_left = FALSE;
	self->priv->in_paragraph = FALSE;
	self->priv->ignore_text = FALSE;
	_tmp0_ = g_queue_new ();
	self->priv->tag_stack = _tmp0_;
}


static void drt_rich_text_buffer_finalize (GObject* obj) {
	DrtRichTextBuffer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_RICH_TEXT_BUFFER, DrtRichTextBuffer);
	_g_free0 (self->priv->_link_color);
	(self->priv->_image_locator_target_destroy_notify == NULL) ? NULL : (self->priv->_image_locator_target_destroy_notify (self->priv->_image_locator_target), NULL);
	self->priv->_image_locator = NULL;
	self->priv->_image_locator_target = NULL;
	self->priv->_image_locator_target_destroy_notify = NULL;
	_g_regex_unref0 (self->priv->strip_spaces);
	__g_queue_free__drt_rich_text_buffer_tag_free0_0 (self->priv->tag_stack);
	G_OBJECT_CLASS (drt_rich_text_buffer_parent_class)->finalize (obj);
}


/**
 * Rich Text Buffer is used to load a XML-like document with
 * a limited formating.
 * 
 * Simple Document buffer supports a very very limited subset of HTML, you should
 * use WebKitGtk to render HTML documents. Supported tags are:
 * 
 * * <h1>, <h2>, <h3> - headings
 * * <p> - a paragraph
 * * <br /> - line break
 * * <b> - bold text
 * * <strong> - alias for <b>
 * * <i> - italic text
 * * <em> - alias for <i>
 * * <a href="uri"> - a link
 * * <dl> - a definition list
 * * <dt> - the defined term (must be inside <dl>)
 * * <dd> - definition (must be inside <dl>)
 * * <img src="uri" width="" height="" /> - an image
 * * <ul> - unordered list (bullets)
 * * <li> - list item
 * 
 * Tag <a> is inserted as anonymous Drt.SimpleDocLink, <img> is inserted as Gtk.Pixbuf.
 * Other tags are inserted as Gtk.TextTags with names TEXT_TAG_*.
 */
GType drt_rich_text_buffer_get_type (void) {
	static volatile gsize drt_rich_text_buffer_type_id__volatile = 0;
	if (g_once_init_enter (&drt_rich_text_buffer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DrtRichTextBufferClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_rich_text_buffer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtRichTextBuffer), 0, (GInstanceInitFunc) drt_rich_text_buffer_instance_init, NULL };
		GType drt_rich_text_buffer_type_id;
		drt_rich_text_buffer_type_id = g_type_register_static (gtk_text_buffer_get_type (), "DrtRichTextBuffer", &g_define_type_info, 0);
		g_once_init_leave (&drt_rich_text_buffer_type_id__volatile, drt_rich_text_buffer_type_id);
	}
	return drt_rich_text_buffer_type_id__volatile;
}


static void _vala_drt_rich_text_buffer_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DrtRichTextBuffer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRT_TYPE_RICH_TEXT_BUFFER, DrtRichTextBuffer);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_drt_rich_text_buffer_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DrtRichTextBuffer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRT_TYPE_RICH_TEXT_BUFFER, DrtRichTextBuffer);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


/**
 * Creates new link text tag.
 * 
 * @param uri    Target URI of the link
 */
DrtRichTextLink* drt_rich_text_link_construct (GType object_type, const gchar* uri) {
	DrtRichTextLink * self = NULL;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (uri != NULL, NULL);
	_tmp0_ = uri;
	self = (DrtRichTextLink*) g_object_new (object_type, "underline", PANGO_UNDERLINE_SINGLE, "uri", _tmp0_, NULL);
	return self;
}


DrtRichTextLink* drt_rich_text_link_new (const gchar* uri) {
	return drt_rich_text_link_construct (DRT_TYPE_RICH_TEXT_LINK, uri);
}


const gchar* drt_rich_text_link_get_uri (DrtRichTextLink* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_uri;
	result = _tmp0_;
	return result;
}


void drt_rich_text_link_set_uri (DrtRichTextLink* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_uri);
	self->priv->_uri = _tmp1_;
	g_object_notify ((GObject *) self, "uri");
}


static void drt_rich_text_link_class_init (DrtRichTextLinkClass * klass) {
	drt_rich_text_link_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DrtRichTextLinkPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_drt_rich_text_link_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_drt_rich_text_link_set_property;
	G_OBJECT_CLASS (klass)->finalize = drt_rich_text_link_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_RICH_TEXT_LINK_URI, g_param_spec_string ("uri", "Link uri", "Target URI of the link.", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void drt_rich_text_link_instance_init (DrtRichTextLink * self) {
	self->priv = DRT_RICH_TEXT_LINK_GET_PRIVATE (self);
}


static void drt_rich_text_link_finalize (GObject* obj) {
	DrtRichTextLink * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_RICH_TEXT_LINK, DrtRichTextLink);
	_g_free0 (self->priv->_uri);
	G_OBJECT_CLASS (drt_rich_text_link_parent_class)->finalize (obj);
}


/**
 * A text tag for links that holds link's URI.
 */
GType drt_rich_text_link_get_type (void) {
	static volatile gsize drt_rich_text_link_type_id__volatile = 0;
	if (g_once_init_enter (&drt_rich_text_link_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DrtRichTextLinkClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_rich_text_link_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtRichTextLink), 0, (GInstanceInitFunc) drt_rich_text_link_instance_init, NULL };
		GType drt_rich_text_link_type_id;
		drt_rich_text_link_type_id = g_type_register_static (gtk_text_tag_get_type (), "DrtRichTextLink", &g_define_type_info, 0);
		g_once_init_leave (&drt_rich_text_link_type_id__volatile, drt_rich_text_link_type_id);
	}
	return drt_rich_text_link_type_id__volatile;
}


static void _vala_drt_rich_text_link_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DrtRichTextLink * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRT_TYPE_RICH_TEXT_LINK, DrtRichTextLink);
	switch (property_id) {
		case DRT_RICH_TEXT_LINK_URI:
		g_value_set_string (value, drt_rich_text_link_get_uri (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_drt_rich_text_link_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DrtRichTextLink * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRT_TYPE_RICH_TEXT_LINK, DrtRichTextLink);
	switch (property_id) {
		case DRT_RICH_TEXT_LINK_URI:
		drt_rich_text_link_set_uri (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



