/* Serialize.c generated by valac 0.34.9, the Vala compiler
 * generated from Serialize.vala, do not modify */

/*
 * Copyright 2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);



#define DRT_SERIALIZE_ALIGN ((guint) 8)
gboolean drt_serialize_variant (GVariant* variant, guint8* buffer, int buffer_length1, guint offset);
guint8* drt_serialize_message (const gchar* name, GVariant* parameters, guint offset, int* result_length1);
GVariant* drt_deserialize_variant (const gchar* type_sig, guint8* buffer, int buffer_length1, guint offset, gboolean trusted);
gboolean drt_deserialize_message (guint8* buffer, int buffer_length1, gchar** name, GVariant** parameters, guint offset);
GVariant* drt_serialize_error (GError* e);
GError* drt_deserialize_error (GVariant* e);


/**
 * Serializes Variant to byte array at given offset.
 * 
 * @param variant    variant value to store
 * @param buffer     byte array to store variant at, must be large enough (see Varian.get_size())
 * @param offset     starting offset to store value at, must be aligned to 8 bytes
 * @return true on success, false if requirements haven't been met
 */
gboolean drt_serialize_variant (GVariant* variant, guint8* buffer, int buffer_length1, guint offset) {
	gboolean result = FALSE;
	guint8* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	guint _tmp1_ = 0U;
	GVariant* _tmp2_ = NULL;
	gsize _tmp3_ = 0UL;
	guint _tmp4_ = 0U;
	guint8* p = NULL;
	guint8* _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	guint _tmp6_ = 0U;
	GVariant* _tmp7_ = NULL;
	g_return_val_if_fail (variant != NULL, FALSE);
	_tmp0_ = buffer;
	_tmp0__length1 = buffer_length1;
	_tmp1_ = offset;
	_tmp2_ = variant;
	_tmp3_ = g_variant_get_size (_tmp2_);
	g_return_val_if_fail (((gsize) (_tmp0__length1 - _tmp1_)) >= _tmp3_, FALSE);
	_tmp4_ = offset;
	g_return_val_if_fail ((_tmp4_ % DRT_SERIALIZE_ALIGN) == ((guint) 0), FALSE);
	_tmp5_ = buffer;
	_tmp5__length1 = buffer_length1;
	_tmp6_ = offset;
	p = ((guint8*) _tmp5_) + _tmp6_;
	_tmp7_ = variant;
	g_variant_store (_tmp7_, p);
	result = TRUE;
	return result;
}


/**
 * Serializes message to byte array at given offset.
 * 
 * @param name      message name
 * @param parameters    message parameters
 * @param offset    starting offset to store data at, use for your own data (e.g. format signature)
 * @return byte array with serialized message
 */
guint8* drt_serialize_message (const gchar* name, GVariant* parameters, guint offset, int* result_length1) {
	guint8* result = NULL;
	const gchar* _tmp0_ = NULL;
	GVariant* _tmp1_ = NULL;
	gchar* type_str = NULL;
	gchar* _tmp4_ = NULL;
	guint variant_offset = 0U;
	guint _tmp5_ = 0U;
	const gchar* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	const gchar* _tmp9_ = NULL;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	guint _tmp12_ = 0U;
	gsize _tmp15_ = 0UL;
	GVariant* _tmp16_ = NULL;
	guint32 buffer_size = 0U;
	guint _tmp19_ = 0U;
	guint8* buffer = NULL;
	guint32 _tmp20_ = 0U;
	guint8* _tmp21_ = NULL;
	gint buffer_length1 = 0;
	gint _buffer_size_ = 0;
	guint8* p = NULL;
	guint8* _tmp22_ = NULL;
	gint _tmp22__length1 = 0;
	guint size = 0U;
	const gchar* _tmp23_ = NULL;
	gint _tmp24_ = 0;
	gint _tmp25_ = 0;
	guint8* _tmp26_ = NULL;
	guint _tmp27_ = 0U;
	const gchar* _tmp28_ = NULL;
	guint _tmp29_ = 0U;
	guint _tmp30_ = 0U;
	guint _tmp31_ = 0U;
	const gchar* _tmp32_ = NULL;
	gint _tmp33_ = 0;
	gint _tmp34_ = 0;
	guint8* _tmp35_ = NULL;
	guint _tmp36_ = 0U;
	const gchar* _tmp37_ = NULL;
	guint _tmp38_ = 0U;
	guint _tmp39_ = 0U;
	guint _tmp40_ = 0U;
	GVariant* _tmp41_ = NULL;
	guint8* _tmp46_ = NULL;
	gint _tmp46__length1 = 0;
	g_return_val_if_fail (name != NULL, NULL);
	_tmp1_ = parameters;
	if (_tmp1_ != NULL) {
		GVariant* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		_tmp2_ = parameters;
		_tmp3_ = g_variant_get_type_string (_tmp2_);
		_tmp0_ = _tmp3_;
	} else {
		_tmp0_ = "";
	}
	_tmp4_ = g_strdup (_tmp0_);
	type_str = _tmp4_;
	_tmp5_ = offset;
	_tmp6_ = name;
	_tmp7_ = strlen (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = type_str;
	_tmp10_ = strlen (_tmp9_);
	_tmp11_ = _tmp10_;
	variant_offset = (guint) ((((_tmp5_ + _tmp8_) + 1) + _tmp11_) + 1);
	_tmp12_ = variant_offset;
	if ((_tmp12_ % DRT_SERIALIZE_ALIGN) != ((guint) 0)) {
		guint _tmp13_ = 0U;
		guint _tmp14_ = 0U;
		_tmp13_ = variant_offset;
		_tmp14_ = variant_offset;
		variant_offset = _tmp13_ + (DRT_SERIALIZE_ALIGN - (_tmp14_ % DRT_SERIALIZE_ALIGN));
	}
	_tmp16_ = parameters;
	if (_tmp16_ != NULL) {
		GVariant* _tmp17_ = NULL;
		gsize _tmp18_ = 0UL;
		_tmp17_ = parameters;
		_tmp18_ = g_variant_get_size (_tmp17_);
		_tmp15_ = _tmp18_;
	} else {
		_tmp15_ = (gsize) 0;
	}
	_tmp19_ = variant_offset;
	buffer_size = (guint32) (_tmp19_ + _tmp15_);
	_tmp20_ = buffer_size;
	_tmp21_ = g_new0 (guint8, _tmp20_);
	buffer = _tmp21_;
	buffer_length1 = _tmp20_;
	_buffer_size_ = buffer_length1;
	_tmp22_ = buffer;
	_tmp22__length1 = buffer_length1;
	p = _tmp22_;
	_tmp23_ = name;
	_tmp24_ = strlen (_tmp23_);
	_tmp25_ = _tmp24_;
	size = (guint) (_tmp25_ + 1);
	_tmp26_ = p;
	_tmp27_ = offset;
	_tmp28_ = name;
	_tmp29_ = size;
	memcpy (_tmp26_ + _tmp27_, (void*) _tmp28_, (gsize) _tmp29_);
	_tmp30_ = offset;
	_tmp31_ = size;
	offset = _tmp30_ + _tmp31_;
	_tmp32_ = type_str;
	_tmp33_ = strlen (_tmp32_);
	_tmp34_ = _tmp33_;
	size = (guint) (_tmp34_ + 1);
	_tmp35_ = p;
	_tmp36_ = offset;
	_tmp37_ = type_str;
	_tmp38_ = size;
	memcpy (_tmp35_ + _tmp36_, (void*) _tmp37_, (gsize) _tmp38_);
	_tmp39_ = offset;
	_tmp40_ = size;
	offset = _tmp39_ + _tmp40_;
	_tmp41_ = parameters;
	if (_tmp41_ != NULL) {
		GVariant* _tmp42_ = NULL;
		guint8* _tmp43_ = NULL;
		gint _tmp43__length1 = 0;
		guint _tmp44_ = 0U;
		gboolean _tmp45_ = FALSE;
		_tmp42_ = parameters;
		_tmp43_ = buffer;
		_tmp43__length1 = buffer_length1;
		_tmp44_ = variant_offset;
		_tmp45_ = drt_serialize_variant (_tmp42_, _tmp43_, _tmp43__length1, _tmp44_);
		_vala_assert (_tmp45_, "serialize_variant(parameters, buffer, variant_offset)");
	}
	_tmp46_ = buffer;
	_tmp46__length1 = buffer_length1;
	if (result_length1) {
		*result_length1 = _tmp46__length1;
	}
	result = _tmp46_;
	_g_free0 (type_str);
	return result;
}


/**
 * Deserializes Variant from byte array at given offset.
 * 
 * @param type_sig    valid variant type signature
 * @param buffer      byte array read data from. array will be freed asynchronously, see Variant.new_from_data
 * @param offset      starting offset to read data from, must be aligned to 8 bytes
 * @param trusted     whether data comes from trusted source
 * @return Variant on success, null if requirements haven't been met
 */
GVariant* drt_deserialize_variant (const gchar* type_sig, guint8* buffer, int buffer_length1, guint offset, gboolean trusted) {
	GVariant* result = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	guint _tmp2_ = 0U;
	guint8* real_data = NULL;
	guint8* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	guint _tmp4_ = 0U;
	gint real_data_length1 = 0;
	gint _real_data_size_ = 0;
	guint8* _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	guint _tmp6_ = 0U;
	gint _tmp7_ = 0;
	GVariantType* type = NULL;
	const gchar* _tmp8_ = NULL;
	GVariantType* _tmp9_ = NULL;
	GVariant* variant = NULL;
	gboolean _tmp10_ = FALSE;
	guint8* _tmp11_ = NULL;
	gint _tmp11__length1 = 0;
	GVariant* _tmp12_ = NULL;
	g_return_val_if_fail (type_sig != NULL, NULL);
	_tmp0_ = type_sig;
	_tmp1_ = g_variant_type_string_is_valid (_tmp0_);
	g_return_val_if_fail (_tmp1_, NULL);
	_tmp2_ = offset;
	g_return_val_if_fail ((_tmp2_ % DRT_SERIALIZE_ALIGN) == ((guint) 0), NULL);
	_tmp3_ = buffer;
	_tmp3__length1 = buffer_length1;
	_tmp4_ = offset;
	real_data = (guint8*) (((guint8*) _tmp3_) + _tmp4_);
	real_data_length1 = -1;
	_real_data_size_ = real_data_length1;
	_tmp5_ = buffer;
	_tmp5__length1 = buffer_length1;
	_tmp6_ = offset;
	real_data_length1 = (gint) (_tmp5__length1 - _tmp6_);
	_tmp7_ = real_data_length1;
	_tmp8_ = type_sig;
	_tmp9_ = g_variant_type_new (_tmp8_);
	type = _tmp9_;
	_tmp10_ = trusted;
	_tmp11_ = buffer;
	_tmp11__length1 = buffer_length1;
	buffer = NULL;
	buffer_length1 = 0;
	_tmp12_ = g_variant_new_from_data (type, real_data, real_data_length1, _tmp10_, g_free, _tmp11_);
	variant = _tmp12_;
	result = variant;
	_g_variant_type_free0 (type);
	buffer = (g_free (buffer), NULL);
	return result;
}


/**
 * Deserializes message from byte array at given offset.
 * 
 * @param buffer    byte array to read data from, array will be freed asynchronously, see Variant.new_from_data
 * @param name      message name
 * @param parameters    message parameters
 * @param offset    starting offset to store data at, use for your own data (e.g. format signature)
 * @return true on success, false on failure (i. e. invalid data)
 */
gboolean drt_deserialize_message (guint8* buffer, int buffer_length1, gchar** name, GVariant** parameters, guint offset) {
	gchar* _vala_name = NULL;
	GVariant* _vala_parameters = NULL;
	gboolean result = FALSE;
	guint32 limit = 0U;
	guint8* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	guint _tmp1_ = 0U;
	guint8* p = NULL;
	guint8* _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	guint _tmp3_ = 0U;
	guint8* index = NULL;
	guint8* _tmp4_ = NULL;
	guint32 _tmp5_ = 0U;
	void* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	guint8* _tmp8_ = NULL;
	guint size = 0U;
	guint8* _tmp11_ = NULL;
	guint8* _tmp12_ = NULL;
	gchar* tmp_name = NULL;
	guint8* _tmp13_ = NULL;
	guint _tmp14_ = 0U;
	void* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	guint _tmp17_ = 0U;
	guint _tmp18_ = 0U;
	guint8* _tmp19_ = NULL;
	guint _tmp20_ = 0U;
	guint32 _tmp21_ = 0U;
	guint _tmp22_ = 0U;
	guint8* _tmp23_ = NULL;
	guint32 _tmp24_ = 0U;
	void* _tmp25_ = NULL;
	gboolean _tmp26_ = FALSE;
	guint8* _tmp27_ = NULL;
	guint8* _tmp30_ = NULL;
	guint8* _tmp31_ = NULL;
	gchar* type_str = NULL;
	guint8* _tmp32_ = NULL;
	guint _tmp33_ = 0U;
	void* _tmp34_ = NULL;
	gchar* _tmp35_ = NULL;
	guint _tmp36_ = 0U;
	guint _tmp37_ = 0U;
	guint _tmp38_ = 0U;
	const gchar* _tmp41_ = NULL;
	gchar* _tmp47_ = NULL;
	_g_free0 (_vala_name);
	_vala_name = NULL;
	_g_variant_unref0 (_vala_parameters);
	_vala_parameters = NULL;
	_tmp0_ = buffer;
	_tmp0__length1 = buffer_length1;
	_tmp1_ = offset;
	limit = (guint32) (_tmp0__length1 - _tmp1_);
	_tmp2_ = buffer;
	_tmp2__length1 = buffer_length1;
	_tmp3_ = offset;
	p = ((guint8*) _tmp2_) + _tmp3_;
	_tmp4_ = p;
	_tmp5_ = limit;
	_tmp6_ = memchr (_tmp4_, 0, (gsize) _tmp5_);
	index = _tmp6_;
	_tmp8_ = index;
	if (_tmp8_ != NULL) {
		guint8* _tmp9_ = NULL;
		guint8* _tmp10_ = NULL;
		_tmp9_ = index;
		_tmp10_ = p;
		_tmp7_ = (_tmp9_ - _tmp10_) > ((gsize) 0);
	} else {
		_tmp7_ = FALSE;
	}
	g_return_val_if_fail (_tmp7_, FALSE);
	_tmp11_ = index;
	_tmp12_ = p;
	size = (guint) ((_tmp11_ - _tmp12_) + 1);
	_tmp13_ = p;
	_tmp14_ = size;
	_tmp15_ = g_memdup (_tmp13_, _tmp14_);
	_tmp16_ = g_strdup ((const gchar*) _tmp15_);
	tmp_name = _tmp16_;
	_tmp17_ = offset;
	_tmp18_ = size;
	offset = _tmp17_ + _tmp18_;
	_tmp19_ = p;
	_tmp20_ = size;
	p = _tmp19_ + _tmp20_;
	_tmp21_ = limit;
	_tmp22_ = size;
	limit = _tmp21_ - _tmp22_;
	_tmp23_ = p;
	_tmp24_ = limit;
	_tmp25_ = memchr (_tmp23_, 0, (gsize) _tmp24_);
	index = _tmp25_;
	_tmp27_ = index;
	if (_tmp27_ != NULL) {
		guint8* _tmp28_ = NULL;
		guint8* _tmp29_ = NULL;
		_tmp28_ = index;
		_tmp29_ = p;
		_tmp26_ = (_tmp28_ - _tmp29_) >= ((gsize) 0);
	} else {
		_tmp26_ = FALSE;
	}
	g_return_val_if_fail (_tmp26_, FALSE);
	_tmp30_ = index;
	_tmp31_ = p;
	size = (guint) ((_tmp30_ - _tmp31_) + 1);
	_tmp32_ = p;
	_tmp33_ = size;
	_tmp34_ = g_memdup (_tmp32_, _tmp33_);
	_tmp35_ = g_strdup ((const gchar*) _tmp34_);
	type_str = _tmp35_;
	_tmp36_ = offset;
	_tmp37_ = size;
	offset = _tmp36_ + _tmp37_;
	_tmp38_ = offset;
	if ((_tmp38_ % DRT_SERIALIZE_ALIGN) != ((guint) 0)) {
		guint _tmp39_ = 0U;
		guint _tmp40_ = 0U;
		_tmp39_ = offset;
		_tmp40_ = offset;
		offset = _tmp39_ + (DRT_SERIALIZE_ALIGN - (_tmp40_ % DRT_SERIALIZE_ALIGN));
	}
	_tmp41_ = type_str;
	if (g_strcmp0 (_tmp41_, "") != 0) {
		const gchar* _tmp42_ = NULL;
		guint8* _tmp43_ = NULL;
		gint _tmp43__length1 = 0;
		guint _tmp44_ = 0U;
		GVariant* _tmp45_ = NULL;
		GVariant* _tmp46_ = NULL;
		_tmp42_ = type_str;
		_tmp43_ = buffer;
		_tmp43__length1 = buffer_length1;
		buffer = NULL;
		buffer_length1 = 0;
		_tmp44_ = offset;
		_tmp45_ = drt_deserialize_variant (_tmp42_, _tmp43_, _tmp43__length1, _tmp44_, FALSE);
		_g_variant_unref0 (_vala_parameters);
		_vala_parameters = _tmp45_;
		_tmp46_ = _vala_parameters;
		g_return_val_if_fail (_tmp46_ != NULL, FALSE);
	}
	_tmp47_ = tmp_name;
	tmp_name = NULL;
	_g_free0 (_vala_name);
	_vala_name = _tmp47_;
	result = TRUE;
	_g_free0 (type_str);
	_g_free0 (tmp_name);
	buffer = (g_free (buffer), NULL);
	if (name) {
		*name = _vala_name;
	} else {
		_g_free0 (_vala_name);
	}
	if (parameters) {
		*parameters = _vala_parameters;
	} else {
		_g_variant_unref0 (_vala_parameters);
	}
	return result;
}


GVariant* drt_serialize_error (GError* e) {
	GVariant* result = NULL;
	GError* _tmp0_ = NULL;
	GQuark _tmp1_ = 0U;
	const gchar* _tmp2_ = NULL;
	GError* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	GError* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	GVariant* _tmp7_ = NULL;
	_tmp0_ = e;
	_tmp1_ = _tmp0_->domain;
	_tmp2_ = g_quark_to_string (_tmp1_);
	_tmp3_ = e;
	_tmp4_ = _tmp3_->code;
	_tmp5_ = e;
	_tmp6_ = _tmp5_->message;
	_tmp7_ = g_variant_new ("(sis)", _tmp2_, _tmp4_, _tmp6_, NULL);
	g_variant_ref_sink (_tmp7_);
	result = _tmp7_;
	return result;
}


GError* drt_deserialize_error (GVariant* e) {
	GError* result = NULL;
	gchar* domain = NULL;
	gint code = 0;
	gchar* message = NULL;
	GVariant* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GQuark _tmp2_ = 0U;
	gint _tmp3_ = 0;
	const gchar* _tmp4_ = NULL;
	GError* _tmp5_ = NULL;
	g_return_val_if_fail (e != NULL, NULL);
	domain = NULL;
	code = 0;
	message = NULL;
	_tmp0_ = e;
	g_variant_get (_tmp0_, "(sis)", &domain, &code, &message, NULL);
	_tmp1_ = domain;
	_tmp2_ = g_quark_from_string (_tmp1_);
	_tmp3_ = code;
	_tmp4_ = message;
	_tmp5_ = g_error_new (_tmp2_, _tmp3_, "%s", _tmp4_);
	result = _tmp5_;
	_g_free0 (message);
	_g_free0 (domain);
	return result;
}



