/* Value.c generated by valac 0.34.9, the Vala compiler
 * generated from Value.vala, do not modify */

/*
 * Copyright 2015 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

#define _g_free0(var) (var = (g_free (var), NULL))



gchar* drt_value_to_string (GValue* value);
gchar* drt_blobs_bytes_to_string (GBytes* value);
gchar* drt_blobs_byte_array_to_string (GByteArray* value);
gboolean drt_value_equal (GValue* value1, GValue* value2);
gboolean drt_blobs_bytes_equal (GBytes* value1, GBytes* value2);
gboolean drt_blobs_byte_array_equal (GByteArray* value1, GByteArray* value2);
gchar* drt_value_describe (GValue* value);
gboolean drt_value_equal_verbose (GValue* value1, GValue* value2, gchar** description);


/**
 * Supported types: GLib.Object, GLib.Bytes, GLib.ByteArray, int, uint, int64, uint64, float, double and bool.
 */
static gchar* bool_to_string (gboolean self) {
	gchar* result = NULL;
	if (self) {
		gchar* _tmp0_ = NULL;
		_tmp0_ = g_strdup ("true");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_ = NULL;
		_tmp1_ = g_strdup ("false");
		result = _tmp1_;
		return result;
	}
}


static gchar* double_to_string (gdouble self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
	_tmp2_ = g_ascii_dtostr (_tmp1_, G_ASCII_DTOSTR_BUF_SIZE, self);
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	result = _tmp4_;
	return result;
}


gchar* drt_value_to_string (GValue* value) {
	gchar* result = NULL;
	GValue* _tmp0_ = NULL;
	GType type = 0UL;
	GValue* _tmp1_ = NULL;
	GType _tmp2_ = 0UL;
	GType _tmp3_ = 0UL;
	gboolean _tmp4_ = FALSE;
	GType _tmp8_ = 0UL;
	GType _tmp12_ = 0UL;
	GType _tmp16_ = 0UL;
	GType _tmp20_ = 0UL;
	GType _tmp24_ = 0UL;
	GType _tmp28_ = 0UL;
	GType _tmp32_ = 0UL;
	GType _tmp36_ = 0UL;
	GType _tmp40_ = 0UL;
	GType _tmp44_ = 0UL;
	GType _tmp48_ = 0UL;
	gboolean _tmp49_ = FALSE;
	GType _tmp53_ = 0UL;
	gboolean _tmp54_ = FALSE;
	_tmp0_ = value;
	if (_tmp0_ == NULL) {
		result = NULL;
		return result;
	}
	_tmp1_ = value;
	_tmp2_ = G_VALUE_TYPE (_tmp1_);
	type = _tmp2_;
	_tmp3_ = type;
	_tmp4_ = G_TYPE_IS_OBJECT (_tmp3_);
	if (_tmp4_) {
		GValue* _tmp5_ = NULL;
		GObject* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		_tmp5_ = value;
		_tmp6_ = g_value_get_object (_tmp5_);
		_tmp7_ = g_strdup_printf ("%p", (void*) _tmp6_);
		result = _tmp7_;
		return result;
	}
	_tmp8_ = type;
	if (_tmp8_ == G_TYPE_INT) {
		GValue* _tmp9_ = NULL;
		gint _tmp10_ = 0;
		gchar* _tmp11_ = NULL;
		_tmp9_ = value;
		_tmp10_ = g_value_get_int (_tmp9_);
		_tmp11_ = g_strdup_printf ("%i", _tmp10_);
		result = _tmp11_;
		return result;
	}
	_tmp12_ = type;
	if (_tmp12_ == G_TYPE_UINT) {
		GValue* _tmp13_ = NULL;
		guint _tmp14_ = 0U;
		gchar* _tmp15_ = NULL;
		_tmp13_ = value;
		_tmp14_ = g_value_get_uint (_tmp13_);
		_tmp15_ = g_strdup_printf ("%u", _tmp14_);
		result = _tmp15_;
		return result;
	}
	_tmp16_ = type;
	if (_tmp16_ == G_TYPE_INT64) {
		GValue* _tmp17_ = NULL;
		gint64 _tmp18_ = 0LL;
		gchar* _tmp19_ = NULL;
		_tmp17_ = value;
		_tmp18_ = g_value_get_int64 (_tmp17_);
		_tmp19_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp18_);
		result = _tmp19_;
		return result;
	}
	_tmp20_ = type;
	if (_tmp20_ == G_TYPE_UINT64) {
		GValue* _tmp21_ = NULL;
		guint64 _tmp22_ = 0ULL;
		gchar* _tmp23_ = NULL;
		_tmp21_ = value;
		_tmp22_ = g_value_get_uint64 (_tmp21_);
		_tmp23_ = g_strdup_printf ("%" G_GUINT64_FORMAT, _tmp22_);
		result = _tmp23_;
		return result;
	}
	_tmp24_ = type;
	if (_tmp24_ == G_TYPE_STRING) {
		GValue* _tmp25_ = NULL;
		const gchar* _tmp26_ = NULL;
		gchar* _tmp27_ = NULL;
		_tmp25_ = value;
		_tmp26_ = g_value_get_string (_tmp25_);
		_tmp27_ = g_strdup (_tmp26_);
		result = _tmp27_;
		return result;
	}
	_tmp28_ = type;
	if (_tmp28_ == G_TYPE_BOOLEAN) {
		GValue* _tmp29_ = NULL;
		gboolean _tmp30_ = FALSE;
		gchar* _tmp31_ = NULL;
		_tmp29_ = value;
		_tmp30_ = g_value_get_boolean (_tmp29_);
		_tmp31_ = bool_to_string (_tmp30_);
		result = _tmp31_;
		return result;
	}
	_tmp32_ = type;
	if (_tmp32_ == G_TYPE_DOUBLE) {
		GValue* _tmp33_ = NULL;
		gdouble _tmp34_ = 0.0;
		gchar* _tmp35_ = NULL;
		_tmp33_ = value;
		_tmp34_ = g_value_get_double (_tmp33_);
		_tmp35_ = double_to_string (_tmp34_);
		result = _tmp35_;
		return result;
	}
	_tmp36_ = type;
	if (_tmp36_ == G_TYPE_FLOAT) {
		GValue* _tmp37_ = NULL;
		gfloat _tmp38_ = 0.0F;
		gchar* _tmp39_ = NULL;
		_tmp37_ = value;
		_tmp38_ = g_value_get_float (_tmp37_);
		_tmp39_ = g_strdup_printf ("%g", _tmp38_);
		result = _tmp39_;
		return result;
	}
	_tmp40_ = type;
	if (_tmp40_ == G_TYPE_BYTES) {
		GValue* _tmp41_ = NULL;
		void* _tmp42_ = NULL;
		gchar* _tmp43_ = NULL;
		_tmp41_ = value;
		_tmp42_ = g_value_get_boxed (_tmp41_);
		_tmp43_ = drt_blobs_bytes_to_string ((GBytes*) _tmp42_);
		result = _tmp43_;
		return result;
	}
	_tmp44_ = type;
	if (_tmp44_ == G_TYPE_BYTE_ARRAY) {
		GValue* _tmp45_ = NULL;
		void* _tmp46_ = NULL;
		gchar* _tmp47_ = NULL;
		_tmp45_ = value;
		_tmp46_ = g_value_get_boxed (_tmp45_);
		_tmp47_ = drt_blobs_byte_array_to_string ((GByteArray*) _tmp46_);
		result = _tmp47_;
		return result;
	}
	_tmp48_ = type;
	_tmp49_ = g_type_is_a (_tmp48_, G_TYPE_BOXED);
	if (_tmp49_) {
		GValue* _tmp50_ = NULL;
		void* _tmp51_ = NULL;
		gchar* _tmp52_ = NULL;
		_tmp50_ = value;
		_tmp51_ = g_value_get_boxed (_tmp50_);
		_tmp52_ = g_strdup_printf ("%p", (void*) _tmp51_);
		result = _tmp52_;
		return result;
	}
	_tmp53_ = type;
	_tmp54_ = G_TYPE_IS_CLASSED (_tmp53_);
	if (_tmp54_) {
		GValue* _tmp55_ = NULL;
		void* _tmp56_ = NULL;
		gchar* _tmp57_ = NULL;
		_tmp55_ = value;
		_tmp56_ = g_value_peek_pointer (_tmp55_);
		_tmp57_ = g_strdup_printf ("%p", (void*) _tmp56_);
		result = _tmp57_;
		return result;
	}
	result = NULL;
	return result;
}


/**
 * Supported types: GLib.Object, GLib.Bytes, GLib.ByteArray, int, uint, int64, uint64, float, double and bool.
 */
gboolean drt_value_equal (GValue* value1, GValue* value2) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GValue* _tmp1_ = NULL;
	gboolean _tmp3_ = FALSE;
	GValue* _tmp4_ = NULL;
	GType type = 0UL;
	GValue* _tmp6_ = NULL;
	GType _tmp7_ = 0UL;
	GType _tmp8_ = 0UL;
	GValue* _tmp9_ = NULL;
	GType _tmp10_ = 0UL;
	GType _tmp11_ = 0UL;
	GType _tmp16_ = 0UL;
	GType _tmp21_ = 0UL;
	GType _tmp26_ = 0UL;
	GType _tmp31_ = 0UL;
	GType _tmp36_ = 0UL;
	GType _tmp41_ = 0UL;
	GType _tmp46_ = 0UL;
	GType _tmp51_ = 0UL;
	gboolean _tmp52_ = FALSE;
	GType _tmp57_ = 0UL;
	GType _tmp63_ = 0UL;
	GType _tmp69_ = 0UL;
	gboolean _tmp70_ = FALSE;
	_tmp1_ = value1;
	if (_tmp1_ == NULL) {
		GValue* _tmp2_ = NULL;
		_tmp2_ = value2;
		_tmp0_ = _tmp2_ == NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = TRUE;
		return result;
	}
	_tmp4_ = value1;
	if (_tmp4_ != NULL) {
		GValue* _tmp5_ = NULL;
		_tmp5_ = value2;
		_tmp3_ = _tmp5_ != NULL;
	} else {
		_tmp3_ = FALSE;
	}
	if (!_tmp3_) {
		result = FALSE;
		return result;
	}
	_tmp6_ = value1;
	_tmp7_ = G_VALUE_TYPE (_tmp6_);
	type = _tmp7_;
	_tmp8_ = type;
	_tmp9_ = value2;
	_tmp10_ = G_VALUE_TYPE (_tmp9_);
	if (_tmp8_ != _tmp10_) {
		result = FALSE;
		return result;
	}
	_tmp11_ = type;
	if (_tmp11_ == G_TYPE_BOOLEAN) {
		GValue* _tmp12_ = NULL;
		gboolean _tmp13_ = FALSE;
		GValue* _tmp14_ = NULL;
		gboolean _tmp15_ = FALSE;
		_tmp12_ = value1;
		_tmp13_ = g_value_get_boolean (_tmp12_);
		_tmp14_ = value2;
		_tmp15_ = g_value_get_boolean (_tmp14_);
		result = _tmp13_ == _tmp15_;
		return result;
	}
	_tmp16_ = type;
	if (_tmp16_ == G_TYPE_INT) {
		GValue* _tmp17_ = NULL;
		gint _tmp18_ = 0;
		GValue* _tmp19_ = NULL;
		gint _tmp20_ = 0;
		_tmp17_ = value1;
		_tmp18_ = g_value_get_int (_tmp17_);
		_tmp19_ = value2;
		_tmp20_ = g_value_get_int (_tmp19_);
		result = _tmp18_ == _tmp20_;
		return result;
	}
	_tmp21_ = type;
	if (_tmp21_ == G_TYPE_UINT) {
		GValue* _tmp22_ = NULL;
		guint _tmp23_ = 0U;
		GValue* _tmp24_ = NULL;
		guint _tmp25_ = 0U;
		_tmp22_ = value1;
		_tmp23_ = g_value_get_uint (_tmp22_);
		_tmp24_ = value2;
		_tmp25_ = g_value_get_uint (_tmp24_);
		result = _tmp23_ == _tmp25_;
		return result;
	}
	_tmp26_ = type;
	if (_tmp26_ == G_TYPE_INT64) {
		GValue* _tmp27_ = NULL;
		gint64 _tmp28_ = 0LL;
		GValue* _tmp29_ = NULL;
		gint64 _tmp30_ = 0LL;
		_tmp27_ = value1;
		_tmp28_ = g_value_get_int64 (_tmp27_);
		_tmp29_ = value2;
		_tmp30_ = g_value_get_int64 (_tmp29_);
		result = _tmp28_ == _tmp30_;
		return result;
	}
	_tmp31_ = type;
	if (_tmp31_ == G_TYPE_UINT64) {
		GValue* _tmp32_ = NULL;
		guint64 _tmp33_ = 0ULL;
		GValue* _tmp34_ = NULL;
		guint64 _tmp35_ = 0ULL;
		_tmp32_ = value1;
		_tmp33_ = g_value_get_uint64 (_tmp32_);
		_tmp34_ = value2;
		_tmp35_ = g_value_get_uint64 (_tmp34_);
		result = _tmp33_ == _tmp35_;
		return result;
	}
	_tmp36_ = type;
	if (_tmp36_ == G_TYPE_STRING) {
		GValue* _tmp37_ = NULL;
		const gchar* _tmp38_ = NULL;
		GValue* _tmp39_ = NULL;
		const gchar* _tmp40_ = NULL;
		_tmp37_ = value1;
		_tmp38_ = g_value_get_string (_tmp37_);
		_tmp39_ = value2;
		_tmp40_ = g_value_get_string (_tmp39_);
		result = g_strcmp0 (_tmp38_, _tmp40_) == 0;
		return result;
	}
	_tmp41_ = type;
	if (_tmp41_ == G_TYPE_DOUBLE) {
		GValue* _tmp42_ = NULL;
		gdouble _tmp43_ = 0.0;
		GValue* _tmp44_ = NULL;
		gdouble _tmp45_ = 0.0;
		_tmp42_ = value1;
		_tmp43_ = g_value_get_double (_tmp42_);
		_tmp44_ = value2;
		_tmp45_ = g_value_get_double (_tmp44_);
		result = _tmp43_ == _tmp45_;
		return result;
	}
	_tmp46_ = type;
	if (_tmp46_ == G_TYPE_FLOAT) {
		GValue* _tmp47_ = NULL;
		gfloat _tmp48_ = 0.0F;
		GValue* _tmp49_ = NULL;
		gfloat _tmp50_ = 0.0F;
		_tmp47_ = value1;
		_tmp48_ = g_value_get_float (_tmp47_);
		_tmp49_ = value2;
		_tmp50_ = g_value_get_float (_tmp49_);
		result = _tmp48_ == _tmp50_;
		return result;
	}
	_tmp51_ = type;
	_tmp52_ = G_TYPE_IS_OBJECT (_tmp51_);
	if (_tmp52_) {
		GValue* _tmp53_ = NULL;
		GObject* _tmp54_ = NULL;
		GValue* _tmp55_ = NULL;
		GObject* _tmp56_ = NULL;
		_tmp53_ = value1;
		_tmp54_ = g_value_get_object (_tmp53_);
		_tmp55_ = value2;
		_tmp56_ = g_value_get_object (_tmp55_);
		result = _tmp54_ == _tmp56_;
		return result;
	}
	_tmp57_ = type;
	if (_tmp57_ == G_TYPE_BYTES) {
		GValue* _tmp58_ = NULL;
		void* _tmp59_ = NULL;
		GValue* _tmp60_ = NULL;
		void* _tmp61_ = NULL;
		gboolean _tmp62_ = FALSE;
		_tmp58_ = value1;
		_tmp59_ = g_value_get_boxed (_tmp58_);
		_tmp60_ = value2;
		_tmp61_ = g_value_get_boxed (_tmp60_);
		_tmp62_ = drt_blobs_bytes_equal ((GBytes*) _tmp59_, (GBytes*) _tmp61_);
		result = _tmp62_;
		return result;
	}
	_tmp63_ = type;
	if (_tmp63_ == G_TYPE_BYTE_ARRAY) {
		GValue* _tmp64_ = NULL;
		void* _tmp65_ = NULL;
		GValue* _tmp66_ = NULL;
		void* _tmp67_ = NULL;
		gboolean _tmp68_ = FALSE;
		_tmp64_ = value1;
		_tmp65_ = g_value_get_boxed (_tmp64_);
		_tmp66_ = value2;
		_tmp67_ = g_value_get_boxed (_tmp66_);
		_tmp68_ = drt_blobs_byte_array_equal ((GByteArray*) _tmp65_, (GByteArray*) _tmp67_);
		result = _tmp68_;
		return result;
	}
	_tmp69_ = type;
	_tmp70_ = g_type_is_a (_tmp69_, G_TYPE_BOXED);
	if (_tmp70_) {
		GValue* _tmp71_ = NULL;
		void* _tmp72_ = NULL;
		GValue* _tmp73_ = NULL;
		void* _tmp74_ = NULL;
		_tmp71_ = value1;
		_tmp72_ = g_value_get_boxed (_tmp71_);
		_tmp73_ = value2;
		_tmp74_ = g_value_get_boxed (_tmp73_);
		result = _tmp72_ == _tmp74_;
		return result;
	}
	g_return_val_if_reached (FALSE);
}


/**
 * Supported types: GLib.Object, GLib.Bytes, GLib.ByteArray, int, uint, int64, uint64, float, double and bool.
 */
gchar* drt_value_describe (GValue* value) {
	gchar* result = NULL;
	GValue* _tmp0_ = NULL;
	GType type = 0UL;
	GValue* _tmp2_ = NULL;
	GType _tmp3_ = 0UL;
	gchar* content = NULL;
	GValue* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	GType _tmp11_ = 0UL;
	const gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	_tmp0_ = value;
	if (_tmp0_ == NULL) {
		gchar* _tmp1_ = NULL;
		_tmp1_ = g_strdup ("<null>");
		result = _tmp1_;
		return result;
	}
	_tmp2_ = value;
	_tmp3_ = G_VALUE_TYPE (_tmp2_);
	type = _tmp3_;
	_tmp4_ = value;
	_tmp5_ = drt_value_to_string (_tmp4_);
	content = _tmp5_;
	_tmp6_ = content;
	if (_tmp6_ != NULL) {
		GType _tmp7_ = 0UL;
		const gchar* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		_tmp7_ = type;
		_tmp8_ = g_type_name (_tmp7_);
		_tmp9_ = content;
		_tmp10_ = g_strdup_printf ("<%s:%s>", _tmp8_, _tmp9_);
		result = _tmp10_;
		_g_free0 (content);
		return result;
	}
	_tmp11_ = type;
	_tmp12_ = g_type_name (_tmp11_);
	_tmp13_ = g_strdup_printf ("<%s>", _tmp12_);
	result = _tmp13_;
	_g_free0 (content);
	return result;
}


/**
 * Supported types: GLib.Object, GLib.Bytes, GLib.ByteArray, int, uint, int64, uint64, float, double and bool.
 */
gboolean drt_value_equal_verbose (GValue* value1, GValue* value2, gchar** description) {
	gchar* _vala_description = NULL;
	gboolean result = FALSE;
	gboolean _result_ = FALSE;
	GValue* _tmp0_ = NULL;
	GValue* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	_tmp0_ = value1;
	_tmp1_ = value2;
	_tmp2_ = drt_value_equal (_tmp0_, _tmp1_);
	_result_ = _tmp2_;
	_tmp3_ = _result_;
	if (_tmp3_) {
		GValue* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		_tmp4_ = value1;
		_tmp5_ = drt_value_describe (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_strdup_printf ("equal %s", _tmp6_);
		_g_free0 (_vala_description);
		_vala_description = _tmp7_;
		_g_free0 (_tmp6_);
	} else {
		GValue* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		GValue* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		_tmp8_ = value1;
		_tmp9_ = drt_value_describe (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = value2;
		_tmp12_ = drt_value_describe (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = g_strdup_printf ("%s != %s", _tmp10_, _tmp13_);
		_g_free0 (_vala_description);
		_vala_description = _tmp14_;
		_g_free0 (_tmp13_);
		_g_free0 (_tmp10_);
	}
	result = _result_;
	if (description) {
		*description = _vala_description;
	} else {
		_g_free0 (_vala_description);
	}
	return result;
}



