/* io.c generated by valac 0.34.9, the Vala compiler
 * generated from io.vala, do not modify */

/*
 * Copyright 2014-2016 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <unistd.h>
#include <gio/gunixsocketaddress.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	DRT_IO_ERROR_CONN_FAILED,
	DRT_IO_ERROR_TIMEOUT,
	DRT_IO_ERROR_RW_FAILED,
	DRT_IO_ERROR_READ,
	DRT_IO_ERROR_WRITE,
	DRT_IO_ERROR_TOO_MANY_DATA,
	DRT_IO_ERROR_NOT_CONNECTED,
	DRT_IO_ERROR_OP_FAILED
} DrtIOError;
#define DRT_IO_ERROR drt_io_error_quark ()


GQuark drt_io_error_quark (void);
GSocketService* drt_create_socket_service (const gchar* path, GError** error);
GSocketConnection* drt_create_socket_connection (const gchar* path, GCancellable* cancellable, GError** error);


GSocketService* drt_create_socket_service (const gchar* path, GError** error) {
	GSocketService* result = NULL;
	const gchar* _tmp0_ = NULL;
	GUnixSocketAddress* address = NULL;
	const gchar* _tmp1_ = NULL;
	GUnixSocketAddress* _tmp2_ = NULL;
	GSocketService* service = NULL;
	GSocketService* _tmp3_ = NULL;
	GSocketAddress* effective_address = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = path;
	unlink (_tmp0_);
	_tmp1_ = path;
	_tmp2_ = (GUnixSocketAddress*) g_unix_socket_address_new (_tmp1_);
	address = _tmp2_;
	_tmp3_ = g_socket_service_new ();
	service = _tmp3_;
	{
		GSocketService* _tmp4_ = NULL;
		GUnixSocketAddress* _tmp5_ = NULL;
		GSocketAddress* _tmp6_ = NULL;
		_tmp4_ = service;
		_tmp5_ = address;
		g_socket_listener_add_address ((GSocketListener*) _tmp4_, (GSocketAddress*) _tmp5_, G_SOCKET_TYPE_STREAM, G_SOCKET_PROTOCOL_DEFAULT, NULL, &_tmp6_, &_inner_error_);
		_g_object_unref0 (effective_address);
		effective_address = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch65_g_error;
		}
	}
	goto __finally65;
	__catch65_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp7_ = NULL;
		GError* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		GError* _tmp10_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp7_ = path;
		_tmp8_ = e;
		_tmp9_ = _tmp8_->message;
		_tmp10_ = g_error_new (DRT_IO_ERROR, DRT_IO_ERROR_CONN_FAILED, "Failed to add socket '%s'. %s", _tmp7_, _tmp9_);
		_inner_error_ = _tmp10_;
		_g_error_free0 (e);
		goto __finally65;
	}
	__finally65:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRT_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (effective_address);
			_g_object_unref0 (service);
			_g_object_unref0 (address);
			return NULL;
		} else {
			_g_object_unref0 (effective_address);
			_g_object_unref0 (service);
			_g_object_unref0 (address);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	result = service;
	_g_object_unref0 (effective_address);
	_g_object_unref0 (address);
	return result;
}


GSocketConnection* drt_create_socket_connection (const gchar* path, GCancellable* cancellable, GError** error) {
	GSocketConnection* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (path != NULL, NULL);
	{
		GUnixSocketAddress* address = NULL;
		const gchar* _tmp0_ = NULL;
		GUnixSocketAddress* _tmp1_ = NULL;
		GSocket* socket = NULL;
		GSocket* _tmp2_ = NULL;
		GSocketConnection* connection = NULL;
		GSocket* _tmp3_ = NULL;
		GSocketConnection* _tmp4_ = NULL;
		GSocketConnection* _tmp5_ = NULL;
		GUnixSocketAddress* _tmp6_ = NULL;
		GCancellable* _tmp7_ = NULL;
		_tmp0_ = path;
		_tmp1_ = (GUnixSocketAddress*) g_unix_socket_address_new (_tmp0_);
		address = _tmp1_;
		_tmp2_ = g_socket_new (G_SOCKET_FAMILY_UNIX, G_SOCKET_TYPE_STREAM, G_SOCKET_PROTOCOL_DEFAULT, &_inner_error_);
		socket = _tmp2_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (address);
			goto __catch66_g_error;
		}
		_tmp3_ = socket;
		_tmp4_ = g_socket_connection_factory_create_connection (_tmp3_);
		connection = _tmp4_;
		_tmp5_ = connection;
		_tmp6_ = address;
		_tmp7_ = cancellable;
		g_socket_connection_connect (_tmp5_, (GSocketAddress*) _tmp6_, _tmp7_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (connection);
			_g_object_unref0 (socket);
			_g_object_unref0 (address);
			goto __catch66_g_error;
		}
		result = connection;
		_g_object_unref0 (socket);
		_g_object_unref0 (address);
		return result;
	}
	goto __finally66;
	__catch66_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp8_ = NULL;
		GError* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		GError* _tmp11_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp8_ = path;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		_tmp11_ = g_error_new (DRT_IO_ERROR, DRT_IO_ERROR_CONN_FAILED, "Failed to connect to socket '%s'. %s", _tmp8_, _tmp10_);
		_inner_error_ = _tmp11_;
		_g_error_free0 (e);
		goto __finally66;
	}
	__finally66:
	if (_inner_error_->domain == DRT_IO_ERROR) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	} else {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}



