/* main.c generated by valac 0.34.9, the Vala compiler
 * generated from main.vala, do not modify */

/*
 * Copyright 2015-2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <sqlite3.h>
#include <gio/gio.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	DRTDB_DATABASE_ERROR_UNKNOWN,
	DRTDB_DATABASE_ERROR_IOERROR,
	DRTDB_DATABASE_ERROR_DATABASE_NOT_OPENED,
	DRTDB_DATABASE_ERROR_GENERAL,
	DRTDB_DATABASE_ERROR_RANGE,
	DRTDB_DATABASE_ERROR_DATA_TYPE,
	DRTDB_DATABASE_ERROR_NAME,
	DRTDB_DATABASE_ERROR_MISMATCH,
	DRTDB_DATABASE_ERROR_MISUSE,
	DRTDB_DATABASE_ERROR_DOES_NOT_EXIST,
	DRTDB_DATABASE_ERROR_TOO_MANY_RESULTS
} DrtdbDatabaseError;
#define DRTDB_DATABASE_ERROR drtdb_database_error_quark ()


GQuark drtdb_database_error_quark (void);
gboolean drtdb_is_type_supported (GType* type);
static gboolean _g_type_equal (const GType* s1, const GType* s2);
GParamSpec** drtdb_create_param_spec_list (GObjectClass* class_spec, gchar** properties, int properties_length1, int* result_length1, GError** error);
GError* drtdb_convert_sqlite_error (gint errno, const gchar* message, const gchar* sql, sqlite3_stmt* stm);
gboolean drtdb_is_sql_error (gint result_code);
void drtdb_throw_if_cancelled (GCancellable* cancellable, const gchar* method, const gchar* file, gint line, GError** error);
gchar* drtdb_escape_sql_id (const gchar* sql_id);


GQuark drtdb_database_error_quark (void) {
	return g_quark_from_static_string ("drtdb_database_error-quark");
}


/**
 * Check whether data type is supported
 * 
 * @param type    the type to check
 * @return `true` if the given type is supported, `false` otherwise
 */
static gboolean _g_type_equal (const GType* s1, const GType* s2) {
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	return (*s1) == (*s2);
}


gboolean drtdb_is_type_supported (GType* type) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	GType* _tmp9_ = NULL;
	_tmp9_ = type;
	if (_tmp9_ == NULL) {
		_tmp8_ = TRUE;
	} else {
		GType* _tmp10_ = NULL;
		GType _tmp11_ = 0UL;
		_tmp10_ = type;
		_tmp11_ = G_TYPE_BOOLEAN;
		_tmp8_ = _g_type_equal (_tmp10_, &_tmp11_) == TRUE;
	}
	if (_tmp8_) {
		_tmp7_ = TRUE;
	} else {
		GType* _tmp12_ = NULL;
		GType _tmp13_ = 0UL;
		_tmp12_ = type;
		_tmp13_ = G_TYPE_INT;
		_tmp7_ = _g_type_equal (_tmp12_, &_tmp13_) == TRUE;
	}
	if (_tmp7_) {
		_tmp6_ = TRUE;
	} else {
		GType* _tmp14_ = NULL;
		GType _tmp15_ = 0UL;
		_tmp14_ = type;
		_tmp15_ = G_TYPE_INT64;
		_tmp6_ = _g_type_equal (_tmp14_, &_tmp15_) == TRUE;
	}
	if (_tmp6_) {
		_tmp5_ = TRUE;
	} else {
		GType* _tmp16_ = NULL;
		GType _tmp17_ = 0UL;
		_tmp16_ = type;
		_tmp17_ = G_TYPE_STRING;
		_tmp5_ = _g_type_equal (_tmp16_, &_tmp17_) == TRUE;
	}
	if (_tmp5_) {
		_tmp4_ = TRUE;
	} else {
		GType* _tmp18_ = NULL;
		GType _tmp19_ = 0UL;
		_tmp18_ = type;
		_tmp19_ = G_TYPE_DOUBLE;
		_tmp4_ = _g_type_equal (_tmp18_, &_tmp19_) == TRUE;
	}
	if (_tmp4_) {
		_tmp3_ = TRUE;
	} else {
		GType* _tmp20_ = NULL;
		GType _tmp21_ = 0UL;
		_tmp20_ = type;
		_tmp21_ = G_TYPE_FLOAT;
		_tmp3_ = _g_type_equal (_tmp20_, &_tmp21_) == TRUE;
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		GType* _tmp22_ = NULL;
		GType _tmp23_ = 0UL;
		_tmp22_ = type;
		_tmp23_ = G_TYPE_BYTES;
		_tmp2_ = _g_type_equal (_tmp22_, &_tmp23_) == TRUE;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		GType* _tmp24_ = NULL;
		GType _tmp25_ = 0UL;
		_tmp24_ = type;
		_tmp25_ = G_TYPE_BYTE_ARRAY;
		_tmp1_ = _g_type_equal (_tmp24_, &_tmp25_) == TRUE;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		GType* _tmp26_ = NULL;
		GType _tmp27_ = 0UL;
		_tmp26_ = type;
		_tmp27_ = G_TYPE_POINTER;
		_tmp0_ = _g_type_equal (_tmp26_, &_tmp27_) == TRUE;
	}
	result = _tmp0_;
	return result;
}


/**
 * Create a list of property specifications of a given ObjectClass
 * 
 * @param class_spec    object class to retrieve property specifications from
 * @param properties    properties to retrieve specification for or `null` to use all properties
 * @return array of requested property specifications
 */
GParamSpec** drtdb_create_param_spec_list (GObjectClass* class_spec, gchar** properties, int properties_length1, int* result_length1, GError** error) {
	GParamSpec** result = NULL;
	GParamSpec** properties_list = NULL;
	gint properties_list_length1 = 0;
	gint _properties_list_size_ = 0;
	gboolean _tmp0_ = FALSE;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	GParamSpec** _tmp27_ = NULL;
	gint _tmp27__length1 = 0;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (class_spec != NULL, NULL);
	_tmp1_ = properties;
	_tmp1__length1 = properties_length1;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		gchar** _tmp2_ = NULL;
		gint _tmp2__length1 = 0;
		_tmp2_ = properties;
		_tmp2__length1 = properties_length1;
		_tmp0_ = _tmp2__length1 == 0;
	}
	if (_tmp0_) {
		GObjectClass* _tmp3_ = NULL;
		guint _tmp4_;
		GParamSpec** _tmp5_ = NULL;
		_tmp3_ = class_spec;
		_tmp5_ = g_object_class_list_properties (_tmp3_, &_tmp4_);
		properties_list = (g_free (properties_list), NULL);
		properties_list = _tmp5_;
		properties_list_length1 = _tmp4_;
		_properties_list_size_ = properties_list_length1;
	} else {
		gchar** _tmp6_ = NULL;
		gint _tmp6__length1 = 0;
		GParamSpec** _tmp7_ = NULL;
		_tmp6_ = properties;
		_tmp6__length1 = properties_length1;
		_tmp7_ = g_new0 (GParamSpec*, _tmp6__length1 + 1);
		properties_list = (g_free (properties_list), NULL);
		properties_list = _tmp7_;
		properties_list_length1 = _tmp6__length1;
		_properties_list_size_ = properties_list_length1;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp8_ = FALSE;
				_tmp8_ = TRUE;
				while (TRUE) {
					gint _tmp10_ = 0;
					gchar** _tmp11_ = NULL;
					gint _tmp11__length1 = 0;
					GParamSpec** _tmp12_ = NULL;
					gint _tmp12__length1 = 0;
					gint _tmp13_ = 0;
					GObjectClass* _tmp14_ = NULL;
					gchar** _tmp15_ = NULL;
					gint _tmp15__length1 = 0;
					gint _tmp16_ = 0;
					const gchar* _tmp17_ = NULL;
					GParamSpec* _tmp18_ = NULL;
					GParamSpec* _tmp19_ = NULL;
					GParamSpec** _tmp20_ = NULL;
					gint _tmp20__length1 = 0;
					gint _tmp21_ = 0;
					GParamSpec* _tmp22_ = NULL;
					if (!_tmp8_) {
						gint _tmp9_ = 0;
						_tmp9_ = i;
						i = _tmp9_ + 1;
					}
					_tmp8_ = FALSE;
					_tmp10_ = i;
					_tmp11_ = properties;
					_tmp11__length1 = properties_length1;
					if (!(_tmp10_ < _tmp11__length1)) {
						break;
					}
					_tmp12_ = properties_list;
					_tmp12__length1 = properties_list_length1;
					_tmp13_ = i;
					_tmp14_ = class_spec;
					_tmp15_ = properties;
					_tmp15__length1 = properties_length1;
					_tmp16_ = i;
					_tmp17_ = _tmp15_[_tmp16_];
					_tmp18_ = g_object_class_find_property (_tmp14_, _tmp17_);
					_tmp12_[_tmp13_] = _tmp18_;
					_tmp19_ = _tmp12_[_tmp13_];
					_tmp20_ = properties_list;
					_tmp20__length1 = properties_list_length1;
					_tmp21_ = i;
					_tmp22_ = _tmp20_[_tmp21_];
					if (_tmp22_ == NULL) {
						gchar** _tmp23_ = NULL;
						gint _tmp23__length1 = 0;
						gint _tmp24_ = 0;
						const gchar* _tmp25_ = NULL;
						GError* _tmp26_ = NULL;
						_tmp23_ = properties;
						_tmp23__length1 = properties_length1;
						_tmp24_ = i;
						_tmp25_ = _tmp23_[_tmp24_];
						_tmp26_ = g_error_new (DRTDB_DATABASE_ERROR, DRTDB_DATABASE_ERROR_NAME, "There is no property named '%s'.", _tmp25_);
						_inner_error_ = _tmp26_;
						if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
							g_propagate_error (error, _inner_error_);
							properties_list = (g_free (properties_list), NULL);
							return NULL;
						} else {
							properties_list = (g_free (properties_list), NULL);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return NULL;
						}
					}
				}
			}
		}
	}
	_tmp27_ = properties_list;
	_tmp27__length1 = properties_list_length1;
	if (result_length1) {
		*result_length1 = _tmp27__length1;
	}
	result = _tmp27_;
	return result;
}


/**
 * Convert SQLite error code to DatabaseError
 * 
 * SQLite error codes: [[http://www.sqlite.org/rescode.html]]
 * 
 * Parameters `message`, `sql` and `stm` are optional but add more information
 * to the resulting error message.
 * 
 * @param errno      sqlite error code
 * @param message    error message
 * @param sql        executed sql query
 * @param stm        sqlite statement
 * @return corresponding {@link DatabaseError}
 */
GError* drtdb_convert_sqlite_error (gint errno, const gchar* message, const gchar* sql, sqlite3_stmt* stm) {
	GError* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	sqlite3_stmt* _tmp3_ = NULL;
	const gchar* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	gchar* msg = NULL;
	gint _tmp8_ = 0;
	gchar* _tmp9_ = NULL;
	GError* _tmp10_ = NULL;
	_tmp1_ = message;
	_tmp0_ = _tmp1_;
	if (_tmp0_ == NULL) {
		_tmp0_ = "(unknown message)";
	}
	_tmp3_ = stm;
	if (_tmp3_ != NULL) {
		sqlite3_stmt* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		_tmp4_ = stm;
		_tmp5_ = sqlite3_sql (_tmp4_);
		_tmp2_ = _tmp5_;
	} else {
		_tmp2_ = NULL;
	}
	_tmp7_ = sql;
	_tmp6_ = _tmp7_;
	if (_tmp6_ == NULL) {
		_tmp6_ = _tmp2_;
	}
	_tmp8_ = errno;
	_tmp9_ = g_strdup_printf ("SQLite Error %d: %s. |%s|", _tmp8_, _tmp0_, _tmp6_);
	msg = _tmp9_;
	_tmp10_ = g_error_new_literal (DRTDB_DATABASE_ERROR, DRTDB_DATABASE_ERROR_GENERAL, msg);
	result = _tmp10_;
	_g_free0 (msg);
	return result;
}


/**
 * Check whether sqlite result code is an error code
 * 
 * @param result_code    sqlite result code
 * @return `true` if the code corresponds to an error, `false` otherwise
 */
inline gboolean drtdb_is_sql_error (gint result_code) {
	gboolean result = FALSE;
	gint _tmp0_ = 0;
	_tmp0_ = result_code;
	switch (_tmp0_) {
		case SQLITE_OK:
		case SQLITE_ROW:
		case SQLITE_DONE:
		{
			result = FALSE;
			return result;
		}
		default:
		{
			result = TRUE;
			return result;
		}
	}
}


/**
 * Throw {@link GLib.IOError} if an operation has been cancelled.
 * 
 * Typical usage:
 * 
 * {{{
 * throw_if_cancelled(cancellable, GLib.Log.METHOD, GLib.Log.FILE, GLib.Log.LINE);
 * }}}
 * 
 * @param cancellable    Cancellation object.
 * @param method         Called method
 * @param file           Source code file
 * @param line           Source code line
 */
void drtdb_throw_if_cancelled (GCancellable* cancellable, const gchar* method, const gchar* file, gint line, GError** error) {
	gboolean _tmp0_ = FALSE;
	GCancellable* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	_tmp1_ = cancellable;
	if (_tmp1_ != NULL) {
		GCancellable* _tmp2_ = NULL;
		gboolean _tmp3_ = FALSE;
		_tmp2_ = cancellable;
		_tmp3_ = g_cancellable_is_cancelled (_tmp2_);
		_tmp0_ = _tmp3_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		gint _tmp6_ = 0;
		GError* _tmp7_ = NULL;
		_tmp4_ = method;
		_tmp5_ = file;
		_tmp6_ = line;
		_tmp7_ = g_error_new (G_IO_ERROR, G_IO_ERROR_CANCELLED, "Operation was cancelled in %s (%s:%d).", _tmp4_, _tmp5_, _tmp6_);
		_inner_error_ = _tmp7_;
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


/**
 * Escape SQL identifier
 * 
 * @param sql_id    SQL id to escape
 * @return escaped id
 */
static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		_tmp0_ = old;
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp2_);
		regex = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch5_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp6_ = regex;
		_tmp7_ = replacement;
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) -1, 0, _tmp7_, 0, &_inner_error_);
		_tmp5_ = _tmp8_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch5_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp9_ = _tmp5_;
		_tmp5_ = NULL;
		result = _tmp9_;
		_g_free0 (_tmp5_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally5;
	__catch5_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally5:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


inline gchar* drtdb_escape_sql_id (const gchar* sql_id) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (sql_id != NULL, NULL);
	_tmp0_ = sql_id;
	_tmp1_ = string_replace (_tmp0_, "\"", "\"\"");
	result = _tmp1_;
	return result;
}



